# $Date: 1995/08/25 19:01:02 $ $Author: kg $ $Revision: 1.8 $ #
#++
Cat::EntireRing -- the category of rings

An Cat::EntireRing is a Cat::Ring with no zero divisors, ie. a <> 0 and b <> 0
implies a*b <> 0.
++#

Cat::EntireRing:= CategoryConstructor(
    Cat::EntireRing,
    [],
    [],
    NIL,
    [ Cat::Ring, Cat::RightModule(this) ],
    [ Ax::noZeroDivisors ]

)():

