# #
# $Date: 1996/07/04 15:27:37 $  $Author: frankp $   $Revision: 1.4 $ #
# #
# frankp, 7/09/95 #
# #

#++
	Cat::VectorSpace  --  the categories of vectorspaces

	VectorSpace( F )

	F: a Cat::Field

	A Cat::VectorSpace( F ) is a vectorspace over a field F.
	The scalar product has to be realized by the method
        "_mult" of the domain that belongs to this category as
        '*': (F,this) -> this and '*': (this,F) -> this.
++#

Cat::VectorSpace:= CategoryConstructor::new(

# Name = # Cat::VectorSpace,

# Args = # [ F ],

# Local Paramameters = # [ ],

# Init = # (
    if args(0) <> 1 then
	error("wrong no of args")
    end_if;
    if F::hasProp( Cat::Field ) <> TRUE then
	error("argument must be of category 'Cat::Field'")
    end_if),

# Super Categories = # [ Cat::Module( F ) ],

# Axioms  = # [ ]

):

# end of file #
