# $Date: 1997/10/10 15:55:20 $ $Author: tonner $ $Revision: 1.2 $ #

#++
_index -- get definition of entry

_index(CC, e)

CC - category constructor
e  - entry name (string)

_index returns the unevaluated definition of the entry e of CC or 
FAIL if e is not directly defined for CC.
++#

CategoryConstructor::_index:= proc(CC,e)
    option noDebug;
begin
    # search for entry in category constructor #
    if contains(extop(CC,6), e) then
	# use index_val to avoid early evaluation of entry definition #
	index_val(extop(CC,6), e)
    else
        FAIL
    end_if;
end_proc:

# end of file #
