# $Date: 1997/10/10 15:55:22 $ $Author: tonner $ $Revision: 1.6 $ #

#++
subsArgs -- substitute actual parameters of category and domain for formal
            parameters of category constructor into expression and
            evaluate it

subsArgs(e, C, this)

e    - expression to substitute actual parameters into
C    - category for which expression is to be created
this - actual domain to substitute for 'this'
++#

CategoryConstructor::subsArgs:= proc()
    option noDebug;
begin
    if extnops(args(2)) = 2 then
        eval(subs(args(1), hold(this)=args(3), Unsimplified))
    else
        eval(subs(args(1), [ hold(this)=args(3),
        	  op(zip(extop(extop(args(2),1),2),
        	  	 extop(args(2),3),
        	  	 _equal)) ],
		  Unsimplified))
    end_if
end_proc:

# end of file #
