# $Date: 1997/10/10 15:55:32 $ $Author: tonner $ $Revision: 1.15 $ #

#++
getEntry -- get entry of domain

getEntry(this,e)

this - domain
e    - name of entry

Creates domain entry e on the fly, depending on the domain 'this' and its
actual parameters. The new entry is returned (and inserted into the
domain by 'domattr').
++#

DomainConstructor::getEntry:= proc(#this,e#)
  option noDebug;
    local _0_m;
begin
    _0_m:= DomainConstructor::makeEntry(args());

    # is the entry missing by fault? #
    if _0_m[1] = hold(toBeDefined) then
        error("missing domain entry \"".args(2)."\"")
    end_if;
    
    # give method a name #
    _0_m:= _0_m[1];
    if domtype(_0_m) = DOM_PROC then
	_0_m:= subsop(_0_m, 6=hold(domattr)(args()));
    end_if;
    _0_m
end_proc:

# end of file #
