# $Date: 1997/10/10 15:55:33 $ $Author: tonner $ $Revision: 1.2 $ #

#++
_index -- get definition of entry

_index(DC, e)

DC - domain constructor
e  - entry name (string)

_index returns the unevaluated definition of the entry e of DC or 
FAIL if e is not directly defined for DC.
++#

DomainConstructor::_index:= proc(DC, e)
    option noDebug;
begin
    # search for entry in constructor #
    if contains(extop(DC,7), e) then
        # use 'index_val' to get table entries in order to avoid early
          evaluation #
        index_val(extop(DC,7), e)
    else
        FAIL
    end_if
end_proc:

# end of file #
