# $Date: 1997/10/16 10:52:37 $ $Author: olli $ $Revision: 1.6 $ #
#++
extoper -- create operation on DOM_EXT-elements

extoper(g,f1,...,fn)

g,fi - functions

extoper(g,f1,...,fn) returns the function

	(e1,...,em) -> new(D, g((f.i(extop(e.j,i) $ j=1..m) $i=1..n))

where the ei are elements of one domain D.
++#

domains::extoper:= proc(g,f)
    local a, p, i;
begin
    if args(0) < 2 then error("wrong no of args") end_if;

    a:= hold(F)(hold(_seqgen)(hold(extop)(hold(args(i)),i-1),
			      hold(hold(i)=1..args(0))))
	$ i=2..args(0);

    if g = id then
	p:= subsop(hold(fun(
			   new(extop(args(1),0), F)
		        )), [1,2]=a, Unsimplified)
    else
	p:= subsop(subsop(hold(fun(
			      new(extop(args(1),0), F)
			  )),
			  [1,2]=hold(G)(a), Unsimplified),
		    [1,2,0]=g, Unsimplified)
    end_if;

    if args(0) = 2 and g = id then
	p:= subsop(p, [1,2,0]=f, Unsimplified)
    else
	for i from 2 to args(0) do
	    p:= subsop(p, [1,2,i-1,0]=args(i), Unsimplified)
	end_for;
	p
    end_if;
    # eval(%) #
    subs(p, Simplified);
end_proc:

# end of file #
