# $Date: 1995/09/22 15:02:26 $ $Author: kg $ $Revision: 1.1 $ #
# kg, 19/09/95 #

#++
fp::fixedpt -- return fixed point of function

fp::fixedpt(f)
f - function

This is the Y combinator. Given a function f it returns the 
fixed point of f:
	Y: f +-> h(f)(h(f))
with
	h: F +-> (g +-> (x +-> F(g(g))(x)))
++#

fp::fixedpt:= fun((
    newpurefunc("fun(...)", NIL,
        subsop(hold(subsop(fun(F(f(f))(args())),
        		   [5,0,1,0]=args(),
        		   [5,0,1,1]=args())),
               [1,1,0,0]=args(1)));
    %(%)
)):

# end of file #
