
# $Date $ $Author $ $Revision: 1.1 $ #

#++ WeightedDegreeOrder(l) 

  l - list of integers or floats

  returns the monomial ordering o defined by
  o([n1,...,nk]< [m1,...,mk]) iff 
	sum(l[i]*ni,i=1..k) < sum(l[i]*mi,i=1..k) 

  
++#


groebner::WeightedDegreeOrder:=proc(l)
local a,n,f;

begin
f:=fun(bool(_plus(op(args(1), i)*op(a, i) $ hold(i) = 1..n) <
_plus(op(args(2), i) * op(a, i) $ hold(i) = 1..n)));
subsop(f,[5,1,1,1,2,2,2]=nops(l),[5,1,2,1,2,2,2]=nops(l),
[5,1,1,1,1,2,1]=l,[5,1,2,1,1,2,1]=l)
end_proc:	
