intlib::changevar := proc(i,eq,t)
local _x,xoft,u,tofx,s;
begin
   if testargs() then
      if type(i)<>"int" then error("invalid arguments") end_if;
   end_if;
   if type((_x:=op(i,2)))="_equal" then _x:=op(_x,1) end_if;
   if args(0)<3 then # try to find the new variable #
      t:=indets(eq) minus {_x};
      if nops(t)<>1 then error("please give the new variable") end_if;
      t:=op(t)
   end_if;
   assume(t,Type::RealNum);
   s:=solve(eq,_x,hold(PrincipalValue));
   if type(s)<>DOM_SET or s={} then error("cannot solve the change equation for "._x) end_if;
   xoft:=op(s,1);
   for u from 2 to nops(s) do
      if length(op(s,u))<length(xoft) then xoft:=op(s,u) end_if
   end_for;
   if type(op(i,2))="_equal" then
      tofx:=solve(eq,t,hold(PrincipalValue));
      if type(tofx)<>DOM_SET or tofx={} then
         error("cannot solve the change equation for ".t)
      end_if;
      tofx:=op(tofx,1);
      u:=t=limit(tofx,_x=op(i,[2,2,1]),Right)..limit(tofx,_x=op(i,[2,2,2]),Left)
   else u:=t
   end_if;
   # hold(int)(simplify(eval(subs(op(i,1),_x=xoft)))*diff(xoft,t),u) #
   hold(int)(simplify(subs(op(i,1),_x=xoft,Simplified))*diff(xoft,t),u)
end_proc:
