# $Date: 1997/10/10 15:55:59 $ $Author: tonner $ $Revision: 1.4 $ #
# kg, 19/09/95 #

#++
fp -- a library of functional programming utilities
++#

proc()
    option noDebug;
    local path;
begin

fp:= domain("fp"):
fp::info:= "Library 'fp': Utilities for functional programming":
fp::interface:= {
    hold(bottom),
    hold(apply),
    hold(nest),
    hold(nestvals),
    hold(fold),
    hold(curry),
    hold(fixargs),
    hold(fixedpt),
    hold(unapply)
}:

# fp::bottom -- the bottom function which never returns #
fp::bottom:= fun(error("bottom reached")):

path := pathname("FP"):

fp::apply:= loadproc(fp::apply, path, "apply"):
fp::nest:= loadproc(fp::nest, path, "nest"):
fp::nestvals:= loadproc(fp::nestvals, path, "nestvals"):
fp::fold:= loadproc(fp::fold, path, "fold"):
fp::curry:= loadproc(fp::curry, path, "curry"):
fp::fixargs:= loadproc(fp::fixargs, path, "fixargs"):
fp::fixedpt:= loadproc(fp::fixedpt, path, "fixedpt"):
fp::unapply:= loadproc(fp::unapply, path, "unapply"):

end_proc():

# end of file #
