proc()
    option noDebug;
    local dir;
begin
  linopt:=domain("linopt"):
  linopt::info:="Library 'linopt':  Linear and Integer Optimization / Programming":
  linopt::interface:={hold(maximize), hold(minimize), hold(setup),
                      hold(findMinimum), hold(feasible) }:

  dir:= pathname("LINOPT"):

linopt::maximize      := loadproc(linopt::maximize     , dir, "minimize"):
linopt::minimize      := loadproc(linopt::minimize     , dir, "minimize"):
linopt::setup         := loadproc(linopt::setup        , dir, "setup"   ):
linopt::Land_Doig     := loadproc(linopt::Land_Doig    , dir, "integer" ):
linopt::findMinimum   := loadproc(linopt::findMinimum  , dir, "findMin" ):
linopt::simplify      := loadproc(linopt::simplify     , dir, "simplify"):
linopt::linear_system := loadproc(linopt::linear_system, dir, "minimize"):
linopt::feasible      := loadproc(linopt::feasible     , dir, "feasible"):

stdlib::LoadlibState["linopt"]:= TRUE:

  null():
end_proc():

