proc()
  option noDebug;
  local dir;
begin
  stats:=domain("stats"):
  stats::info:="Library 'stats':  statistics functions":
  stats::interface:={hold(mean), hold(median), hold(variance), hold(stdev),
                     hold(normal), hold(ChiSquare), hold(linReg), hold(reg)}:

  dir:= pathname("STATS"):

stats::mean      := loadproc(stats::mean, dir, "mean"):
stats::meanTest  := loadproc(stats::meanTest, dir, "meanTest"):
stats::median    := loadproc(stats::median, dir, "median"):
stats::variance  := loadproc(stats::variance, dir, "variance"):
stats::stdev     := loadproc(stats::stdev, dir, "stdev"):
stats::normal    := loadproc(stats::normal, dir, "normal"):
stats::Tdist     := loadproc(stats::Tdist, dir, "Tdist"):
stats::ChiSquare := loadproc(stats::ChiSquare, dir, "chi"):
stats::linReg    := loadproc(stats::linReg, dir, "linreg"):
stats::reg       := loadproc(stats::reg, dir, "reg"):

stdlib::LoadlibState["stats"]:= TRUE:

  null():
end_proc():

