# #
# frankp, 7/09/95 #

#++
  student.mu

	student -- the student package
++#

proc()
    option noDebug;
    local path;
begin

student:= domain("student"):
student::info:= "Library 'student': the student package":
student::interface:= {
	hold(isFree),
	hold(equateMatrix),
	hold(genExample),
	hold(Kn),
	hold(gaussElim)
}:

loadlib("linalg"):

# #
# Library #
# #
path:= pathname("STUDENT"):

student::equateMatrix:= loadproc(student::equateMatrix,path, "equate"):
student::genExample  := loadproc(student::genExample,  path, "genExpl"):
student::Kn          := loadproc(student::Kn,          path, "Kn"):
student::gaussElim   := loadproc(student::gaussElim,   path, "gauselim"):
student::isFree	     := loadproc(student::isFree,      path, "isFree"):

stdlib::LoadlibState["student"]:= TRUE:

null()
end_proc():

# end of file #
