# #
# $Date: 1997/03/19 11:21:13 $  $Author: frankp $   $Revision: 1.2 $ #
# #
# frankp, 29/07/94 #

#++
  tr.mu

	linalg::tr(A) -- returns the trace of a square matrix

	This function uses the method "tr" of Matrix.
	See file 'Matrix.mu' for further details.
++#

linalg::tr:= proc(A)
    name linalg::tr;
begin
    if testargs() then
        if args(0) <> 1 then error("expecting 1 argument")
	elif A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("argument is not of 'Cat::MatrixCat'")
	end_if
    end_if;

    A::tr( A )
end_proc:

# end of file #
