#++
removeDupSorted does the same as removeDuplicates but it assumes that the
list is sorted and is thus faster. A notable gain will, however, only
occur, if there are comparatively few duplicates in a long list. 

Author:	 Werner M. Seiler, Uni Karlsruhe	
Created:	Mon Dec 15 12:11:04 1997
Last update:	Mon Dec 15 12:11:04 1997
++#

listtools::removeDupSorted := proc(l:DOM_LIST):DOM_LIST
local k,n;
begin
    k := 1;
    n := nops(l);
    while k<n do
	if l[k]=l[k+1] then
	    l[k] := NIL;
	    n := n-1;
	else
	    k := k+1;
	end_if;
    end_while;
    l;
end_proc:



