# #
# $Date: 1997/09/16 11:22:51 $  $Author: frankp $   $Revision: 1.2 $ #
# #
#
Authors: Eduard Niess, Werner M. Seiler, Uni Karlsruhe
Date created: May 23rd, 1996
Last update: August 10th, 1997
#

listtools::setDifference:= proc(l1,l2)
    local res,i;
begin
    if testargs() then
        if (contains([DOM_LIST,DOM_SET],domtype(l1))=0) or
           (contains([DOM_LIST,DOM_SET],domtype(l2))=0) then
            error("illegal argument types");
        end_if;
    end_if;

    if domtype(l1)=DOM_LIST then res := []
    else res := {} end_if;
    for i in l1 do
        if contains(l2,i)=0 then
            res := append(res,i);
        end_if;
    end_for;
    res;
end_proc:

# end of file #
