# #
# $Date: 1995/10/17 17:20:53 $  $Author: frankp $   $Revision: 1.2 $ #
# #

#++
	Rounds a floating-point complex number wrt eps,
  	used in newton.mu and in solvepol.mu
++#

numeric::complex_round := proc(x,eps)
begin
   if type(x)=DOM_COMPLEX then
      if abs(op(x,1)/x)<eps then I*op(x,2)
      elif abs(op(x,2)/x)<eps then op(x,1)
      else x
      end_if
   else x
   end_if
end_proc:

# end of file #
