# splits the set sys into a set of equations and a set of initial conditions #
ode::split := proc(sys,z)
local eqs,inits,eq;
begin
   eqs:=null(); inits:=null();
   for eq in sys do
      if not has(eq,z) 
      then inits:=inits,eq
      elif type(eq)="_equal" then eqs:=eqs,op(eq,1)-op(eq,2)
      else eqs:=eqs,eq
      end_if;
   end_for;
   {eqs},{inits}
end_proc:

