
#(
	Properties of Base-Types (Test-File)
)#

sysassign(
DOM_INT::NRange,
	proc()
	begin
	  if args() = 0 then
	    return(property::NRange("Zero"))
	  else
	    if phi(args()) = (args() - 1) then
	      return(property::NRange("Prime"))
	    else
	      if args() > 0 then
	        return(property::NRange("PosInt"))
	      elif args() >= 0 then
	        return(property::NRange("NonNegInt"))
	      elif args() < 0 then
	        return(property::NRange("NegInt"))
	      else
	        return(property::NRange("Integer"))
	      end_if
	    end_if
	  end_if
	end_proc
):

sysassign(
DOM_RAT::NRange,
	proc()
	begin
	  if args() > 0 then
	    return(property::NRange("PosRat"))
	  else
	    return(property::NRange("PosRat"))
	  end_if
	end_proc
):

sysassign(
DOM_FLOAT::NRange,
	proc()
	begin
	  if args() > 0.0 then
	    return(property::NRange("Positive"))
	  elif args() = 0.0 then
	    return(property::NRange("Zero"))
	  else
	    return(property::NRange("Negative"))
	  end_if
	end_proc
):

sysassign(
DOM_COMPLEX::NRange,
	proc()
	begin
	  if op(args(), 1) = 0 then
	    if domtype(op(args(), 2)) = DOM_INT then
	      return(property::NRange("IntImaginary"))
	    else
	      return(property::NRange("Imaginary"))
	    end_if
	  else
	    return(property::NRange("Complex"))
	  end_if
	end_proc
):

sysassign(
DOM_IDENT::NRange,
	proc()
	begin
	  return(property::NRange("Complex"))
	end_proc
):

sysassign(
DOM_EXPR::NRange,
	proc()
	begin
	  #case type(args())#
	  #of "sin" do#
	    #return(property::())#
	  #end_case;#
	  args()
	end_proc
):

sysassign(
DOM_INT::Divs,
	proc()
	begin
	  return(property::Divs(args()))
	end_proc
):

sysassign(
DOM_RAT::Divs,
	proc()
	begin
	  return(property::Divs(args()))
	end_proc
):

sysassign(
DOM_FLOAT::Divs,
	proc()
	begin
	  if frac(args()) = 0.0 then
	    return(property::Divs(trunc(args())))
	  else
	    return(property::Divs(args()))
	  end_if
	end_proc
):

sysassign(
DOM_COMPLEX::Divs,
	proc()
	begin
	  return(property::Divs(args()))
	end_proc
):

sysassign(
DOM_IDENT::Divs,
	proc()
	begin
	  return(property::Divs(args()))
	end_proc
):

sysassign(
DOM_EXPR::Divs,
	proc()
	begin
	  return(args())
	end_proc
):

sysassign(
DOM_INT::IV,
	proc()
	begin
	  return(property::IV([args(), args()], (args())::NRange(args())))
	end_proc
):

sysassign(
DOM_RAT::IV,
	proc()
	begin
	  return(property::IV([args(), args()], (args())::NRange(args())))
	end_proc
):

sysassign(
DOM_FLOAT::IV,
	proc()
	begin
	  return(property::IV([args(), args()], (args())::NRange(args())))
	end_proc
):

sysassign(
DOM_IDENT::IV,
	proc()
	begin
	  return(property::IV([args(), args()]))
	end_proc
):

sysassign(
DOM_INT::Rel,
	proc()
	begin
	  return(property::Rel(args(), hold(_equal), args()))
	end_proc
):

sysassign(
DOM_RAT::Rel,
	proc()
	begin
	  return(property::Rel(args(), hold(_equal), args()))
	end_proc
):

sysassign(
DOM_FLOAT::Rel,
	proc()
	begin
	  return(property::Rel(args(), hold(_equal), args()))
	end_proc
):

sysassign(
DOM_IDENT::Rel,
	proc()
	begin
	  return(property::Rel(args(), hold(_equal), args()))
	end_proc
):

sysassign(
DOM_EXPR::Rel,
	proc()
	begin
	  case type(args())
	  of "exp" do
	    if property::_is(args(), Type::RealNum) = TRUE then
	      return(property::Rel(args(), -hold(_less), 0))
	    else
	      return(FAIL)
	    end_if
	  end_case
	end_proc
):

#sysassign(#
#DOM_INT::Type,#
	#proc()#
	#begin#
	  #if args() > 0 then#
	    #return(Type::PosInt)#
	  #elif args() >= 0 then#
	    #return(Type::NonNegInt)#
	  #else#
	    #return(Type::NegInt)#
	  #end_if#
	#end_proc#
#):#

#sysassign(#
#DOM_RAT::Type,#
	#proc()#
	#begin#
	  #return(Type::Rational)#
	#end_proc#
#):#

#sysassign(#
#DOM_FLOAT::Type,#
	#proc()#
	#begin#
	  #return(Type::RealNum)#
	#end_proc#
#):#

#sysassign(#
#DOM_COMPLEX::Type,#
	#proc()#
	#begin#
	  #return(Type::AnyType)#
	#end_proc#
#):#

sysassign(
Type::is,
	proc()
	begin
	  if args(1) = args(2) then return(TRUE) end_if;
	  return(testtype(op((property::NRange)::elem(Type::NRange(args(1))), 1),
	                  args(2))
	         or UNKNOWN)
	end_proc
):

#sysassign(#
#Type::NRange,#
	#proc()#
	#begin#
	  #case args()#
	    #of Type::PosInt do return(property::NRange("natural"))#
	    #of Type::NonNegInt do return(property::NRange("nonnegint"))#
	    #of Type::NegInt do return(property::NRange("negint"))#
	    #of Type::Rational do return(property::NRange("rational"))#
	    #of Type::RealNum do return(property::NRange("real"))#
	    #of Type::AnyType do return(property::NRange("complex"))#
	    #otherwise return(FAIL)#
	  #end_case#
	#end_proc#
#):#

#sysassign(#
#Type::Rel,#
	#proc()#
	#begin#
	  #case args()#
	    #of Type::PosInt do return(property::Rel(property::NIL, -hold(_less), 0))#
	    #of Type::NonNegInt do return(property::Rel(property::NIL, -hold(_leequal), 0))#
	    #of Type::NegInt do return(property::Rel(property::NIL, hold(_less), 0))#
	    #otherwise return(FAIL)#
	  #end_case#
	#end_proc#
#):#

#sysassign(#
#Type::IV,#
	#proc()#
	#begin#
	  #case args()#
	    #of Type::PosInt do#
	      #return(property::IV(0, infinity, property::NRange("posint")))#
	    #of Type::NoNegInt do#
	      #return(property::IV([0], infinity, property::NRange("nonnegint")))#
	    #of Type::NegInt do#
	      #return(property::IV(-infinity, 0, property::NRange("negint")))#
	    #of Type::Rational do#
	      #return(property::IV(-infinity, infinity, property::NRange("rational")))#
	    #of Type::RealNum do#
	      #return(property::IV(-infinity, infinity, property::NRange("real")))#
	    #otherwise return(FAIL)#
	  #end_case#
	#end_proc#
#):#

#( Funktionsattribute "getprop" und "is" )#

#sysassign(#
	#exp,#
	#funcattr(exp, "getprop",#
	  #proc(_ex, _to)#
	  #begin#
	    #_ex:= op(_ex);#
	    #case _to#
	      #of hold(_to) do return(property::getprop(_ex))#
	      #of property::Rel do#
	        #if property::_is(_ex, property::real) = TRUE then#
	          #return(property::Rel(args(1), -hold(_less), 0))#
	        #else#
	          #return(_ex)#
	        #end_if#
	      #of property::NRange do#
	        #if property::_is(_ex, property::real) = TRUE then#
	          #return(property::positive)#
	        #else#
	          #return(property::complex)#
	        #end_if#
	      #otherwise return(_ex)#
	    #end_case#
	  #end_proc)#
#):#

sysassign(
	exp,
	funcattr(exp, "getprop",
	  proc(_ex, _to)
	    local _ret;
	  begin
	    userinfo(9, "stdlib::exp: ".expr2text(args()));
	    if not(contains({"float", type(_ex)}, type((_ret:= float(_ex))))) then
	      return(property::_getprop(_ret, _to))
	    end_if;
	    #_ex:= op(_ex);#
	    if property::_is(_ex, Type::NonNegative) = TRUE then
	      _ret:= property::IV([1], infinity, Type::Positive)
	    elif property::_is(_ex, Type::RealNum) = TRUE then
	      _ret:= property::isprop(Type::NonNegative)
	    else
	      _ret:= property::isprop(Type::Complex)
	    end_if;
	    return(property::convert_to(_ret, _to))
	  end_proc)
):

sysassign(
	exp,
	funcattr(exp, "is",
	  proc(_ex, _prop)
	    local _ret;
	  begin
	    userinfo(9, "stdlib::exp: ".expr2text(args()));
	    if not(contains({"float", type(_ex)}, type((_ret:= float(_ex))))) then
	      return(property::_is(_ret, _prop))
	    end_if;
	    #_ex:= op(_ex);#
	    if property::_is(_ex, Type::NonNegative) = TRUE then
	      return(property::isprop(
	               property::IV([1], infinity, Type::Positive), prop))
	      #return(property::isprop(property::Rel(_ex, -hold(_leequal), 1),#
	                              #_prop))#
	    elif property::_is(_ex, Type::RealNum) = TRUE then
	      return(property::isprop(Type::NonNegative, _prop))
	    else
	      return(property::isprop(Type::Complex, _prop))
	    end_if
	  end_proc)
):

sysassign(
	Re,
	funcattr(Re, "getprop",
	  proc(_ex, _to)
	  begin
	    userinfo(9, "stdlib::Re: ".expr2text(args()));
	    
	    if property::_is(_ex, Type::RealNum) = TRUE then
	      property::getprop(_ex)
	    end_if;
	    property::convert_to(property::getprop(_ex)
	                         and Type::RealNum, _to)
	  end_proc)
):

sysassign(
	Re,
	funcattr(Re, "is",
	  proc(_ex, _prop)
	  begin
	    userinfo(9, "stdlib::Re: ".expr2text(args()));
	    
	    if property::_is(_ex, Type::RealNum) = TRUE then
	      return(property::_is(_ex, _prop))
	    end_if;
	    property::_is(property::convert_to(property::getprop(_ex)
	                                       and Type::RealNum), _prop)
	  end_proc)
):

sysassign(
	Im,
	funcattr(Im, "getprop",
	  proc(_ex, _to)
	    local _ret;
	  begin
	    userinfo(9, "stdlib::Re: ".expr2text(args()));
	    
	    if property::_is(_ex, Type::Imaginary) = TRUE then
	      return(property::getprop(_ex))
	    end_if;
	    property::convert_to(property::getprop(_ex)
	                         and Type::Imaginary, _to)
	  end_proc)
):

sysassign(
	Im,
	funcattr(Im, "is",
	  proc(_ex, _prop)
	    local _ret;
	  begin
	    userinfo(9, "stdlib::Re: ".expr2text(args()));
	    
	    if property::_is(_ex, Type::Imaginary) = TRUE then
	      return(property::_is(_ex, _prop))
	    end_if;
	    property::_is(property::convert_to(property::getprop(_ex)
	                                       and Type::Imaginary), _prop)
	  end_proc)
):

userinfo(1, "Loading BaseProps done..."):
