      
#(
   Divs - domain of divisors
          
)#

alias(Divs = property::Divs):
alias(Ar(x) = [5, x]):
alias(Arg(x, y) = op(extop(x, 5), y)):
alias(Args(x) = op(extop(x, 5))):

Divs:= domain("property::Divs"):
Divs::info:= "Domain of divisors":
Divs::domtype:= fun(Type):
Divs::type:= "Divs":
Divs::prop:= TRUE:
Divs::propdom:= domattr(property, "Divs"):
Divs::autoload:= TRUE:
Divs::testtype:= Type::testtype:

Divs::ax:= []:

Divs::new:= 
	proc()
	  local __m;
	begin
	  if args(0) > 1 then
	    __m:= {map(args(), type)};
	    if contains(__m, "Pnot") or
	      contains(__m, "_not") then
	      if nops(__m) > 1 then
	        error("divide or not divide?")
	      end_if;
	      Divs::_not(Divs(op(map({args()}, op))))
	    else
	      domattr(Type, "Divs")([Divs::divs(lcm(args()))])
	    end_if
	  else
	    if args(0) > 0 then
	      if type(args()) = "Pnot" or type(args()) = "_not" then
	        Divs::_not(Divs(op(args())))
	      else
	        domattr(Type, "Divs")([Divs::divs(args())])
	      end_if
	    else
	      domattr(Type, "Divs")([1, 0])
	    end_if
	  end_if
	end_proc:

#( gibt bool zur"uck, ob x geteilt durch Divs(d1) => durch Divs(_d2) )#
#( jeder Teiler von _d2 mu\3 einen Teiler von d1 teilen)#
Divs::is:=
	proc(_d1, _d2)
	  local __ret, __r, __set, __s, __tt, __k, __i, __j;
	begin
	  if type(_d1) <> "Divs" or type(_d2) <> "Divs" then
	    return(UNKNOWN)
	  end_if;
	  if _d1 = Divs(0) then return(UNKNOWN)
	  elif _d1 = Divs(1) then return(UNKNOWN)
	  elif _d2 = Divs(0) then return(TRUE) end_if;

	  #( !wenn nicht even dann odd! )#
	  if _d2 = not(Divs(2)) then
	    return(Divs::is(Divs(map(map(_mult(map(Divs::eval(_d1), op)),
	                                 abs), _plus, 1)),
	                    Divs(2)))
	  end_if;

	  if domtype(_plus(Args(_d1))) <> DOM_INT or 
	     domtype(_plus(Args(_d2))) <> DOM_INT then

	    __ret:= TRUE;
	    __set:= FALSE;
	    __tt:= (type(Arg(_d1, 1)) = "Pnot" and
	            type(Arg(_d2, 1)) <> "Pnot") or
	           (type(Arg(_d1, 1)) <> "Pnot" and
	            type(Arg(_d2, 1)) = "Pnot");
	    for __j from 1 to floor(nops(Args(_d2))/2) do
	      __r:= UNKNOWN;			# noch kein Teiler #
	      __s:= TRUE;
	      for __i from 1 to floor(nops(Args(_d1))/2) do
	        __k:= Divs::div(Arg(_d2, __j*2-1), Arg(_d1, __i*2-1));
	        if _if(__tt, _leequal(Arg(_d2, __j*2), Arg(_d1, __i*2)),
	                     _leequal(Arg(_d1, __i*2), Arg(_d2, __j*2))) then
	          if __k = TRUE then
	            __r:= __k;
	            break
	          elif __k = FALSE then
	            __s:= __k;
	            break
	          end_if
	        end_if;
	      end_for;
	      __ret:= __ret and __r;
	      __set:= __set or __s;
	      
	    end_for;
	    return(__ret and __set)
	  else
	    return(bool(domtype(_mult(Divs::eval(_d1))/
	                        _mult(Divs::eval(_d2)))
	                = DOM_INT) or UNKNOWN)
	  end_if

	end_proc:

#( gibt bool zur"uck, ob _d1 Teiler von _d2 )#
Divs::div:=
	proc(_d1, _d2)
	begin
	  if type(_d1) = "Pnot" then
	    if type(_d2) = "Pnot" then #( beide Pnot )#
	      return(bool(domtype(op(_d2)/op(_d1)) = DOM_INT))
	    else #( erster Pnot )#
	      return(bool(not(domtype(_d2/op(_d1)) = DOM_INT)) and UNKNOWN)
	    end_if
	  else
	    if type(_d2) = "Pnot" then #( zweiter Pnot )#
	      return(bool(not(domtype(op(_d2)/_d1) = DOM_INT)) and UNKNOWN)
	    else
	      return(bool(domtype(_d2/_d1) = DOM_INT) or UNKNOWN)
	    end_if
	  end_if
	end_proc:

#( gibt alle Primteiler von _d1 zur"uck )#
Divs::divs:=
	proc(_d1)
	  local _n;
	begin
	  if domtype(_d1) <> DOM_INT then
	#    if type(_d1) = "_power" then#
	#      return(_d1)#
	#    end_if;#
	#    if domtype(_d1) = DOM_RAT then#
	#      return(_d1)#
	#    end_if;#
	    _d1:= factor(_d1);
	    if nops(_d1) = 1 then return(op(_d1), 1) end_if;
	    _n:= op(_d1, 1);
	    if abs(_n) <> 1 then
	    #  return(op(subsop(_d1, 1 = null())), Divs::divs(_n))#
	      return(op(subsop(_d1, 1 = null())), op(_d1, 1), 1)
	    else
	      return(op(subsop(_d1, 1 = null())))
	    end_if
	  else
	    if abs(_d1) = 1 then return(1, 1) end_if;
	    if _d1 = 0 then return(0, 1) end_if;
	    _d1:= ifactor(_d1);    
	    return(op(subsop(_d1, 1 = null())))
	  end_if
	end_proc:

Divs::_or:=
	proc()
	begin
	  property::_Op(Divs, _or,
	    proc()
	    begin
	      if type(Arg(args(1), 1)) = "Pnot" then
	        if type(Arg(args(2), 1)) = "Pnot" then
	          return(not(Divs(gcd(_mult(map(Divs::eval(args(1)), op)),
			              _mult(map(Divs::eval(args(2)), op))))))
	        else
	          #if domtype(_mult(map(Divs::eval(args(1)), op))/#
			     #_mult(Divs::eval(args(2)))) = DOM_INT then#
	            #return(not(Divs(_mult(map(Divs::eval(args(1)), op))/#
			            #_mult(Divs::eval(args(2))))))#
	          #elif domtype(_mult(Divs::eval(args(2)))/#
			       #_mult(map(Divs::eval(args(1)), op))) = DOM_INT then#
	            #return(Divs(_mult(Divs::eval(args(2)))/#
			        #_mult(map(Divs::eval(args(1)), op))))#
	          #else#
	            return(hold(_or)(args()))
	          #end_if#
	        end_if
	      else
	        if type(Arg(args(2), 1)) = "Pnot" then
	          #if domtype(_mult(map(Divs::eval(args(2)), op))/#
			     #_mult(Divs::eval(args(1)))) = DOM_INT then#
	            #return(not(Divs(_mult(map(Divs::eval(args(2)), op))/#
			            #_mult(Divs::eval(args(1))))))#
	          #elif domtype(_mult(Divs::eval(args(1)))/#
			       #_mult(map(Divs::eval(args(2)), op))) = DOM_INT then#
	            #return(Divs(_mult(Divs::eval(args(1)))/#
			        #_mult(map(Divs::eval(args(2)), op))))#
	          #else#
	            return(hold(_or)(args()))
	          #end_if#
	        else
	          return(Divs(   (_mult(Divs::eval(args(1))),
			          _mult(Divs::eval(args(2))))))
	        end_if
	      end_if
	    end_proc, args())
	end_proc:

Divs::_and:=
	proc()
	begin
	  property::_Op(Divs, _and,
	    proc()
	    begin
	      if type(Arg(args(1), 1)) = "Pnot" then
	        if type(Arg(args(2), 1)) = "Pnot" then
	          return(not(Divs(   (_mult(map(Divs::eval(args(1)), op)),
			              _mult(map(Divs::eval(args(2)), op))))))
	        else
	          if domtype(_mult(map(Divs::eval(args(1)), op))/
			     _mult(Divs::eval(args(2)))) = DOM_INT then
	            return(not(Divs(_mult(map(Divs::eval(args(1)), op))/
			            _mult(Divs::eval(args(2))))))
	          elif domtype(_mult(Divs::eval(args(2)))/
			       _mult(map(Divs::eval(args(1)), op))) = DOM_INT then
	            #return(Divs(_mult(Divs::eval(args(2)))/#
			        #_mult(map(Divs::eval(args(1)), op))))#
	            return(Divs(0))
	          else
	            return(hold(_and)(args()))
	          end_if
	        end_if
	      else
	        if type(Arg(args(2), 1)) = "Pnot" then
	          if domtype(_mult(map(Divs::eval(args(2)), op))/
			     _mult(Divs::eval(args(1)))) = DOM_INT then
	            return(not(Divs(_mult(map(Divs::eval(args(2)), op))/
			            _mult(Divs::eval(args(1))))))
	            #return(Divs(0))#
	          elif domtype(_mult(Divs::eval(args(1)))/
			       _mult(map(Divs::eval(args(2)), op))) = DOM_INT then
	            #return(Divs(_mult(Divs::eval(args(1)))/#
			        #_mult(map(Divs::eval(args(2)), op))))#
	            return(Divs(0))
	          else
	            return(hold(_and)(args()))
	          end_if
	        else
	          return(Divs(gcd(_mult(Divs::eval(args(1))),
			          _mult(Divs::eval(args(2))))))
	        end_if
	      end_if
	    end_proc, args())
	end_proc:

Divs::_not:=
	proc()
	  local _ret, __i;
	begin
	  #if args(0) > 1 then error("Illegal operand") end_if;#
	  if op(_mult(Divs::eval(args()))) = 1 then return(Divs(0)) end_if;
	  _ret:= args(1);
	  for __i from 1 to floor(nops(Args(_ret))/2) do
	    _ret:= subsop(_ret, Ar(2*__i-1) =
	                        (property::POp)::Pnot(Arg(_ret, 2*__i-1)))
	  end_for;
	  return(_ret)
	end_proc:

Divs::_mult:=
	proc()
	begin
	  property::_Op(Divs, _mult,
	    proc()
	    begin
	      if nops(map({Arg(args(1), 1), Arg(args(2), 1)},
	             fun(bool(type(args()) = "Pnot")))) = 2 then
	        return(args(_if(type(Arg(args(1), 1)) = "Pnot", 2, 1)))
	      else
	      end_if;
	      return(Divs(_mult(_mult(Divs::eval(args(1))),
			        _mult(Divs::eval(args(2))))))
	    end_proc, args())
	end_proc:
	
Divs::_divide:=
	proc()
	begin
	  property::_Op(Divs, _divide,
	    proc()
	    begin
	      if type(Arg(args(1), 1)) = "Pnot" then
	        if type(Arg(args(2), 1)) = "Pnot" then
	          return(args(1))
	          #return(not(Divs(_mult(_mult(map(Divs::eval(args(1)), op)),#
			                #_mult(map(Divs::eval(args(2)), op))))))#
	        else
	          return(not(Divs(_divide(_mult(map(Divs::eval(args(1)), op)),
			                  _mult(Divs::eval(args(2)))))))
	        end_if
	      else
	        if type(Arg(args(2), 1)) = "Pnot" then
	          return(args(1))
	        else
	          return(Divs(_divide(_mult(Divs::eval(args(1))),
			              _mult(Divs::eval(args(2))))))
	        end_if
	      end_if;

	    end_proc, args())
	end_proc:
	
Divs::_power:=
	proc()
	begin
	  property::_Op(Divs, _power,
	    proc()
	    begin
	      if type(args(1)) = "Divs" then
	        if type(args(2)) = "Divs" then
	          if type(Arg(args(1), 1)) = "Pnot" then
	            if type(Arg(args(2), 1)) = "Pnot" then
	              return(Divs(0))
	            else
	              return(not(Divs(_power(_mult(map(Divs::eval(args(1)), op)),
	                                     _mult(Divs::eval(args(2)))))))
	            end_if
	          else
	            if type(Arg(args(2), 1)) = "Pnot" then
	              return(Divs(0))
	            else
	              return(Divs(_power(_mult(Divs::eval(args(1))),
	                                 _mult(Divs::eval(args(2))))))
	            end_if
	          end_if
	        elif property::_is(args(2) < 0) = TRUE then
	          return(not(Divs::_power(args(1), -args(2))))
	        else
	          return(Divs(_power(_mult(Divs::eval(args(1))),
	                             args(2))))
	        end_if
	      else
	        return(FAIL)
	      end_if
	    end_proc, args())
	end_proc:

Divs::_plus:=
	proc()
	begin
	  property::_Op(Divs, _plus,
	    proc()
	    begin
	      #if property::_is((args(1) + args(2)) = 0) = TRUE then#
	        #return(Divs(0))#
	      #end_if;#
	      if contains({{FALSE}, {TRUE}},
			   map({Arg(args(1), 1), Arg(args(2), 1)},
			       fun(bool(type(args()) = "Pnot")))) then
	        return(_and(args()))
	      else
	        return(Divs(0))
	      end_if
	    end_proc, args())
	end_proc:

Divs::_subtract:=
	proc()
	begin
	  property::_Op(Divs, _subtract,
	    proc()
	    begin
	      #if property::_is((args(1) - args(2)) = 0) = TRUE then#
	        #return(Divs(0))#
	      #end_if;#
	      if contains({{FALSE}, {TRUE}},
			   map({Arg(args(1), 1), Arg(args(2), 1)},
			       fun(bool(type(args()) = "Pnot")))) then
	        return(_and(args()))
	      else
	        return(Divs(0))
	      end_if
	    end_proc, args())
	end_proc:

#(  )#
Divs::eval:=
	proc(_d1)
	  local __i, _n, _ret;
	begin
	  _ret:= null();
	  for __i from 1 to floor(nops(Args(_d1))/2) do
	    _n:= _power(Arg(_d1, 2*__i-1), Arg(_d1, 2*__i));
	    _ret:= _ret, _n, 1
	  end_for;
	  return(op(_ret))
	end_proc:

Divs::NRange:=
	proc()
	  local _ret;
	begin
	  _ret:= _mult(Divs::eval(args(1)));
	  if domtype(_ret) = DOM_INT then
	    return(Type::Integer)
	  end_if;
	  #for __i from 1 to nops(_ret) do#
	    #_ret:= _and(map(_ret, property::convert_to, NRange))#
	  #end_for;#
	  #return(_ret)#
	  return(FAIL)
	end_proc:

Divs::print:=
	proc()
	  local _pr, __l, __i;
	begin
	  #if contains(property::aliases, pr) then#
	    #return(property::aliases[pr])#
	  #end_if;#
	  if (__l:= expr2text(op(args(), 1))) <> "Divs" then
	    __l
	  else
	    _pr:= Args(args());
	    __l:= null();
	    for __i from 1 to floor(nops(_pr)/2) do
	      __l:= __l, hold(_power)(op(_pr, 2*__i-1), op(_pr, 2*__i)) 
	    end_for;
	    if 2*(__i-1) < nops(_pr) then
	      __l:= __l, op(_pr, nops(_pr))
	    end_if;
	    "Divs(" . expr2text(__l) . ")"
	  end_if
	end_proc:

unalias(Ar):
unalias(Arg):
unalias(Args):
unalias(Divs):
