      
#(
   EO - domain of even/odd
          
)#

alias(EO = property::EO):

EO:= domain("property::EO"):
EO::info:= "Domain of divisors":
EO::domtype:= fun(Type):
EO::type:= "EO":
EO::prop:= TRUE:
EO::propdom:= fun(property::EO):
EO::autoload:= TRUE:
EO::testtype:= Type::testtype:

EO::ax:= []:

EO::new:= 
	proc()
	begin
	  if property::is(Divs(args()), Divs(2)) = TRUE then
	    new(EO, 0)
	  elif property::is(Divs(args()), not(Divs(2))) = TRUE then
	    new(EO, 1)
	  else
	    Divs(args())
	  end_if
	end_proc:

EO::is:=
	proc()
	begin
	  if type(args(1)) = "EO" then
	    if type(args(2)) = "EO" then
	      return(bool(op(args(1)) = op(args(2))) or UNKNOWN)
	    else
	      return(property::is(_if(op(args(1)) = 0, Divs(2), not(Divs(2))),
	                          args(2)))
	    end_if
	  else
	    if type(args(2)) = "EO" then
	      return(property::is(args(1),
		                  _if(op(args(2)) = 0, Divs(2), not(Divs(2)))))
	    end_if
	  end_if
	end_proc:

EO::_and:=
	proc()
	begin
	  if op(args()) = 0 then
	  else
	  end_if
	end_proc:
	
EO::_plus:=
	proc()
	begin
	  property::_Op(EO, _plus,
	    proc()
	    begin
	      EO(op(args(1)) + op(args(2)) + 2)
	    end_proc, args())
	end_proc:

EO::_subtract:=
	proc()
	begin
	  property::_Op(EO, _subtract,
	    proc()
	    begin
	      EO(op(args(1)) + op(args(2)) + 2)
	    end_proc, args())
	end_proc:

EO::_negate:=
	proc()
	begin
	  args()
	end_proc:

EO::_mult:=
	proc()
	begin
	  property::_Op(EO, _mult,
	    proc()
	    begin
	      EO(op(args(1)) * op(args(2)) + 2)
	    end_proc, args())
	end_proc:

EO::_divide:=
	proc()
	begin
	  property::_Op(EO, _divide,
	    proc()
	    begin
	      if op(args(1)) <> op(args(2)) then
	        args(1)
	      else
	        property::NIL
	      end_if
	    end_proc, args())
	end_proc:

EO::_invert:=
	proc()
	begin
	  1/Divs(EO::Divs(args()))
	end_proc:

EO::_power:=
	proc()
	begin
	  property::_Op(EO, _power,
	    proc()
	    begin
	      EO(op(args(1)) + op(args(2)) + 2)
	    end_proc, args())
	end_proc:

EO::Divs:=
	proc()
	begin
	  _if(op(args() = 0), Divs(2), not(Divs(2)))
	end_proc:
	
EO::print:=
	proc()
	begin
	  if op(args()) = 0 then
	    "even"
	  else
	    "odd"
	  end_if
	end_proc:
	
stdlib::LoadlibState["property::EO"]:= TRUE:

userinfo(1, "Loading 'EO' done ..."):
unalias(EO):
