
#( Pand - Domain of 'And of Properties' )#

alias(Pand = (property::POp)::Pand):

Pand:= domain("POp::Pand"):
Pand::info:= "And of Properties":
Pand::type:= "Pand":
Pand::Ptype:= "Pbool":
  
Pand::new:=
	proc()
	begin
	  new(Pand, args())
	end_proc:

Pand::expr:=
	proc()
	  local i;
	begin
	  for i from 1 to args(0) do
	    if POp::expr(args(i)) = FALSE then
	      return(FALSE)
	    end_if
	  end_for;
	  return(TRUE)
	end_proc:
	
Pand::print:=
	proc()
	  local i, l;
	begin
	  if nops(args()) > 0 then
	    l:= "(" . expr2text(op(args(), 1));
	    i:= 2;
	    while i <= nops(args()) do
	      l:= l . " and " . expr2text(op(args(), i));
	      i:= i + 1
	    end_while;
	    l . ")"
	  end_if
	end_proc:

unalias(Pand):