alias(Is = property::__Is):

#( (ident, prop, Op) verkn"upft die Eigenschaften von ident Op prop )#
property::assume:=
	proc(ident, prop, Op)
	  local idprops, Args, p;
	begin
	  idprops:= FALSE;
	  if property::PROPLEVEL <= 1 then
            sign:
            Args:= [args()];
            if (p:= contains( Args,_and )) = 0 then 
                # remove only props set by the old assume facility #
                idprops:= property::PROPLEVEL;
                sysassign( property::PROPLEVEL, 1 );
                unassume( args() );
                sysassign( property::PROPLEVEL, idprops )
            else
                unassign( Args[p] )
            end_if;

            if type(ident)="_less" then
               sysassign( Is(op(ident,1),Type::RealNum),TRUE ):
               sysassign( Is(op(ident,2),Type::RealNum),TRUE );
               sysassign( sign(op(ident,2)-op(ident,1)), 1 );
               sysassign( sign(op(ident,1)-op(ident,2)), -1 );
            elif args(0) = 2 then
	         case args(2) 
	         of Type::PosInt do
	             sysassign( Is(ident,Type::RealNum), TRUE );
	             sysassign( sign(ident), 1 );
	             break
	         of Type::NegInt do
                     sysassign( Is(ident,Type::RealNum), TRUE );
                     sysassign( sign(ident), 1 );
                     break
	         of Type::NonNegInt do
	             sysassign( Is(ident,Type::RealNum), TRUE );
	             break
	         otherwise
	             sysassign(Is(op(Args)), TRUE)
	         end_case
            end_if;
            idprops:= sysassign(Is(op(Args)), TRUE)
          end_if;
 
          if property::PROPLEVEL <> 1 then
              # call new assume #
              property::_assume( args() )
          else
              idprops
          end_if
       end_proc:
property::_assume:= proc(ident,prop,Op)
	  local idprops;
	begin
	    property::reset();
	    if contains({"_less", "_leequal", "_equal", "_unequal"},
		        type(ident)) then
              prop:= property::setrel(ident, _if(hold(prop) = prop,
	                                         null(), prop));
              if domtype(prop) = DOM_NULL then
                return(bool(property::PROPLEVEL <= 1))
              else
	        return(prop)
              end_if
	    end_if;
	    if domattr(ident, "propdom") <> FAIL then
	      if args(0) = 1 then
	        prop:= _and
	      end_if;
	      if nops(property::gdef) > 0 then
	        ident:= prop(ident, property::gdef)
	      end_if;
	      return(sysassign(property::gdef, ident))
	    end_if;
	    if domtype(ident) <> DOM_IDENT then
	      return(idprops)
	    end_if;
	    if args(0) < 3 then
	      Op:= _and;
	      #( standard: l"oschen )#
	      #property::unassume(ident)#
              properties( ident,FAIL )
	    else
	      if contains({hold(New), "New"}, Op) then
	        #property::unassume(ident);#
                properties( ident,FAIL );
	        Op:= _and
	      end_if
	    end_if;

	    idprops:= properties(ident);
	    #(if domtype(idprops) = DOM_FAIL then)#
	    if idprops = FAIL then
	      properties(ident, prop);
	      return(prop)
	    else
	      if domtype(idprops) = DOM_EXPR then
	        idprops:= map(idprops, Op, prop)
	      else
	        idprops:= Op(idprops, prop)
	      end_if;
	      if TRUE then                 #( Vereinfachung gew"unscht )#
	        if domtype(idprops) = DOM_EXPR then
	          idprops:= op(idprops, 0)(op({op(idprops)}))
	        end_if
	      end_if;
	      properties(ident, idprops)
	    end_if;
	    return(idprops)
	end_proc:
	
#( (rel, _Op) setzt neue Relation )#
property::setrel:=
	proc(_rel, _Op)
	  local __op, op1, op2, __ret;
	begin
	  property::reset():
	  op1:= _if(domtype(op(_rel, 1)) = DOM_IDENT, op(_rel, 1), null());
	  op2:= _if(domtype(op(_rel, 2)) = DOM_IDENT, op(_rel, 2), null());
	  _Op:= _if(hold(_Op) = _Op, null(), _Op);
	  __ret:= null();
	  __op:= op(_rel, 0);
	  if domtype(op1) <> DOM_NULL then
	    __ret:= property::_assume(op1, property::Rel(op1, __op,
					                 op(_rel, 2)), _Op)
	  end_if;
	  if domtype(op2) <> DOM_NULL then
	    __ret:= property::_assume(op2, property::Rel(op2, -__op,
					                 op(_rel, 1)), _Op)
	  end_if;
	  __ret
	end_proc:

#( (rel) gibt eine Relation (Typ `Rel') zur"uck )#
property::rel:=
	proc(_rel)
	begin
	  if args(0) = 1 then
	    return(property::Rel(op(args(1), 1),
		                 op(args(1), 0), op(args(1), 2)))
	  else
	    return(property::Rel(op(args(1), 2),
		                 -op(args(1), 0), op(args(1), 1)))
	  end_if
	end_proc:

assume:= property::assume:

unalias(Is):
