# solves the recurrence with constant coefficients
  l[1]*u(n)+l[2]*u(n+1)+...+l[ord+1]*u(n+ord)=0
  Example:
>> rec::constant([2,2,1,0],n,2);

                                   n               n
                       a1 (- 1 - I)  + a2 (- 1 + I)
#

rec::constant := proc(l,n,ord) local eq,x,i,sol;
begin
   # form the characteristic equation #
   eq:=_plus(l[i+1]*x^i$i=0..ord);
   sol:=0;
   for x in solve(eq,x,Multiple) do
      sol:=sol+x[1]^n*_plus(genident("a")*n^i$i=0..x[2]-1)
   end_for;
   if l[ord+2]=0 then sol
   else null() # variation of constant not yet implemented #
   end_if
end_proc:
