# $Date: 1995/08/12 16:08:10 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	besselJ/diff -- the function attribut "diff" for besselJ
--#

besselJ := funcattr(besselJ,"diff",proc(e,x) # e=besselJ(v,f) #
   local v,f;
begin
   if has(op(e,1),[args(2..args(0))]) then hold(diff)(args())
   # now we only have to diff. with respect to second argument #
   elif args(0)>2 then diff(diff(e,x),args(3..args(0)))
   else
      v:=op(e,1); f:=op(e,2); (v/f*e-subsop(e,1=v+1))*diff(f,x)
   end_if
end_proc):

# end of file #
