# $Date: 1996/06/05 07:52:29 $ $Author: frankp $ $Revision: 1.3 $ #

#--
	ln/sign -- the function attribut "sign" for ln
--#

ln:= funcattr(ln,"sign",proc(x)
    local s, ss, t;
begin
    if sign(op(x,1)) = 1 then
        return( sign( op(x,1)-1 ) )
    end_if;
    s:= Re(x);
    if not has(s,{Re,Im}) and s <> x then
        ss := Im(x);
        if not has(ss,{Re,Im}) then
             t := sqrt( s^2*sign(s)^2+ss^2*sign(ss)^2 );
             if not iszero(t) then return( (s+I*ss)/t ) end_if
        end_if
    end_if;
    hold(sign)(x)
end_proc):

# end of file #
