acsc := proc(x)
    # acsc(x) = asin(1/x) #
begin
    if x::acsc <> FAIL then return(x::acsc(args())) end_if;
    if args(0) <> 1 then
       error("1 argument expected")
    end_if;

    if x = 0 or x = 0.0 then
       error("singularity")
    end_if;
    asin(1/x)
end_proc:

acsc:= funcattr(acsc, "type", "acsc"):
acsc:= funcattr(acsc, "print", "acsc"):
acsc:= funcattr(acsc, "info", "acsc -- the inverse cosecant"):

# end of file #
