asec := proc(x)
    # asec(x) = acos(1/x) #
begin
    if x::asec <> FAIL then return(x::asec(args())) end_if;
    if args(0) <> 1 then
       error("1 argument expected")
    end_if;

    if x = 0 or x = 0.0 then
       error("singularity")
    end_if;
    acos(1/x)
end_proc:

asec:= funcattr(asec, "print", "asec"):
asec:= funcattr(asec, "info", "asec -- the inverse secant"):
asec:= funcattr(asec, "type", "asec"):

# end of file #
