# #
# $Date: 1996/07/03 13:45:49 $ $Author: frankp $ $Revision: 1.8 $ #

# zimmerma, 16/02/95 #

#++
	besselY -- Bessel function of 2nd kind, order v and argument z

	besselY(n,z)
++#

besselY:=proc(n,z)
begin
   if z::besselY <> FAIL then return( z::besselY(args()) ) end_if;

   if type(z)=DOM_FLOAT then return(funcattr(besselY,"float")(n,z))
   elif type(z)=DOM_COMPLEX then
      if type(op(z,1))=DOM_FLOAT or type(op(z,2))=DOM_FLOAT then
         return(funcattr(besselY,"float")(n,z))
      end_if
   end_if;
   hold(besselY)(n,z)
end_proc:

besselY:=funcattr(besselY,"float",
    loadproc(funcattr(besselY,"float"),pathname("SPECFUNC","FLOAT"),"besselY")
):
    
besselY:=funcattr(besselY,"type","besselY"):
besselY:=funcattr(besselY,"info",
"besselY(v,z) -- Bessel function of 2nd kind, order v and argument z"):
besselY:=funcattr(besselY,"print","besselY"):

# end of file #
