csch := proc(x)
    # csch(x) = 1/sinh(x) #
begin
    if x::csch <> FAIL then return(x::csch(args())) end_if;
    if args(0) <> 1 then
       error("1 argument expected")
    end_if;

    sinh(x);
    if % = 0 or % = 0.0 then
       error("singularity")
    else
       1/%
    end_if;
end_proc:

csch := funcattr(csch, "type", "csch"):
csch := funcattr(csch, "print", "csch"):
csch := funcattr(csch, "info", "csch -- the hyperbolic cosecant"):

csch := funcattr(csch, "expand", fun(expand(1/sinh(args(1)))) ):

csch:= funcattr( csch, "conjugate",
    loadproc(funcattr(csch,"conjugate"),pathname("STDLIB","CONJ"),"csch")
):

# end of file #
