# $Date: 1995/08/12 16:02:35 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	tan/Im -- the function attribut "Im" for tan
--#

tan := funcattr( tan, "Im", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then return( 0 )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sinh(2*s) / (cos(2*r) + cosh(2*s)) )
            end_if
        end_if;
        hold(Im)(tan(x))
    end_proc
):

# end of file #
