# $Date: 1995/08/12 16:02:36 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	tanh/Im -- the function attribut "Im" for tanh
--#

tanh := funcattr( tanh, "Im", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then return( 0 )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sin(s)*cos(s)/(sinh(r)^2+cos(s)^2) )
            end_if
        end_if;
        hold(Im)(tanh(x))
    end_proc
):

# end of file #
