Pref::debugOnTheFly:= funcattr(
    proc(n)
    begin
        case args(0) 
        of 0 do
            return( _pref(DebugOnTheFly)) 
        of 1 do
            if args(1) = NIL then # set default value #
                n:= _pref(hold(DebugOnTheFly)); 
                _pref(hold(DebugOnTheFly) = TRUE);
                return( n )
            elif domtype(n) <> DOM_BOOL then
                error("BOOLEAN expected")
            else
                _pref(hold(DebugOnTheFly)); 
                _pref(hold(DebugOnTheFly) = n); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting TRUE or FALSE)")
        end_case
    end_proc,
"info","If set to TRUE you can debug procedures and funs created in runtime."):

Pref::debugOnTheFly:= funcattr( Pref::debugOnTheFly,"default", TRUE ):

# end of file #
