Pref::keepOrder:= funcattr(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(KeepOrder)) )
        of 1 do
            if args(1) = NIL then # set default value #
               v:= _pref(hold(KeepOrder)); _pref(hold(KeepOrder) = hold(DomainsOnly));
               return( v )
            elif not contains( {Always, DomainsOnly,System},v ) then
                error("argument must either be 'Always', 'DomainsOnly' or 'System'")
            else
                _pref(hold(KeepOrder)); _pref(hold(KeepOrder) = v); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting either 'Always', 'DomainsOnly' or 'System')")
        end_case
    end_proc,
"info","Controlls the ordering of sums (for display only)."):

Pref::keepOrder:= funcattr( Pref::keepOrder, "default", hold(DomainsOnly) ):

# end of file #
