
Pref::printTimesDot:= funcattr(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(PrintTimesDot)) )
        of 1 do
            if args(1) = NIL then # set default value #
               v:= _pref(hold(PrintTimesDot));
	       _pref(hold(PrintTimesDot) = FALSE);
               return( v )
            elif not contains( {TRUE,FALSE},v ) then
               error("expecting TRUE or FALSE")
            else
               _pref(hold(PrintTimesDot));
	       _pref(hold(PrintTimesDot) = v); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting TRUE or FALSE)")
        end_case
    end_proc,
"info","Print centered dot as multiplication sign."):

Pref::printTimesDot:= funcattr( Pref::printTimesDot, "default", FALSE ):

# end of file #
