Pref::noProcRemTab:= funcattr(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(NoProcRemTab)) )
        of 1 do
            if args(1) = NIL then # set default value #
                v:= _pref(hold(NoProcRemTab)); _pref(hold(NoProcRemTab) = FALSE);
                return( v )
            elif not contains( {TRUE,FALSE},v ) and not testtype( v,Type::ListOf(DOM_IDENT) ) then
                error("argument must either be TRUE, FALSE or a list of identifiers (procedure names)")
            else
                _pref(hold(NoProcRemTab)); _pref(hold(NoProcRemTab) = v); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting either TRUE, FALSE or a list of identifiers)")
        end_case
    end_proc,
"info","Disables option 'remember' for given procedures."):

Pref::noProcRemTab:= funcattr( Pref::noProcRemTab,"default",FALSE ):

# end of file #
