# $Date: 1995/08/12 16:03:20 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	tan/Re -- the function attribut "Re" for tan
--#

tan := funcattr( tan, "Re", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then return( tan(x) )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sin(2*r) / (cos(2*r) + cosh(2*s)) )
            end_if
        end_if;
        hold(Re)(tan(x))
    end_proc
):

# end of file #
