# $Date: 1995/08/12 16:03:20 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	tanh/Re -- the function attribut "Re" for tanh
--#

tanh := funcattr( tanh, "Re", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then return( tanh(x) )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sinh(r)*cosh(r)/(sinh(r)^2+cos(s)^2) )
            end_if
        end_if;
        hold(Re)(tanh(x))
    end_proc
):

# end of file #
