# $Date: 1997/08/07 13:42:57 $ $Author: tonner $ $Revision: 1.5 $ #

#--
	asin/rectform -- the function attribut "rectform" for asin
--#

asin := funcattr( asin, "rectform", proc(x)
        local a, b, rl, d, s, t, e;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2))
        else
            x:= rectform::new(x)
        end_if;
        rl := extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(asin)(rectform::expr(x)),rl)
        else
            a:= extop(x,1);
            b:= extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
               and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then
                rectform::new(asin(a+I*b))
            else
		s:= 1/2*rectform::expr( funcattr(abs,"rectform")(a+1+I*b,rl) );
		t:= 1/2*rectform::expr( funcattr(abs,"rectform")(a-1+I*b,rl) );
		d:= s+t; e:= -I*a+b;
		new(rectform,asin(s-t),sqrt(e^2)/e*ln(d+sqrt(d^2-1)),0,rl)
            end_if
        end_if
    end_proc
):
 
# end of file #
