# $Date: 1997/08/07 13:42:59 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	cosh/rectform -- the function attribut "rectform" for cosh
--#

cosh := funcattr( cosh, "rectform", proc(x)
        local a, b, rl;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2))
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(cosh)(rectform::expr(x)),rl)
        else
            a:= extop(x,1);
            b:= extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
               and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then
                rectform::new(cosh(a+I*b))
            else
                new(rectform,cosh(a)*cos(b),sinh(a)*sin(b),0,rl)
            end_if
        end_if
    end_proc
):

# end of file #
