# $Date: 1997/08/07 13:43:02 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	igamma/rectform -- the function attribut "rectform" for igamma
--#

igamma:= funcattr( igamma, "rectform", proc(a,x)
        local t, rl;
    begin
        if args(0) = 3 then
            x:= rectform::new(x,args(3))
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 or not iszero(extop(x,2)) then
            new(rectform,0,0,hold(igamma)(a,args(1)),rl)
        else
            t:= extop(x,1);
            if domtype(t) = DOM_FLOAT then
                rectform::new(igamma(a,t))
            else
                new(rectform,igamma(a,t),0,0,rl)
            end_if
        end_if
    end_proc
):

# end of file #
