# $Date: 1997/08/07 13:43:05 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	tan/rectform -- the function attribut "rectform" for tan
--#

tan:= funcattr( tan, "rectform", proc(x)
        local a, b, t, rl;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2)) 
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(tan)(rectform::expr(x)),rl)
        else
            a:= extop(x,1);
            b:= extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
            and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then
                rectform::new(tan(a+I*b))
            elif iszero(b) then
                new(rectform,tan(a),0,0,rl)
            else
                t:= cos(2*a)+cosh(2*b);
                new(rectform,sin(2*a)/t,sinh(2*b)/t,0,rl)
            end_if
        end_if
    end_proc
):

# end of file #
