#--

x  -> (x^2)             : func(x^2, x)

() -> 5                 : fun(5)

x  -> (x, x^2)          : func(hold(_exprseq)(x, x^2), x)

(x, y, z) -> (x*y, y*z) : func(hold(_exprseq)(x*y, y*z), x, y, z)

x -> (if x = 0 then x else x-1 end_if) :
                        func(hold(_exprseq)((if x = 0 then x else x-1 end_if))

-#

arrow := proc()
 
  option hold;
 
  local f1, f2, r, s1, s2;
 
begin
 
  f1 := context(args(1));
  if type(args(2)) = "_if" then
     f2 := args(2)
  else
     f2 := context(args(2));
  end_if;
 
  if type(args(1)) = DOM_NIL then

     s1 := "()";
 
     if domtype(f2) = DOM_EXPR then
 
        r := hold(fun)(hold(hold)(_exprseq)(f2));

        s2 := "(".expr2text(f2).")"
 
     else
 
        r := hold(fun)(f2);

        s2 := expr2text(f2)
 
     end_if
 
  else

     if type(f1) = "_exprseq" then

        s1 := "(".expr2text(f1).")"

     else

        s1 := expr2text(f1)

     end_if;

     if domtype(f2) = DOM_EXPR then
 
        r := hold(func)(hold(hold)(_exprseq)(f2), f1);

        s2 := "(".expr2text(f2).")"
 
     else
 
        r := hold(func)(f2, f1);
 
        s2 := expr2text(f2)
 
     end_if

  end_if;

  r := level(r, 2);

  if domtype(r) = DOM_EXEC then
    
    # Redefine output #

    r := subsop(r, 3=s1." -> ".s2)

  else

    r

  end_if

end_proc:
