# 
  Synopsis: changevar(f,eq) changes the variables in f according to eq.
  Author: Paul Zimmermann, 8 Feb 1996
  Examples: 
  >> changevar(hold(int)(ln(x)*2, x=0..1),x=exp(t));

                     int(2 t exp(t), t = -infinity..0)
#

changevar := proc(#f,eq#)
begin
   if (args(1))::changevar<>FAIL then (args(1))::changevar(args())
   elif type(args(1))="int" 
   or type(args(1))="function" and op(args(1),0)=hold(int) then
      loadlib("intlib"); intlib::changevar(args())
   else FAIL
   end_if
end_proc:
