# $Date: 1999/05/26 10:20:37 $  $Author: olli $  $Revision: 1.3.2.1 $ #
#
|
| Library-Routine plot3d().
|
|
|
| Diese Datei enth"alt die Library-Routinen plot3d(),
| die notwendig sind, um die verschiedenen im Hand-
| buch aufgelisteten Grafikbefehle zu vereinbaren.
| Die Argumente dieser Befehle werden so ge"andert,
| dass die Kernroutine plot() die richtigen Werte an
| das Grafiktool liefert.
|
|
|
| Autor: Thorsten Schulze
|
| letzte "Anderung : 22.5.99
|
#






plot3d := proc()
#
| Dieses ist die Library-Routine plot3d().
| Sie ist notwendig, um aus einen plot3d-Aufruf
| einen plot-Aufruf zu formen. Das einzige, was
| geschieht, ist das zus"atzlich die Option
| Dimension = 3 "ubergeben wird, um die Dimension
| der Szene richtig zu setzen.
#

local _s_, DIGITS;

begin
  DIGITS := 10:
  #
  | Falls keine Argumente "ubergeben wurden, wird 
  | nur plot(); aufgerufen.
  #

  if args(0) = 0
  then
    plot(Dimension=3);
  else
    #
    | Hier muss geprueft werden, ob args eine leere Liste ist.
    #
    if type(args(1)) = DOM_LIST and nops(args(1)) = 0 then
        error("Illegal argument"):
    end_if:
    
    #
    | Sonst wird der plot3d-Befehl in einen plot-Befehl
    | umgewandelt, wobei die zus"atzliche Option 
    | Dimension = 3 eingef"ugt wird.
    #

    _s_ := Dimension = 3;
    _s_ := _s_ , args():
    
    #
    | Aufruf der Kernroutine plot mit den Argumenten
    #

    if stdlib::ShowPlot = FALSE then _s_ else  plot(_s_) end_if

  end_if:
end_proc:

