
plotdata := proc(l)
   local arg, i, j, n, SceneOption, shift_x, shift_y;
begin
    SceneOption := null();
    n := nops(l);
    for j from 2 to args(0) do
        arg := args(j);
        if type(arg) = "_equal" and op(arg, 1) = AxesScaling then
           shift_x := 0; shift_y := 0;
           if op(arg, [2,1]) = Log then
              shift_x := max(-l[i][1]$i=1..n)+1;
           end_if;
           if op(arg, [2,2]) = Log then  
              shift_y := max(-l[i][2]$i=1..n)+1;
           end_if;
           SceneOption := Shift=[shift_x, shift_y];
           break;
        end_if;
    end_for;
            
    plot2d(args(2..args(0)), SceneOption,
           [Mode=List, [polygon(point(l[i][1],l[i][2])$i=1..n)]])
end_proc:
