#-

@@ - the repeated composition operator



f @@ n : f - any function, n - an integer



sin @@ 3      -> sin@sin@sin

(sin @@ 2)(x) -> sin(sin(x))

sin @@ (-1)   -> asin

(f @@ g)(x)   -> (f @@ g)(x)

-#

repcom := proc(x, i) 

   local y;

begin

   if type(i) = DOM_INT then

     if i = 0 then
         return( id )
      elif x=id then
	 return(id) 
      elif i=1 then
	 return(x)
      elif i > 1 then
         return( _fconcat( x $ i ) )
      elif i <= -1 then
         y := stdlib::inv_func1[x];
         if type(y) = "_index" then
            y := stdlib::inv_func2[x];
            if type(y) = "_index" then
               return( procname( args() ) )
            end_if
         end_if;
         return(_fconcat(y $-i))
      end_if
 
   end_if;
 
   procname( args() )
 
end_proc:

sysassign((stdlib::inv_func1), 

   table(

      sin  = asin,
      cos  = acos,
      tan  = atan,
      cot  = acot,
      sec  = asec,
      csc  = acsc,

      sinh = asinh,
      cosh = acosh,
      tanh = atanh,
      coth = acoth, 
      sech = asech,
      csch = acsch,

      ln   = exp
   )
):

sysassign(stdlib::inv_func2, proc() local i; begin
      table( (op(stdlib::inv_func1,[i,2]) = op(stdlib::inv_func1,[i,1]))
             $ i = 1..nops(stdlib::inv_func1)
      )
      end_proc()
):

repcom := funcattr(repcom, "type", "@@"):
repcom := funcattr(repcom, "print", "@@"):

#--
  Redefine output, such that repcom(f,g) gives f @@ g
--#

repcom := subsop(repcom, 2=built_in(1100, 15, "@@", "repcom")):
