# $Date: 1997/10/10 15:56:33 $ $Author: tonner $ $Revision: 1.7 $ #

# kg, 13/01/95 #

#++
unalias -- un-define alias name

unalias([expr,...])

expr - alias name to un-define

unalias(e1,...,en) un-defines the alias names ei.
unalias() un-defines all alias names.
++#

unalias:= proc()
    option hold, noDebug;
    local i;
begin
    if stdlib::Alias = FAIL then return(null()) end_if;
    
    if args(0) = 0 then
        # remove all aliases #
        sysassign(stdlib::Alias, [ table(), table(), table(), table() ]);
    	sysassign(_dom_alias_element_, NIL);
    	return(null())
    end_if;

    # remove from alias tables #
    for i from 1 to args(0) do
	if contains(stdlib::Alias[2], args(i)) then
	    sysassign(stdlib::Alias[1][stdlib::Alias[2][args(i)]], NIL);
	    sysassign(stdlib::Alias[2][args(i)], NIL)
	else
	    sysassign(stdlib::Alias[3][args(i)], NIL) ;
            sysassign(stdlib::Alias[4][args(i)], NIL)
	end_if
    end_for;

    # speed up parsing if no other aliases exist #
    if nops(stdlib::Alias[1]) + nops(stdlib::Alias[3]) = 0 then
    	sysassign(_dom_alias_element_, NIL)
    end_if;
    null()
end_proc:

# end of file #
