# Dirk Mueller, olorien, 28/10/96, v1.0 #

besselJ:=funcattr(besselJ, "transform::laplace",
  proc(_f, var1, var2) 
    local _c, _d, _a2;
  begin
    _c:=op(_f,1); _a2:=op(_f,2);
    if testtype(_c,NUMERIC) and (not testtype(_c, DOM_COMPLEX)) then
      _d:=_a2/var1;
      if (not has(_d, var1)) then
        return( ( sqrt(var2^2+_d^2)-var2 )^_c/( sqrt(var2^2+_d^2)*_d^_c ) );
      end_if;
    end_if;
    
    FAIL;
  end_proc):

# end of file #
