# $Date: 1997/10/13 16:10:14 $  $Author: frankp $  $Revision: 1.4 $ #

#++
AlgebraicConstant -- expression to test for algebraic constant expressions

This type expressions allows to test for algebraic constants.
++#

Type::AlgebraicConstant:=

    new(Type,
	hold(AlgebraicConstant),
	proc(t,x) begin
	    if args(0) <> 2 then return(FALSE) end_if;
	    case domtype(x)
	    of DOM_IDENT do return(FALSE);
	    of DOM_EXPR do
		if op(x,0) = hold(_index) then return(FALSE)
                elif op(x,0)=hold(_power) then
                   return(testtype(op(x,1),Type::AlgebraicConstant)
			and contains({DOM_RAT,DOM_INT},type(op(x,2))))
		else t:= map([op(x)], testtype, Type::AlgebraicConstant);
		end_if;
		if contains(t, FALSE) <> 0 then return(FALSE) end_if;
		if contains(t, FAIL) <> 0 then return(FAIL) end_if;
		return(TRUE);
	    of DOM_INT do
	    of DOM_RAT do return(TRUE);
	    of DOM_COMPLEX do
		return(bool(nops({DOM_RAT,DOM_INT} union map({op(x)},type))=2))
	    of DOM_FLOAT do
	    of DOM_STRING do
	    of DOM_BOOL do
	    of DOM_POINT do
	    of DOM_POLYGON do
	    of DOM_NIL do
	    of DOM_NULL do
	    of DOM_FAIL do
		return(FALSE);
	    end_case;
	    FAIL
	end_proc,
	FALSE, FALSE):

# end of file #
