# $Date: 1997/10/13 16:10:40 $  $Author: frankp $  $Revision: 1.3 $ #

#++
Singleton - returns type expression to test singleton types

Singleton(e)

e - expression defining the singleton type, may NOT be an
    expression sequence

A singleton type is a type consisting of only one element - the
expression given by e.
++#

Type::Singleton:= fun((
    if args(0) <> 1 then error("wrong no of args") end_if;
    new(Type,
	hold(Singleton),
	fun((
	    if args(0) <> 2 then return(FALSE) end_if;
	    bool(args(2) = args(1)[1])
	)),
	[ args(1) ], FALSE)
)):

# end of file #
