surface := proc(a, b)
  local c, s, x, y, z;
begin
  c := cos(b); s := sin(b);
  x :=  a * c * cosh(u) * cos(v) + a * s * sinh(u) * sin(v);
  y := -a * c * cosh(u) * sin(v) + a * s * sinh(u) * cos(v);
  z := a * c * u + a * s * v;
  x, y, z
end_proc:

nr := 1:
for i from 0.0 to 1.6 step 0.1 do
    plot3d(Scaling=UnConstrained,
           CameraPoint=[-46,61,26], FocalPoint=[0,0,10],
	   PlotDevice=["c".nr, Raster],
           [ Mode=Surface,
             [surface(1,i)], u=[-PI,PI], v=[-PI,PI],
            Color=[Flat], Style=[ColorPatches,AndMesh]
           ]
    ):
    nr:=nr+1:
end_for:
