/* $Date: 1995/10/17 14:02:34 $  $Author: andi $  $Revision: 1.4 $ */

/**************************************************************************
**                           MCM_compare.c                               **
** In diesem File werden die Funktionen und Variablen, die von           **
** MCM_compare.c zur Verfuegung gestellt werden deklariert.              **
** Erstellungsdatum  : 28/05/91                                          **
** Letzte Aenderung  : 17/10/95                                          **
** Autor             : Holger Naundorf, Andreas Kemper                   **
**************************************************************************/

#ifndef __MCM_compare__
#define __MCM_compare__


#define MCM_equal(s,t)   MCM_equal_intern(s,t)
#define MCM_compare(s,t) MCM_compare_intern(s,t)

/************************************************************************** 
** Deklarierte Funktionen :                                              **
**************************************************************************/
void MCM_init                    ( VOID );
void MCM_exit                    ( VOID );
long MCM_equal_specless          ( S_Pointer s, S_Pointer t );
long MCM_equal_intern            ( S_Pointer s, S_Pointer t );
long MCM_compare_intern          ( S_Pointer s, S_Pointer t );
long MCM_compare_specless        ( S_Pointer s, S_Pointer t );
long MCM_compare_string_ident    ( S_Pointer s, S_Pointer t );

long MCM_compare_string_ident    ( S_Pointer string,    S_Pointer ident );
long MCM_compare_MMMstring_ident ( S_Pointer mmmstring, S_Pointer ident );

/************************************************************************** 
** Deklarierte Variablen :                                               **
**************************************************************************/
#ifdef MCMD_STATISTICS

/*** In dieser Variablen werden die Aufrufe von MCM_equal mitgezaehlt. ***/

extern long MCMV_equal_calls ;  

/*** In dieser Variablen werden die Aufrufe von MCM_equal mitgezaehlt, ***/
/*** bei denen  die Gleichheit  des Inhaltes  der S-Zeiger  durch die  ***/
/*** Gleichheit der Zeiger entschieden wurde.                          ***/

extern long MCMV_equal_point_equal ; 

/*** In dieser Variablen werden die Aufrufe von MCM_equal mitgezaehlt, ***/
/*** bei denen die S-Zeiger trotz gleicher Signatur verschieden waren. ***/

extern long MCMV_equal_sign_equal ; 

/*** In dieser Variablen werden die Aufrufe von MCM_equal mitgezaehlt, ***/
/*** bei denen die S-Zeiger gleich waren.                              ***/
       
extern long MCMV_equal_equal ; 

#endif /* MCMD_STATISTICS */

#endif /* __MCM_compare__ */
