/* $Date: 1995/07/21 09:34:17 $  $Author: andi $  $Revision: 1.3 $ */

/**************************************************************************/
/* FILE:             MGR_sys_func.h                                       */
/* Autor:            Andreas Kemper, Klaus Gottheil                       */ 
/* Erstellt:         18/02/92                                             */ 
/* Letzte Aenderung: 02/02/94                                             */ 
/**************************************************************************/ 
 
#ifndef __MGR_sys_func__
#define __MGR_sys_func__


/**************************************************************************/ 
/* Deklaration der Systemfunktionen 'plot2d' und 'plot3d'                 */
/**************************************************************************/ 

/*
 * Makros:
 
#define MGR_cat(s) MMMZ(&s, CATEGORY, MMMread)->cat
#define MGR_set_error(s) MEV_set_error(MEVC_PLOT_ERROR, "plot", (s))
#define MGR_no_sign(s) !(MMMZ(&s,CATEGORY,MMMread)->spec & \
                        (MINUS_BIT | DIV_BIT | NOT_BIT))
*/
/*
 * Funktionen
 */


#ifndef MACINTOSH
void	  MGR_output_descr(int descr);
#endif

S_Pointer MGR_eval_plot(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MGR_eval_point(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);
S_Pointer MGR_eval_polygon(S_Pointer s, long prev_func, long eval_type, S_Pointer exec);


#endif /* __MGR_sys_func__ */


