/*
 * File:        MGR_util.h
 *
 * Inhalt:      Diese Datei enth"alt einige Utilities f"ur die Grafikberech-
 *              nungen. Diese ROutinen waren vorher in MGR_sys_func.c gespei-
 *              chert.
 *
 * Autor:       Gudrun Oevel, Thorsten Schulze
 *
 * Datum:       27.09.1994
 */

#ifndef __MGR_util__
#define __MGR_util__


/*
 * globale Funktionen
 */

void    MGR_calc_minmax_values_3d
           (   S_Pointer    sp_object
           );

void    MGR_default_perspective
           (   MGRT_Scene    *scene
           );

void    MGR_set_objectstrings
           (   S_Pointer    sp_object
           );

void    MGR_swap
           (   S_Pointer   *sp1,
               S_Pointer   *sp2
           );


void    MGR_string_to_c
           (   S_Pointer    sp_source,
               char         *string,
               long         max_length
           );

#endif /* __MGR_util__ */
