/* $Date: 1997/07/01 14:00:32 $  $Author: andi $  $Revision: 1.8 $ */

/*
 * MMMstorage.h -- bindet je nach Bedarf MMMstorage_gen.h oder 
 *                 MMMstorage_seq.h ein.
 *
 * Beim Definement MMMGEN/MMMD_GEN wird MMMstorage_gen.h 
 * eingebunden, sonst MMMstorage_seq.h.
 *
 */

#ifndef __MMMstorage__
#define __MMMstorage__


#if defined(MMMGEN) || defined(MMMD_GEN)
#   ifdef DOS_FILENAMES
#       include "MMMstorg.h"
#   else
#       include "MMMstorage_gen.h"
#   endif
#elif defined(MMMDAUTO)
#   ifdef DOS_FILENAMES
#       include "MMMstoru.h"
#   else
#       include "MMMstorage_auto.h"
#   endif
#elif defined(MMMDLEAN)
#   ifdef DOS_FILENAMES
#       include "MMMstorl.h"
#   else
#       include "MMMstorage_lean.h"
#   endif
#else
#   ifdef DOS_FILENAMES
#       include "MMMstors.h"
#   else
#       include "MMMstorage_seq.h"
#   endif
#endif

/*** In der Modul-/Kernel-Toolbox (MKT_func.[ch]) wird statt ***/
/*** 'S_Pointer' stets 'MTcell' verwendet. Dieser Bezeichner ***/
/*** entspricht den dort verwendeten Namenkonvention und er- ***/
/*** scheint griffiger.                                      ***/

#define MTcell S_Pointer
#define MTnode S_Pointer

#endif /* __MMMstorage__ */

