/* $Date: 1995/07/21 09:34:47 $  $Author: andi $  $Revision: 1.3 $ */

/**************************************************************************
**                            MMMSpeicherMem.h                           **
** In diesem File werden die beiden globalen Variabln MMM_mem_init[]     **
** und MMMV_mem_step[] definiert.                                        **
** -In MMMV_mem_init[i] steht, wieviele freie Bloecke der zum Index i    **
**  gehoerenden Groesse bei der Initialisierung der Speicherverwaltung   **
**  schon bereit gestellt werden sollen.                                 **
** -In MMM_mem_step[i] steht, wieviele freie Bloecke der zum Index i     **
**  gehoerenden Groesse bereitgestellt werden, wenn bei der Anforderung  **
**  eines entsprechenden Blockes kein Block mehr frei war.               **
**                                                                       **
** Erstellung      : 10/10/90                                            **
** Letzte Aenderung: 10/10/90                                            **
** Autor           : Holger Naundorf                                     **
**************************************************************************/
 
#ifndef __MMMstorage_mem__
#define __MMMstorage_mem__


long MMMV_mem_init [MMMCupper_index+1] = 
{
0, /*0*/ /*dieser Wert muss 0 bleiben!!!!!!*/
4,
4,
4,
4,
4, /*5*/
4,
4,
4,
4,
4, /*10*/
4,
4,
4,
4,
4, /*15*/
4,
4,
4,
4,
4, /*20*/
4,
4,
4,
4,
4, /*25*/
4,
4,
4,
4,
4, /*30*/
4,
4,
4,
4,
4, /*35*/
4,
4,
4,
4,
4, /*40*/
4,
4,
4,
4,
4, /*45*/
4,
4,
4,
4,
4, /*50*/
4,
4,
4,
4,
4, /*55*/
4,
4,
4,
4,
4, /*60*/
4,
4,
4
} ;

long MMMV_mem_step [MMMCupper_index+1] =
{
1, /*0*/  /*Dieser Eintrag muss den Wert 1 behalten!!*/
30,
100,
30,
30,
4, /*5*/
4,
4,
4,
4,
4, /*10*/
4,
4,
4,
4,
4, /*15*/
4,
4,
4,
4,
4, /*20*/
4,
4,
4,
4,
4, /*25*/
4,
4,
4,
4,
4, /*30*/
4,
4,
4,
4,
4, /*35*/
4,
4,
4,
4,
4, /*40*/
4,
4,
4,
4,
4, /*45*/
4,
4,
4,
4,
4, /*50*/
4,
4,
4,
4,
4, /*55*/
4,
4,
4,
4,
4, /*60*/
4,
4,
4
} ;

#endif /* __MMMstorage_mem__ */
