/*
 * MUT_registration.h -- routines for creating and validating license keys
 */

#ifndef __MUT_registration_h__
#define __MUT_registration_h__

char *MupMakeUserLicKey(const char *name);
char *MupMakeCampusLicKey(const char *name);
char *MupMakeProdKey(const char *prefix);
int MupCheckKey(const char *name, const char *key);
int MupCheckCampusKey(const char *name, const char *key);

#ifdef WIN32
char *MupMakeUserRegKey(const char *name);
int MupCheckUserRegKey(const char *name, const char *key);
char *MupMakeCampusRegKey(const char *name);
int MupCheckCampusRegKey(const char *name, const char *key);
#endif

#endif /* ! __MUT_registration_h__ */
