#
Erzeuge alle k-Tupel natuerlicher Zahlen [n_1, ... ,n_r], 
fuer die n_1 + ... + n_r = n ist, und n_i >= 1.
composition(n, k) liefert [], falls n, k < 1 oder n < k
#

combinat::composition := proc(n, k)
begin

  if testargs() then
     if args(0) <> 2 then
        error("")
     elif type(n) <> DOM_INT or type(k) <> DOM_INT then
        error("")
     end_if
  end_if;

  combinat::comp(k, n, 1, [], [])

end_proc:

# Erzeuge alle r-Tupel natuerlicher Zahlen [k_1, ... ,k_r],  #
# fuer die k_1 + ... + k_r = n ist, und k_i >= s.            #
#                                                            #
# Aufruf: combinat::comp(r, n, s, [], []);                   #
# >> combinat::comp(2,5,1,[],[]);                            #
#                                                            #
#                    [[1, 4], [2, 3], [3, 2], [4, 1]]        #
#                                                            #
# >> combinat::comp(2,5,2,[],[]);                            #
#                                                            #
#                            [[2, 3], [3, 2]]                #
 
 
combinat::comp := proc(r, n, s, global_list, list)
  local i, l;
begin
       l := global_list;
       if r = 1 then
         append(global_list, append(list, n));
       else
         for i from s to n-s do
           l := combinat::comp(r-1, n-i, s, l, append(list, i));
         end_for
       end_if
end_proc:
