# $Date: 1995/08/25 18:59:50 $ $Author: kg $ $Revision: 1.4 $ #
#++
Ax::cancellation -- the cancellation law for a commutative operation

The cancellation law states that for a commutative operation op
op(a,b) = op(a,c) implies b = c.

Ax::cancellation(o)

o - the name of the operation (string)
++#

Ax::cancellation:= AxiomConstructor(
    Ax::cancellation,
    [ operator ],
    [ ],
    (if args(0) <> 1 then error("wrong no of args") end_if;
     if domtype(operator) <> DOM_STRING then
	error("wrong operator name")
     end_if)
):

