# $Date: 1995/08/25 19:00:03 $ $Author: kg $ $Revision: 1.4 $
#
#++
Ax::unitElement -- the axiom constructor about the existence of an unit element
	       for an operation

Ax::unitElement(e, o)

e - name of the unit element (string)
o - name of the operation (string)

The axiom states that op(e, x) = x for each x.
++#

Ax::unitElement:= AxiomConstructor(
    Ax::unitElement,
    [ element, operator ],
    [ ],
    (if args(0) <> 2 then error("wrong no of args") end_if;
     if domtype(element) <> DOM_STRING then
        error("wrong element name")
     end_if;
     if domtype(operator) <> DOM_STRING then
        error("wrong operator name")
     end_if)
):

