#++
Cat::OrderedAbelianMonoid -- the category of ordered ableian monoids

It is always assumed that the ordering is compatible with the
monoid operation, i.e. x < y => x+z < y+z and this::zero is the
smallest element of the monoid.

Author: Werner M. Seiler, Uni Karlsruhe
Created: July 1st, 1997
Last update: August 5th, 1997
++#

Cat::OrderedAbelianMonoid := CategoryConstructor(
	Cat::OrderedAbelianMonoid,
	[],
	[],
	NIL,
	[Cat::AbelianMonoid, Cat::OrderedSet],
	[]
)():
