# $Date: 1995/08/25 19:01:32 $ $Author: kg $ $Revision: 1.8 $ #
#++
Cat::SemiGroup -- the category of semi-groups

A Cat::SemiGroup is a Cat::SetCat with an associative operation '*'.

Methods:
_mult(x1,x2,...) - returns the product of x1*x2*...
_power(x,i)      - returns x*x*...*x (i times) for a positive integer i
++#

Cat::SemiGroup:= CategoryConstructor(
    Cat::SemiGroup,
    [],
    [],
    NIL,
    [ Cat::SetCat ],
    [],

    "_mult",

    "_power" = domains::repeatedSquaring(this, "_mult")

)():

