# $Date: 1997/10/10 15:55:36 $ $Author: tonner $ $Revision: 1.6 $ #

#++
subsArgs -- substitute actual parameters of domain for formal
            parameters of domain constructor into expression
            and evaluate the expression

subsArgs(e, D, this)

e    - expression to substitute actual parameters into
D    - domain which defines the expression and the parameters
this - domain for which expression is to be created
++#

DomainConstructor::subsArgs:= proc()
    option noDebug;
begin
    if nops((args(2))::constructor_args) = 0 then
        eval(subs(args(1), hold(this)=args(3), Unsimplified))
    else
        eval(subs(args(1), [ hold(this)=args(3),
            op(zip(extop((args(2))::constructor,2),
            	   (args(2))::constructor_args,
            	   _equal)) ],
	    Unsimplified))
    end_if
end_proc:

# end of file #
