# p is a polynomial (DOM_POLY) whose 3rd operand is neither Expr nor IntMod(...) #
faclib::domfact := proc(p) local q,xx,i;
begin	
   q:=op(p,3);
   if op(q,[4,2,0])=hold(Poly) then
	xx:=factor(poly(p,op(p,2).op(q,[4,2,1]),op(q,[4,2,2])));
	for i from 2 to nops(xx) step 2 do 
		xx[i]:=poly(xx[i],op(p,2..3));
	end_for;
	xx
   elif q::constructor=Dom::IntegerMod and nops(op(p,2))=1 then
      xx:=IntMod(op(q::constructor_args));
      p:=subs(factor(subsop(p,3=xx)),xx=q);
      subsop(p,1=q(p[1]))
   elif q=Dom::Rational or q=Dom::Integer or q::constructor=Dom::ExpressionField then
      subs(factor(poly(p,Expr)),Expr=q)
   elif q::constructor=Dom::AlgebraicExtension and nops(op(p,2))=1 then
      faclib::algfactor(p,TRUE)
   elif q::constructor=Dom::GaloisField and nops(op(p,2))=1 then
      faclib::factorgf(p)
   else
      if q::hasProp(Cat::Field) then
         # if nops(op(p,2))=2 then faclib::bifactor(p) #
         if nops(op(p,2))>1 then
		 faclib::multifactor(p)
         else
            error("cannot factor univariate polynomials over arbitrary fields")
	 end_if
      elif q::constructor=Dom::DistributedPolynomial then
	    factor(poly(p,q::constructor_args[1].op(p,2),q::constructor_args[2]))
      else
        error("can only factor over fields or polynomial rings")
      end_if
   end_if
end_proc:
