# $Date: 1996/06/28 09:04:05 $ $ Author: yuan $ #

#-- 
faclib::rr -- generate a global form of random number in -[p/2]..[p/2], output
              is an integer number.

faclib::rr(p)
p - a positive integer number

faclib::rr may be called by faclib::ufactor many times with the same input number, so set "option remember", the form may also be used by faclib::canzas many times, so faclib::Rc is a global variable
--#

faclib::rr:=proc(p)
local p2;
option remember;
begin
p2:=p div 2;
sysassign(faclib::Rc, random(-p2..p2));
end_proc:
