# $Date: 1996/07/05 15:04:42 $ $Author: snoo $ $Revision: 1.3 $ #
# kg, 19/09/95 #

#++
fp::fold -- create folded function

fp::fold(f, [e...])
f - function
e - expression

fold(f,e) returns the function 
	() +-> e,
	(x1,x2,...,xn) +-> f(xn,...f(x2,f(x1,e))...)
++#

fp::fold:= fun((
    if args(0) = 0 then error("no argument") end_if;
    newpurefunc("fun(...)", NIL,
	subsop(hold((
		    0; 
		    e;
		    while %2 <> args(0) do
			%2+1;
			f(args(%), %2)
		    end_while
		   )),
	       2=args(2..args(0)), [3,2,2,0]=args(1)))
)):

# end of file #
