# $Date: 1996/07/05 15:04:43 $ $Author: snoo $ $Revision: 1.3 $ #
# kg, 19/09/95 #

#++
fp::nest -- repeated composition of function

fp::nest(f, n)
f - function
n - non-negative integer

nest(f,n) returns the function x +-> f(f(...f(x)...)) where the
composition of f is n-fold repeated. I.e. nest is the function
	(f,0) +-> id,
	(f,n) +-> f @ nest(f, n-1) for n > 0.
++#

fp::nest:= fun((
    if testargs() then
        if args(0) <> 2 then error("wrong no of args") end_if;
        if not testtype(args(2), Type::NonNegInt) then
            error("illegal power")
        end_if
    end_if;
    case args(2)
    of 0 do return(id);
    of 1 do return(args(1));
    end_case;
    newpurefunc("fun(...)", NIL,
    	subsop(hold(_fconcat(f $ n)(args())),
    	       [0,1,1]=args(1), [0,1,2]=args(2)))
)):

# end of file #
