# $Date: 1997/07/03 08:10:38 $ $Author: stefanw $ $Revision: 1.3 $ #

# kg, 20/02/95 #

#--
groebner::primpart -- make rational non-zero polynomial primitive

groebner::primpart(p)

p - non-zero rational polynomial

additional argument o does no harm if given
--#

groebner::primpart:=
	fun(multcoeffs(args(1), 1/icontent(args(1)))):


#--
groebner::normalize -- normalize non-zero polynomial over field

groebner::normalize(p, o)

p - non-zero polynomial over field
o - term ordering 
--#

groebner::normalize:=
	fun(multcoeffs(args(1), 1/groebner::lcoeff(args(1), o))):

# end of file #
