# frankp, 070499 #
# This method implementes the integration routine for 
  objects of type DOM_POLY.
#
DOM_POLY::int:= proc(p,xx)
  name DOM_POLY::int;
  local e, X, x, result;
begin
  if args(0) = 1 then
    x:= op(p,2);
    if nops(x) <> 1 then
      error("need integration variable")
    else
      x:= op(x,1)
    end_if
  elif type(xx) = "_equal" then
    X:= op(xx,1);
    e:= op(xx,2);
    if type( e ) <> "_range" then
      error("no range of integration")
    end_if;

    result:= DOM_POLY::int( p,X,args(3..args(0)) );
    return( evalp( result,X=op(e,2) ) - evalp( result, X=op(e,1) ) )
  else
    x:=xx
  end_if;

  e:= op(p,1);
  if domtype(x) <> DOM_IDENT then
    # substitute x by a free identifier #
    e:= eval(subs( int( eval(subs( e,x=X )),X,args(3..args(0)) ), X=x ))
  else
    e:= int( e,x,args(3..args(0)) )
  end_if;

  return( subsop(p,1=e) )
end_proc:

