# $Date: 1996/11/15 11:59:58 $ $Author: zimmerma $ $Revision: 1.5 $ #
#--
intlib::insert(f) - adds a new extension to the tower of field extensions if
necessary.
--#
intlib::insert:=proc(j,operator,L)
  local i,x,T;
# global n,k,k_sub,k_ident,k_diff,k_deg,k_alg,Q,Q_sub; #
begin
  if nops({op(k_sub)} intersect indets(L))>0
    then if (i:=contains(k,operator(L)))>0 then return(k_sub[i]); end_if;
         T:=intlib::algdep(operator(L),n);
#tt
         if test then print("towermin->",T); end_if;
tt#
         if T[2]=1 then return(normal(T[1])); end_if;
         if (i:=contains(k_sub,T[1]))>1
           then
                k[i]:=operator(L); 
                k_deg[i] :=j;
               k_diff[i]:=lcoeff(poly(intlib::diffs(operator(L),n),[k_sub[n]]));
#               don't remove the further extensions, e.g.
 		int(-exp(x^2)^(-1/2)*(x^3 + Y^2*x), x)
		for j from i+1 to n do
                  k[i+1]:=NIL; k_sub[i+1]:=NIL; k_deg[i+1]:=NIL;
                  k_ident[i+1]:=NIL; k_diff[i+1]:=NIL; k_alg[i+1]:=NIL;
                end_for; #
                return(FALSE);
         end_if;
 
         x:=genident();
         k      :=append(k,operator(L));
         k_sub  :=append(k_sub,x);
         k_deg  :=append(k_deg,j);
         k_ident:=append(k_ident,genident());
         n:=n+1;
         k_diff:=append(k_diff,
                        lcoeff(poly(intlib::diffs(operator(L),n),[k_sub[n]])));
         if T[2]>0 then k_alg  :=append(k_alg,poly(x^T[2]-T[1],[x]));
                   else k_alg  :=append(k_alg,0);
         end_if;
         return(x);
    else if (i:=contains(Q,operator(L)))>0
           then return(Q_sub[i]);  
           else x:=genident(); Q:=append(Q,operator(L)); Q_sub:=append(Q_sub,x);
                return(x);
         end_if;
  end_if;
end_proc:
