proc()
    option noDebug;
  local dir;
begin
  combinat:=domain("combinat"):
  combinat::info:="Library 'combinat':  combinatorial functions":
  combinat::interface:={hold(bell), hold(partitions), hold(permute), 
                        hold(powerset), hold(stirling1), hold(stirling2),
			hold(cartesian), hold(composition), hold(choose)}:

  dir:= pathname("COMBINAT"):

combinat::permute:= loadproc(combinat::permute, dir, "permute"):
combinat::powerset:= loadproc(combinat::powerset, dir, "powerset"):
combinat::stirling1:= loadproc(combinat::stirling1, dir, "stirl1"):
combinat::stirling2:= loadproc(combinat::stirling2, dir, "stirl2"):
combinat::partitions:= loadproc(combinat::partitions, dir, "parts"):
combinat::bell:= loadproc(combinat::bell, dir, "bell"):
combinat::cartesian:= loadproc(combinat::cartesian, dir, "cartes"):
combinat::composition:= loadproc(combinat::composition, dir, "composit"):
combinat::choose:= loadproc(combinat::choose, dir, "choose"):

stdlib::LoadlibState["combinat"]:= TRUE:

  null():
end_proc():

