# $Date: 1997/10/10 15:55:57 $ $Author: tonner $ $Revision: 1.30 $ #
#++
domains -- a library for constructing domains and categories
++#

proc()
  option noDebug;
  local path;
begin

domains:= domain("domains"):
domains::info:= "Library 'domains': Constructing domains and categories":
domains::interface:= { hold(show_type), hold(hasProp) }:
domains::SHOW_TYPE:= FALSE:

domains::show_type:= fun((
    if domtype(args(1)) <> DOM_BOOL then error("illegal argument") end_if;
    domains::SHOW_TYPE:= args(1)
)):

path := pathname("DOMAINS", "CONSTR");
domains::hasProp:= loadproc(domains::hasProp, path, "DChasPro"):

path := pathname("DOMAINS", "CATEGORY");
domains::repeatedSquaring:= loadproc(domains::repeatedSquaring, path, "rep_sq"):

stdlib::LoadlibState["domains"]:= TRUE:

end_proc():

# end of file #
