proc()
    option noDebug;
  local dir,dir2;
begin
  intlib:=domain("intlib"):
  intlib::info:="Library 'intlib':  Symbolic Integration":
  intlib::interface:={hold(int),hold(equal),hold(simplify)}:

  dir:= pathname("INTLIB"):

intlib::_proof:= loadproc(intlib::_proof,dir,"_proof"):
intlib::algdep:= loadproc(intlib::algdep,dir,"algdep"):
intlib::algred:= loadproc(intlib::algred,dir,"algred"):
intlib::bound:= loadproc(intlib::bound,dir,"bound"):
intlib::diffs:= loadproc(intlib::diffs,dir,"diffs"):
intlib::equal:= loadproc(intlib::equal,dir,"equal"):
# now use the standard function gcdex #
# intlib::gcdex:= loadproc(intlib::gcdex,dir,"gcdex"): #
intlib::gcdk_n:= loadproc(intlib::gcdk_n,dir,"gcdk_n"):
intlib::hermite:= loadproc(intlib::hermite,dir,"hermite"):
intlib::insert:= loadproc(intlib::insert,dir,"insert"):
intlib::int:= loadproc(intlib::int,dir,"int"):
intlib::intt:= loadproc(intlib::intt,dir,"intt"):
intlib::inttest:= loadproc(intlib::inttest,dir,"inttest"):
intlib::linsys:= loadproc(intlib::linsys,dir,"linsys"):
intlib::lookup:= loadproc(intlib::lookup,dir,"lookup"):
intlib::pde_exp:= loadproc(intlib::pde_exp,dir,"pde_exp"):
intlib::pde_var:= loadproc(intlib::pde_var,dir,"pde_var"):
intlib::pde_ln:= loadproc(intlib::pde_ln,dir,"pde_ln"):
intlib::pdioe:= loadproc(intlib::pdioe,dir,"pdioe"):
intlib::primpart:= loadproc(intlib::primpart,dir,"primpart"):
# intlib::quad:= loadproc(intlib::quad,dir,"quad"): #
# intlib::risch:= loadproc(intlib::risch,dir,"risch"): #
intlib::rlti:= loadproc(intlib::rlti,dir,"rlti"):
intlib::sim:= loadproc(intlib::sim,dir,"sim"):
# intlib::simpl:= loadproc(intlib::simpl,dir,"simpl"):  #
intlib::simplify:= loadproc(intlib::simplify,dir,"simplify"):
intlib::solveRde:= loadproc(intlib::solveRde,dir,"solveRde"):
intlib::spde:= loadproc(intlib::spde,dir,"spde"):
intlib::split1:= loadproc(intlib::split1,dir,"split1"):
intlib::split2:= loadproc(intlib::split2,dir,"split2"):
intlib::sqffTab:= loadproc(intlib::sqffTab,dir,"sqffTab"):
intlib::sub:= loadproc(intlib::sub,dir,"sub"):
intlib::subres:= loadproc(intlib::subres,dir,"subres"):
intlib::subst:= loadproc(intlib::subst,dir,"subst"):
intlib::tower:= loadproc(intlib::tower,dir,"tower"):
intlib::weaknorm:= loadproc(intlib::weaknorm,dir,"weaknorm"):
intlib::changevar:= loadproc(intlib::changevar,dir,"changevr"):
intlib::hyperint:= loadproc(intlib::hyperint,dir,"hint"):
intlib::gaussian:= loadproc(intlib::gaussian,dir,"gaussian"):
intlib::besselJ:= loadproc(intlib::besselJ,dir,"besselJ"):
intlib::byparts:= loadproc(intlib::byparts,dir,"byparts"):
# integration of special functions #
intlib::bigOhInt:= loadproc(intlib::bigOhInt,dir,"specfunc"):
intlib::diracInt:= loadproc(intlib::diracInt,dir,"diracInt"):
intlib::diracDef:= loadproc(intlib::diracDef,dir,"diracInt"):
intlib::heavisideInt:= loadproc(intlib::heavisideInt,dir,"heaviInt"):
intlib::specialFunctionDef:=
  loadproc(intlib::specialFunctionDef,dir,"specfunc"):
intlib::specialFunctionInt:=
  loadproc(intlib::specialFunctionInt,dir,"specfunc"):


  dir2:= pathname("INTLIB", "NUMERIC"):

intlib::numint   := loadproc(intlib::numint,dir2,"numint"):
intlib::improper := loadproc(intlib::improper,dir2,"improper"):
intlib::oscillate:= loadproc(intlib::oscillate,dir2,"osc"):
intlib::ncquad   := loadproc(intlib::ncquad,dir2,"ncquad"):
intlib::ccquad   := loadproc(intlib::ccquad,dir2,"ccquad"):
intlib::transform:= loadproc(intlib::transform,dir2,"trans"):
intlib::singleft := loadproc(intlib::singleft,dir2,"singleft"):
intlib::makeproc := loadproc(intlib::makeproc,dir2,"makeproc"):
intlib::float    := loadproc(intlib::float,dir2,"float"):


# definite integration #

  dir2:= pathname("INTLIB", "DEFINITE"):

intlib::match:= loadproc(intlib::match,dir2,"match"):
intlib::intdef:= loadproc(intlib::intdef,dir2,"intdef"):
intlib::matchassign:= loadproc(intlib::matchassign,dir2,"match"):

stdlib::LoadlibState["intlib"]:= TRUE:

  null():
end_proc():

