# $Date: 1997/10/10 15:56:06 $ $Author: tonner $ $Revision: 1.22 $ #

# kg, 13/12/94 #

#--
misc.mu -- define/load auxiliary functions
--#

proc()
    option noDebug;
    local path;
begin

misc:= domain("misc"):

misc::info:= "Library 'misc': General utilities":
misc::interface:= {
    hold(checkFunction),
    hold(checkLib),
    hold(subsFreeVars),
    hold(genassop),
    hold(testinit),
    hold(testfunc),
    hold(test),
    hold(makelib),
    hold(tcov),
    hold(checkexample),
    hold(freeze),
    hold(unfreeze),
    hold(subsFunArgs),
    hold(mapFun),
    hold(tableForm),
    hold(minimalDomain)
}:

path:= pathname("MISC"):

misc::checkFunction:= loadproc(misc::checkFunction, path, "checkfct"):
misc::checkLib:= loadproc(misc::checkLib, path, "checklib"):
misc::checkAll:= loadproc(misc::checkAll, path, "checklib"):
misc::genassop:= loadproc(misc::genassop, path, "genassop"):
misc::testinit:= loadproc(misc::testinit, path, "test"):
misc::testfunc:= loadproc(misc::testfunc, path, "test"):
misc::test:= loadproc(misc::test, path, "test"):
misc::subsFreeVars:= loadproc(misc::subsFreeVars, path, "subFrVar"):
misc::makelib:= loadproc(misc::makelib, path, "makelib"):
misc::tcov:= loadproc(misc::tcov, path, "tcov"):
misc::checkexample:= loadproc(misc::checkexample, path, "checkexa"):
misc::freeze:= loadproc(misc::freeze, path, "freeze"):
misc::unfreeze:= loadproc(misc::unfreeze, path, "freeze"):
misc::subsFunArgs:= loadproc(misc::subsFunArgs, path, "subsFunA"):
misc::mapFun:= loadproc(misc::mapFun, path, "mapFun"):
misc::tableForm:= loadproc(misc::tableForm, path, "tabForm"):
misc::minimalDomain:= loadproc(misc::minimalDomain, path, "minDom"):

stdlib::LoadlibState["misc"]:= TRUE:

end_proc():

# end of file #
