proc()
  option noDebug;
  local dir;
begin
  string:=domain("string"):
  string::info:="Library 'string':  Utilities for string manipulation":
  string::interface:={hold(contains), hold(subs), hold(subsop),
                      hold(delete), hold(format), hold(formatf), hold(pos)}:

  dir:= pathname("STRING"):

  string::match    := loadproc(string::match   , dir, "match"   ):
  string::contains := loadproc(string::contains, dir, "contains"):
  string::subs     := loadproc(string::subs    , dir, "subs"    ):
  string::subsop   := loadproc(string::subsop  , dir, "subsop"  ):
  string::delete   := loadproc(string::delete  , dir, "delete"  ):
  string::format   := loadproc(string::format  , dir, "format"  ):
  string::formatf  := loadproc(string::formatf , dir, "formatf" ):
  string::pos      := loadproc(string::pos     , dir, "pos"     ):

  string::FirstIndex := 0:

  stdlib::LoadlibState["string"]:= TRUE:

  null():
end_proc():

