Tableau:=DomainConstructor(     

# name            #
                        Tableau,        
# arguments       #
                        [],     
# local variables #
                        [],     
# initialisation  #
                        Nil,    
# super-domains   #
                        Dom::BaseDomain,        
# categories      #
                        [],     
# axioms          #
                        [],             
# elements        #
                        "_index"        =       fun((if args(0) = 3 
                                                     then (op(args(1),1)[args(2),args(3)]) 
                                                     else (op(args(1),args(2))) end_if)),
                        "index_val"     =       fun((if args(0) = 3 
                                                     then (op(args(1),1)[args(2),args(3)]) 
                                                     else (op(args(1),args(2))) end_if)),


                        "set_index"     =       proc(T,i,j,z)
                                                local tbl;

                                                begin
                                                  tbl := op(T,1):
                                                  tbl[i,j] := z: 
                                                  new(this,tbl,op(T,2),op(T,3),op(T,4),op(T,5),op(T,6),
                                                                op(T,7),op(T,8),op(T,9),op(T,10),op(T,11))
                                                end_proc,
                                                
                        "new"           =       proc(list)                              # [{eqs},gfct] : min gfct(x) under Ax <= b expctd

                                                                                          return : [tbl,m,n,internalorder]  #
                                                                                                


                                                local   tbl,m,n,identset,equations,gfct,unlimited,scrollanz,interval,
                                                        internalorder,                  # order of variables               #
                                                        identlist,                      # set and list of variables        #
                                                        inteq,                          # internal (un)-equation           #
                                                        unequations,                    # set of unequations               #
                                                        constraints,                    # set of constraints               #
                                                        gezero,                         # set of unequations >= 0          #
                                                        muneqs,mgez,                    # number of unequations            # 
                                                        h,                              # help variable                    #
                                                        i,j,                            # index for loops                  #
                                                        lowbounded,upbounded,           # sets of bounded variables        #
                                                        slk,scr;                        # array with slackvariables        #

                                                begin
                                                  Tableau::unset():
                                                  if testargs()
                                                  then 
                                                    if args(0) <> 1 then 
                                                        error("One list with set of (un)-equations and goalfunction expected")
                                                    end_if:

                                                    if (nops(list) < 2) or (nops(list) > 3)                                     # input list ok? #
                                                    then error("List with set of (un)-equations and goalfunction expected")
                                                    end_if: 

                                                    if not testtype(op(list,1),DOM_SET) 
                                                    then error("Set of (un)-equations expected")
                                                    end_if:

                                                    gfct := op(list,2):
                                                    if (domtype(gfct) <> DOM_EXPR) and (domtype(gfct) <> DOM_IDENT) and not 
                                                        (testtype(gfct,DOM_INT) or testtype(gfct,DOM_FLOAT) or testtype(gfct,DOM_RAT))
                                                    then error("No correct goalfunction specified")
                                                    end_if:
                                                    
                                                    if nops(list) >= 3 then 
                                                        if testtype(op(list,3),DOM_SET)
                                                        then for i from 1 to nops(op(list,3)) do
                                                               if not testtype(op(list,[3,i]),DOM_IDENT) then
                                                                 print(op(list,[3,i])):
                                                                 error("Set of restricted variables expected")
                                                               end_if:
                                                             end_for
                                                        elif (op(list,3) <> NONNEGATIVE)
                                                          then print(op(list,3)): 
                                                               error("Set of restricted variables expected") 
                                                          end_if: 
                                                     end_if:
        
                                                    unequations := {}:
                                                    equations := {}:
                                                    gezero := {}:
                                                    constraints := op(list,1):
                                                    identset :={}:

                                                    upbounded := {}:
                                                   
                                                    if nops(list) >= 3 and testtype(op(list,3),DOM_SET) 
                                                    then for i in op(list,3) do
                                                           interval[i,greater] := 0
                                                         end_for:
                                                         lowbounded := op(list,3)
                                                    else lowbounded := {}
                                                    end_if:                                             



#*************************************************************************************************************************************************************#



                                                    i := 1:
                                                    while i <= nops(constraints) do                                      # search for x with
                                                                                                                           a <= x or x <= b #
                                                        case type(op(constraints,i)) 
                                                        of "_leequal" do
                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs (inteq,equations):
                                                            
                                                             if testtype(inteq,"_plus") and (nops(inteq) = 2)  
                                                             then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                       testtype(op(inteq,2),DOM_FLOAT) or 
                                                                       testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                     ( testtype(op(inteq,1),DOM_IDENT) or
                                                                       testtype(op(inteq,1),"_mult") )
                                                                  then if testtype(op(inteq,1),"_mult")
                                                                       then if ( testtype(op(inteq,[1,2]),DOM_INT  ) or
                                                                                 testtype(op(inteq,[1,2]),DOM_FLOAT) or 
                                                                                 testtype(op(inteq,[1,2]),DOM_RAT  ) ) and 
                                                                                 testtype(op(inteq,[1,1]),DOM_IDENT)
                                                                            then if nops(list) >= 3
                                                                                 then if (op(list,3) = NONNEGATIVE or 
                                                                                         contains(op(list,3),op(inteq,[1,1]))) and 
                                                                                        testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                      then interval[op(inteq,[1,1]),greater] := 0:
                                                                                           lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                      end_if
                                                                                 end_if: 
                                                                                 if op(inteq,[1,2]) < 0 
                                                                                 then if not testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                      then if interval[op(inteq,[1,1]),greater] < -op(inteq,2)/op(inteq,[1,2])
                                                                                           then interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                                lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                           end_if
                                                                                      else interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                           lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                      end_if
                                                                                 elif not testtype(interval[op(inteq,[1,1]),lower],"_index")
                                                                                      then if interval[op(inteq,[1,1]),lower] > -op(inteq,2)/op(inteq,[1,2])
                                                                                           then interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                                upbounded := upbounded union {op(inteq,[1,1])}
                                                                                           end_if
                                                                                      else interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                           upbounded := upbounded union {op(inteq,[1,1])}
                                                                                 end_if
                                                                            else print(op(constraints,i)):
                                                                                 error("Linear optimization only!")
                                                                            end_if
                                                                       else if nops(list) >= 3
                                                                            then if (op(list,3) = NONNEGATIVE or 
                                                                                         contains(op(list,3),op(inteq,1))) and
                                                                                      testtype(interval[op(inteq,1),greater],"_index")
                                                                                 then interval[op(inteq,1),greater] := 0:
                                                                                      lowbounded := lowbounded union {op(inteq,1)}
                                                                                 end_if
                                                                            end_if:
                                                                            if not testtype(interval[op(inteq,1),lower],"_index")
                                                                            then if interval[op(inteq,1),lower] > -op(inteq,2)
                                                                                 then interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                      upbounded := upbounded union {op(inteq,1)}
                                                                                 end_if
                                                                            else interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                 upbounded := upbounded union {op(inteq,1)} 
                                                                            end_if
                                                                       end_if
                                                                  else i := i+1: break
                                                                  end_if
                                                             elif testtype(inteq,"_mult")
                                                               then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                         testtype(op(inteq,2),DOM_FLOAT) or 
                                                                         testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                         testtype(op(inteq,1),DOM_IDENT)
                                                                    then if nops(list) >= 3
                                                                         then if (op(list,3) = NONNEGATIVE or 
                                                                                 contains(op(list,3),op(inteq,1))) and
                                                                                 testtype(interval[op(inteq,1),greater],"_index")
                                                                              then interval[op(inteq,1),greater] := 0:
                                                                                   lowbounded := lowbounded union {op(inteq,1)}
                                                                              end_if
                                                                         end_if:
                                                                         if op(inteq,2) < 0 
                                                                         then if not testtype(interval[op(inteq,1),greater],"_index")
                                                                              then if interval[op(inteq,1),greater] < 0
                                                                                   then interval[op(inteq,1),greater] := 0:
                                                                                        lowbounded := lowbounded union {op(inteq,1)}
                                                                                   end_if
                                                                              else interval[op(inteq,1),greater] := 0:
                                                                                   lowbounded := lowbounded union {op(inteq,1)}
                                                                              end_if
                                                                         elif not testtype(interval[op(inteq,1),lower],"_index")
                                                                           then if interval[op(inteq,1),lower] > 0
                                                                                then interval[op(inteq,1),lower] := 0:
                                                                                     upbounded := upbounded union {op(inteq,1)}
                                                                                end_if
                                                                           else interval[op(inteq,1),lower] := 0:
                                                                                upbounded := upbounded union {op(inteq,1)}
                                                                         end_if:
                                                                    else print(op(constraints,i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                                elif testtype(inteq,DOM_IDENT)
                                                                  then if nops(list) >= 3
                                                                       then if (op(list,3) = NONNEGATIVE or contains(op(list,3),inteq)) and 
                                                                                testtype(interval[inteq,greater],"_index")
                                                                            then interval[inteq,greater] := 0:
                                                                                 lowbounded := lowbounded union {inteq}
                                                                            end_if
                                                                       end_if:
                                                                       if not testtype(interval[inteq,lower],"_index")
                                                                       then if interval[inteq,lower] > 0 then
                                                                              interval[inteq,lower] := 0:
                                                                              upbounded := upbounded union {inteq}
                                                                            end_if
                                                                       else interval[inteq,lower] := 0:
                                                                            upbounded := upbounded union {inteq} 
                                                                       end_if
                                                                  else i := i+1: break
                                                             end_if:

                                                             constraints := constraints minus {op(constraints,i)}:
                                                            
                                                             break
                                                        of "_equal" do
                                                             i := i+1: 
                                                             break
                                                        otherwise 
                                                             print(op(constraints,i)):
                                                             error("Set of (un)-equations expected"):
                                                             break
                                                        end_case:
                                                
                                                    end_while:                                                          # a <= x <= b #
#print(upbounded):print(lowbounded):#
                                                    j := 1:                                                             # insert scrolling vars 
                                                                                                                          for [b >=] x >= a :-> 
                                                                                                                          [b-a >=] y = x-a >= 0 #
                                                    h := {}:
                                                    i := 1:

                                                    while i <= nops(lowbounded) do

                                                        if interval[op(lowbounded,i),greater] <> 0
                                                        then interval[scr[j],greater] := 0:
                                                             if not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                               if  interval[op(lowbounded,i),greater] > interval[op(lowbounded,i),lower] 
                                                               then return(this::leer()) 
                                                               end_if:
                                                               if interval[op(lowbounded,i),greater] = interval[op(lowbounded,i),lower]
                                                               then equations := subs(equations,{op(lowbounded,i)=interval[op(lowbounded,i),greater]}) 
                                                                                 union {op(lowbounded,i)=interval[op(lowbounded,i),greater]}: 
                                                                    upbounded := upbounded minus {op(lowbounded,i)}:
                                                                    lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                    next
                                                               end_if:
                                                               interval[scr[j],lower] := interval[op(lowbounded,i),lower]-interval[op(lowbounded,i),greater]:
                                                               h := h union {scr[j]}:
                                                               upbounded := upbounded union {scr[j]}:
                                                               subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                               equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                            union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                               upbounded := upbounded minus {op(lowbounded,i)}:
                                                               lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                               j := j+1:
                                                               next
                                                             end_if:
                                                             h := h union {scr[j]}:
                                                             subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                             equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                          union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                             upbounded := upbounded minus {op(lowbounded,i)}:
                                                             lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                             upbounded := upbounded union {scr[j]}:                                                     
                                                             j := j+1:
                                                             next
                                                        elif not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                            if 0 > interval[op(lowbounded,i),lower] then return(this::leer()) end_if:
                                                            if 0 = interval[op(lowbounded,i),lower]
                                                            then equations := subs(equations,{op(lowbounded,i)=0}) union {op(lowbounded,i)=0}:
                                                                 upbounded := upbounded minus {op(lowbounded,i)}:
                                                                 lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                 next
                                                            end_if:
                                                        end_if:
                                                        i := i+1
                                                    end_while:

                                                    lowbounded := h union lowbounded:
#print(lowbounded):#
                                                    h := {}:
                                                    for i in (upbounded minus lowbounded) do                              # insert scrolling vars
                                                                                                                            for b >= x :-> y = b-x >= 0 #
                                                        #if interval[i,lower] <> 0
                                                        then# interval[scr[j],greater] := 0:
                                                             lowbounded := lowbounded union {scr[j]}:
                                                             subs(constraints,{i=-scr[j]+interval[i,lower]}):
                                                             equations := subs(equations,{i=-scr[j]+interval[i,lower]}) union {i=-scr[j]+interval[i,lower]}:
                                                             h := h union {i}:
                                                             j := j+1
                                                        #end_if#
                                                    end_for:

                                                    upbounded := upbounded minus h:
#print(upbounded):print(lowbounded):#
                                                    scrollanz := j-1:



#*************************************************************************************************************************************************************#


                                                    i := 1:
                                                    while i <= nops(constraints) do                                     # build internal set of
                                                                                                                          equations # 
                                                        if testtype(op(constraints,i),"_leequal") 
                                                        then i := i+1: next end_if:
                                                             
                                                        
                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs(inteq,equations):
                                                             h := FALSE:

                                                             if testtype(inteq,"_plus")                                 # test all operands of 
                                                                                                                          the equation #
                                                             then for j from 1 to nops(inteq) do                        
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then if ( testtype(op(inteq,[j,2]),DOM_INT  ) or
                                                                              testtype(op(inteq,[j,2]),DOM_FLOAT) or 
                                                                              testtype(op(inteq,[j,2]),DOM_RAT  ) ) and 
                                                                            ( testtype(op(inteq,[j,1]),DOM_IDENT) or
                                                                              testtype(op(inteq,[j,1]),"_index") ) 
                                                                          then if not contains(lowbounded,op(inteq,[j,1])) and
                                                                                 (nops(list) < 3 or (op(list,3) <> NONNEGATIVE and 
                                                                                                     not contains(op(list,3),op(inteq,[j,1]))
                                                                                                    )
                                                                                 )
                                                                               then h := [op(inteq,[j,1]),-op(inteq,[j,2])]:
                                                                                    break:
                                                                               elif (h = FALSE) then
                                                                                   h := [op(inteq,[j,1]),-op(inteq,[j,2])]
                                                                               end_if
                                                                          else print(op(constraints,i)):
                                                                               error("Linear optimization only!")
                                                                          end_if
                                                                    elif testtype(op(inteq,j),DOM_IDENT) or testtype(op(inteq,j),"_index")
                                                                      then if not contains(lowbounded,op(inteq,j)) and
                                                                              (nops(list) < 3 or (op(list,3) <> NONNEGATIVE and 
                                                                                                     not contains(op(list,3),op(inteq,j))
                                                                                                 )
                                                                               )
                                                                            then h := [op(inteq,j),-1]:
                                                                                 break:
                                                                            elif (h = FALSE) then
                                                                                h := [op(inteq,j),-1]
                                                                            end_if
                                                                      elif not ( testtype(op(inteq,j),DOM_INT  ) or
                                                                                 testtype(op(inteq,j),DOM_FLOAT) or 
                                                                                 testtype(op(inteq,j),DOM_RAT  ) )
                                                                        then print(op(constraints,i)):
                                                                             error("Linear optimization only!")
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                         testtype(op(inteq,2),DOM_FLOAT) or 
                                                                         testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                       ( testtype(op(inteq,1),DOM_IDENT) or 
                                                                         testtype(op(inteq,1),"_index") )
                                                                    then h := [op(inteq,1),-op(inteq,2)]
                                                                    else print(op(constraints,i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                               elif testtype(inteq,DOM_IDENT) or testtype(inteq,"_index") 
                                                                 then h := [inteq,-1]
                                                                 elif not ( testtype(inteq,DOM_INT  ) or
                                                                            testtype(inteq,DOM_FLOAT) or 
                                                                            testtype(inteq,DOM_RAT  ) )
                                                                   then print(op(constraints,i)):
                                                                        error("Linear optimization only!")
                                                             end_if:
                                                
                                                             if h = FALSE 
                                                             then if bool(inteq <> 0) then return(this::leer()) end_if
                                                                  
                                                             else inteq := inteq + h[2]*h[1]:
                                                                  equations := {op(equations,[i,1]) = subs(op(equations,[i,2]),h[1]=inteq/h[2])
                                                                                $hold(i)=1..nops(equations)}: 

                                                                  equations := equations union {h[1]=inteq/h[2]}:
                                                                  identset := identset minus {h[1]}:
                                                                  gezero := {op(gezero,[i,1]) = subs(op(gezero,[i,2]),h[1]=inteq/h[2])
                                                                               $hold(i)=1..nops(gezero)}:
                                                                  if contains(lowbounded,h[1]) or
                                                                     (nops(list) >= 3 and (op(list,3)=NONNEGATIVE or contains(op(list,3),h[1]))) 

                                                                  then gezero := gezero union {h[1]=inteq/h[2]}:
                                                                       identset := identset union indets(inteq,PolyExpr):
                                                                       unlimited[h[1]] := FALSE:
                                                                  end_if
                                                             end_if:

                                                             constraints := constraints minus {op(constraints,i)}:
                                                                                                                        # equations #
                                                    end_while:


#*************************************************************************************************************************************************************#


                                                    i := 1:
                                                    while i <= nops(constraints) do                                      # search for x with
                                                                                                                           a <= x or x <= b #
                                                        if testtype(op(constraints,i),"_equal") 
                                                        then i := i+1: next end_if:

                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs (inteq,equations):
                                                            
                                                             if testtype(inteq,"_plus") and (nops(inteq) = 2)  
                                                             then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                       testtype(op(inteq,2),DOM_FLOAT) or 
                                                                       testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                     ( testtype(op(inteq,1),DOM_IDENT) or 
                                                                       testtype(op(inteq,1),"_index") or
                                                                       testtype(op(inteq,1),"_mult") )
                                                                  then if testtype(op(inteq,1),"_mult")
                                                                       then if ( testtype(op(inteq,[1,2]),DOM_INT  ) or
                                                                                 testtype(op(inteq,[1,2]),DOM_FLOAT) or 
                                                                                 testtype(op(inteq,[1,2]),DOM_RAT  ) ) and 
                                                                               ( testtype(op(inteq,[1,1]),DOM_IDENT) or 
                                                                                 testtype(op(inteq,[1,1]),"_index") )
                                                                            then if nops(list) >= 3
                                                                                 then if (op(list,3) = NONNEGATIVE or 
                                                                                         contains(op(list,3),op(inteq,[1,1]))) and 
                                                                                        testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                      then interval[op(inteq,[1,1]),greater] := 0:
                                                                                           lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                      end_if
                                                                                 end_if: 
                                                                                 if op(inteq,[1,2]) < 0 
                                                                                 then if not testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                      then if interval[op(inteq,[1,1]),greater] < -op(inteq,2)/op(inteq,[1,2])
                                                                                           then interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                                lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                           end_if
                                                                                      else interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                           lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                      end_if
                                                                                 elif not testtype(interval[op(inteq,[1,1]),lower],"_index")
                                                                                      then if interval[op(inteq,[1,1]),lower] > -op(inteq,2)/op(inteq,[1,2])
                                                                                           then interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                                upbounded := upbounded union {op(inteq,[1,1])}
                                                                                           end_if
                                                                                      else interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                           upbounded := upbounded union {op(inteq,[1,1])}
                                                                                 end_if
                                                                            else print(op(constraints,i)):
                                                                                 error("Linear optimization only!")
                                                                            end_if       
                                                                       else if nops(list) >= 3
                                                                            then if (op(list,3) = NONNEGATIVE or 
                                                                                         contains(op(list,3),op(inteq,1))) and
                                                                                      testtype(interval[op(inteq,1),greater],"_index")
                                                                                 then interval[op(inteq,1),greater] := 0:
                                                                                      lowbounded := lowbounded union {op(inteq,1)}
                                                                                 end_if
                                                                            end_if:
                                                                            if not testtype(interval[op(inteq,1),lower],"_index")
                                                                            then if interval[op(inteq,1),lower] > -op(inteq,2)
                                                                                 then interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                      upbounded := upbounded union {op(inteq,1)}
                                                                                 end_if
                                                                            else interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                 upbounded := upbounded union {op(inteq,1)} 
                                                                            end_if
                                                                       end_if
                                                                  else i := i+1: next
                                                                  end_if
                                                             elif testtype(inteq,"_mult")
                                                               then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                         testtype(op(inteq,2),DOM_FLOAT) or 
                                                                         testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                       ( testtype(op(inteq,1),DOM_IDENT) or
                                                                         testtype(op(inteq,1),"_index") )
                                                                    then if nops(list) >= 3
                                                                         then if (op(list,3) = NONNEGATIVE or 
                                                                                 contains(op(list,3),op(inteq,1))) and
                                                                                 testtype(interval[op(inteq,1),greater],"_index")
                                                                              then interval[op(inteq,1),greater] := 0:
                                                                                   lowbounded := lowbounded union {op(inteq,1)}
                                                                              end_if
                                                                         end_if:
                                                                         if op(inteq,2) < 0 
                                                                         then if not testtype(interval[op(inteq,1),greater],"_index")
                                                                              then if interval[op(inteq,1),greater] < 0
                                                                                   then interval[op(inteq,1),greater] := 0:
                                                                                        lowbounded := lowbounded union {op(inteq,1)}
                                                                                   end_if
                                                                              else interval[op(inteq,1),greater] := 0:
                                                                                   lowbounded := lowbounded union {op(inteq,1)}
                                                                              end_if
                                                                         elif not testtype(interval[op(inteq,1),lower],"_index")
                                                                           then if interval[op(inteq,1),lower] > 0
                                                                                then interval[op(inteq,1),lower] := 0:
                                                                                     upbounded := upbounded union {op(inteq,1)}
                                                                                end_if
                                                                           else interval[op(inteq,1),lower] := 0:
                                                                                upbounded := upbounded union {op(inteq,1)}
                                                                         end_if:
                                                                    else print(op(constraints,i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                                elif testtype(inteq,DOM_IDENT) or testtype(inteq,"_index")
                                                                  then if nops(list) >= 3
                                                                       then if (op(list,3) = NONNEGATIVE or contains(op(list,3),inteq)) and 
                                                                                testtype(interval[inteq,greater],"_index")
                                                                            then interval[inteq,greater] := 0:
                                                                                 lowbounded := lowbounded union {inteq}
                                                                            end_if
                                                                       end_if:
                                                                       if not testtype(interval[inteq,lower],"_index")
                                                                       then if interval[inteq,lower] > 0 then
                                                                              interval[inteq,lower] := 0:
                                                                              upbounded := upbounded union {inteq}
                                                                            end_if
                                                                       else interval[inteq,lower] := 0:
                                                                            upbounded := upbounded union {inteq} 
                                                                       end_if
                                                                  else i := i+1: next
                                                             end_if:

                                                             constraints := constraints minus {op(constraints,i)}:
                                                
                                                    end_while:                                                          # a <= x <= b #

                                                    j := scrollanz+1:                                                   # insert scrolling vars 
                                                                                                                          for [b >=] x >= a :-> 
                                                                                                                          [b-a >=] y = x-a >= 0 #
                                                    h := {}:
                                                    i := 1:
                                                    while i <= nops(lowbounded) do
                                                        if interval[op(lowbounded,i),greater] <> 0
                                                        then interval[scr[j],greater] := 0:
                                                             if not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                               if  interval[op(lowbounded,i),greater] > interval[op(lowbounded,i),lower] 
                                                               then return(this::leer()) 
                                                               end_if:
                                                               if interval[op(lowbounded,i),greater] = interval[op(lowbounded,i),lower]
                                                               then equations := subs(equations,{op(lowbounded,i)=interval[op(lowbounded,i),greater]}) 
                                                                                 union {op(lowbounded,i)=interval[op(lowbounded,i),greater]}: 
                                                                    upbounded := upbounded minus {op(lowbounded,i)}:
                                                                    lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                    next
                                                               end_if:
                                                               interval[scr[j],lower] := interval[op(lowbounded,i),lower]-interval[op(lowbounded,i),greater]:
                                                               h := h union {scr[j]}:
                                                               upbounded := upbounded union {scr[j]}:
                                                               subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                               equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                            union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                               upbounded := upbounded minus {op(lowbounded,i)}:
                                                               lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                               j := j+1:
                                                               next
                                                             end_if:
                                                             h := h union {scr[j]}:
                                                             subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                             equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                          union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                             upbounded := upbounded minus {op(lowbounded,i)}:
                                                             lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                             upbounded := upbounded union {scr[j]}:                                                     
                                                             j := j+1:
                                                             next
                                                        elif not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                            if 0 > interval[op(lowbounded,i),lower] then return(this::leer()) end_if:
                                                            if 0 = interval[op(lowbounded,i),lower]
                                                            then equations := subs(equations,{op(lowbounded,i)=0}) union {op(lowbounded,i)=0}:
                                                                 upbounded := upbounded minus {op(lowbounded,i)}:
                                                                 lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                 next
                                                            end_if:
                                                        end_if:
                                                        i := i+1
                                                    end_while:



                                                    lowbounded := h union lowbounded:
                                                    h := {}:
                                                    for i in (upbounded minus lowbounded) do                              # insert scrolling vars
                                                                                                                            for b >= x :-> y = b-x >= 0 #
                                                        #if interval[i,lower] <> 0
                                                        then# interval[scr[j],greater] := 0:
                                                             lowbounded := lowbounded union {scr[j]}:
                                                             subs(constraints,{i=-scr[j]+interval[i,lower]}):
                                                             equations := subs(equations,{i=-scr[j]+interval[i,lower]}) union {i=-scr[j]+interval[i,lower]}:
                                                             h := h union {i}:
                                                             j := j+1
                                                        #end_if#
                                                    end_for:

                                                    upbounded := upbounded minus h:


                                                    scrollanz := j-1:


#*************************************************************************************************************************************************************#


                                                    
                                                    i := 1:
                                                    while i <= nops(constraints) do                                     # build internal set of
                                                                                                                          unequations # 

                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs (inteq,equations):
                                                             h := 0:    
                                                             if testtype(inteq,"_plus")
                                                             then for j from 1 to nops(inteq) do                        # test all operands of 
                                                                                                                          the unequation #
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then if ( testtype(op(inteq,[j,2]),DOM_INT  ) or
                                                                              testtype(op(inteq,[j,2]),DOM_FLOAT) or 
                                                                              testtype(op(inteq,[j,2]),DOM_RAT  ) ) and 
                                                                            ( testtype(op(inteq,[j,1]),DOM_IDENT) or 
                                                                              testtype(op(inteq,[j,1]),"_index") )
                                                                         then identset := identset union {op(inteq,[j,1])}
                                                                         else print(op(constraints,i)):
                                                                              error("Linear optimization only!")
                                                                         end_if
                                                                    elif ( testtype(op(inteq,j),DOM_INT  ) or
                                                                           testtype(op(inteq,j),DOM_FLOAT) or 
                                                                           testtype(op(inteq,j),DOM_RAT  ) )
                                                                      then h := op(inteq,j)
                                                                      elif ( testtype(op(inteq,j),DOM_IDENT) or 
                                                                             testtype(op(inteq,j),"_index") ) 
                                                                        then identset := identset union {op(inteq,j)} 
                                                                        else print(op(constraints,i)):
                                                                             error("Linear optimization only!")
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                         testtype(op(inteq,2),DOM_FLOAT) or 
                                                                         testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                       ( testtype(op(inteq,1),DOM_IDENT) or 
                                                                         testtype(op(inteq,1),"_index") )
                                                                    then identset := identset union {op(inteq,1)}
                                                                    else print(op(constraints,i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                               elif ( testtype(inteq,DOM_INT  ) or
                                                                      testtype(inteq,DOM_FLOAT) or 
                                                                      testtype(inteq,DOM_RAT  ) )
                                                                 then h := inteq
                                                                 elif ( testtype(inteq,DOM_IDENT) or 
                                                                        testtype(inteq,"_index") ) 
                                                                   then identset := identset union {inteq} 
                                                                   else print(op(constraints,i)):
                                                                        error("Linear optimization only!")
                                                             end_if:
                                                
                                                             if not ( testtype(inteq,DOM_IDENT) or testtype(inteq,"_index") or testtype(inteq,DOM_EXPR))
                                                             then if bool(inteq > -h) 
                                                                  then return(this::leer())
                                                                  end_if:
                                                             else inteq := inteq - h:
                                                                  unequations := unequations union {[inteq,-h]}
                                                             end_if:

                                                        i := i+1
                                                    end_while:                                                          # unequations #


#*************************************************************************************************************************************************************#


                                                    gfct := subs(gfct,equations):

                                                    if testtype(gfct,"_plus")
                                                    then for j from 1 to nops(op(gfct)) do                              # test all operands of 
                                                                                                                          the goalfunction #

                                                           if testtype(op(gfct,j),"_mult")                              # _mult(x,i) in this order ! #
                                                           then if ( testtype(op(gfct,[j,2]),DOM_INT  ) or 
                                                                     testtype(op(gfct,[j,2]),DOM_FLOAT) or 
                                                                     testtype(op(gfct,[j,2]),DOM_RAT  ) ) and 
                                                                   ( testtype(op(gfct,[j,1]),DOM_IDENT) or
                                                                     testtype(op(gfct,[j,1]),"_index") )
                                                                then identset := identset union {op(gfct,[j,1])}
                                                                else print("Error in goalfunction :"):
                                                                     print(op(list,2)):
                                                                     error("Linear optimization only!")
                                                                end_if
                                                           elif testtype(op(gfct,j),DOM_IDENT) or testtype(op(gfct,j),"_index")
                                                             then identset := identset union {op(gfct,j)}:
                                                             elif not (testtype(op(gfct,j),DOM_INT  ) or 
                                                                       testtype(op(gfct,j),DOM_FLOAT) or 
                                                                       testtype(op(gfct,j),DOM_RAT  ))
                                                                then  print("Error in goalfunction :"):
                                                                      print(op(list,2)):
                                                                      error("Linear optimization only!")
                                                           end_if:
                                                       end_for
                                                    elif testtype(gfct,"_mult")                                         # _mult(x,i) in this order ! #
                                                      then if ( testtype(op(gfct,2),DOM_INT  ) or 
                                                                testtype(op(gfct,2),DOM_FLOAT) or 
                                                                testtype(op(gfct,2),DOM_RAT  ) ) and 
                                                              ( testtype(op(gfct,1),DOM_IDENT) or
                                                                testtype(op(gfct,1),"_index") )
                                                           then identset := identset union {op(gfct,1)}
                                                           else print("Error in goalfunction :"):
                                                                print(op(list,2)):
                                                                error("Linear optimization only!")
                                                           end_if
                                                      elif ( testtype(gfct,DOM_IDENT) or testtype(gfct,"_index") )
                                                        then identset := identset union {gfct}:
                                                        elif not (testtype(gfct,DOM_INT  ) or 
                                                                  testtype(gfct,DOM_FLOAT) or 
                                                                  testtype(gfct,DOM_RAT  ))
                                                          then print("Error in goalfunction :"):
                                                               print(op(list,2)):
                                                               error("Linear optimization only!")
                                                    end_if:                                                             # test of goalfunction #
                                                        

#*************************************************************************************************************************************************************#


                                                    if nops(list) >= 3 and op(list,3) = NONNEGATIVE then                # rest of vars >= 0 #
                                                      for i in identset do
                                                        lowbounded := lowbounded union {i}:
                                                        if testtype(interval[i,greater],"_index") then
                                                          interval[i,greater] := 0
                                                        end_if
                                                      end_for
                                                    end_if:







#**************************************************************************************************************************************************************
**************************************************************************************************************************************************************#




                                        
                                                  else                                                                  # inner application #
                                                    
                                                    if nops(list) = 9                                                   # two news! #
                                                    then return(new(this,args()))
                                                    end_if: 

                                                    gfct := op(list,2):
                                                    unequations := {}:
                                                    equations := {}:
                                                    gezero := {}:
                                                    constraints := op(list,1):
                                                    identset :={}:

                                                    upbounded := {}:
                                                   
                                                    if nops(list) >= 3 and testtype(op(list,3),DOM_SET) 
                                                    then for i in op(list,3) do
                                                           interval[i,greater] := 0
                                                         end_for:
                                                         lowbounded := op(list,3)
                                                    else lowbounded := {}
                                                    end_if:                                             


#*************************************************************************************************************************************************************#


                                                    i := 1:
                                                    while i <= nops(constraints) do                                      # search for x with
                                                                                                                           a <= x or x <= b #
                                                        case type(op(constraints,i)) 
                                                        of "_leequal" do
                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs (inteq,equations):
                                                            
                                                             if testtype(inteq,"_plus") and (nops(inteq) = 2)  
                                                             then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                       testtype(op(inteq,2),DOM_FLOAT) or 
                                                                       testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                     ( testtype(op(inteq,1),DOM_IDENT) or
                                                                       testtype(op(inteq,1),"_mult") )
                                                                  then if testtype(op(inteq,1),"_mult")
                                                                       then if ( testtype(op(inteq,[1,2]),DOM_INT  ) or
                                                                                 testtype(op(inteq,[1,2]),DOM_FLOAT) or 
                                                                                 testtype(op(inteq,[1,2]),DOM_RAT  ) ) and 
                                                                                 testtype(op(inteq,[1,1]),DOM_IDENT)
                                                                            then if nops(list) >= 3
                                                                                 then if (op(list,3) = NONNEGATIVE or 
                                                                                         contains(op(list,3),op(inteq,[1,1]))) and 
                                                                                        testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                      then interval[op(inteq,[1,1]),greater] := 0:
                                                                                           lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                      end_if
                                                                                 end_if: 
                                                                                 if op(inteq,[1,2]) < 0 
                                                                                 then if not testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                      then if interval[op(inteq,[1,1]),greater] < -op(inteq,2)/op(inteq,[1,2])
                                                                                           then interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                                lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                           end_if
                                                                                      else interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                           lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                      end_if
                                                                                 elif not testtype(interval[op(inteq,[1,1]),lower],"_index")
                                                                                      then if interval[op(inteq,[1,1]),lower] > -op(inteq,2)/op(inteq,[1,2])
                                                                                           then interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                                upbounded := upbounded union {op(inteq,[1,1])}
                                                                                           end_if
                                                                                      else interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                           upbounded := upbounded union {op(inteq,[1,1])}
                                                                                 end_if
                                                                            else print(op(constraints,i)):
                                                                                 error("Linear optimization only!")
                                                                            end_if
                                                                       else if nops(list) >= 3
                                                                            then if (op(list,3) = NONNEGATIVE or 
                                                                                         contains(op(list,3),op(inteq,1))) and
                                                                                      testtype(interval[op(inteq,1),greater],"_index")
                                                                                 then interval[op(inteq,1),greater] := 0:
                                                                                      lowbounded := lowbounded union {op(inteq,1)}
                                                                                 end_if
                                                                            end_if:
                                                                            if not testtype(interval[op(inteq,1),lower],"_index")
                                                                            then if interval[op(inteq,1),lower] > -op(inteq,2)
                                                                                 then interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                      upbounded := upbounded union {op(inteq,1)}
                                                                                 end_if
                                                                            else interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                 upbounded := upbounded union {op(inteq,1)} 
                                                                            end_if
                                                                       end_if
                                                                  else i := i+1: break
                                                                  end_if
                                                             elif testtype(inteq,"_mult")
                                                               then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                         testtype(op(inteq,2),DOM_FLOAT) or 
                                                                         testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                         testtype(op(inteq,1),DOM_IDENT)
                                                                    then if nops(list) >= 3
                                                                         then if (op(list,3) = NONNEGATIVE or 
                                                                                 contains(op(list,3),op(inteq,1))) and
                                                                                 testtype(interval[op(inteq,1),greater],"_index")
                                                                              then interval[op(inteq,1),greater] := 0:
                                                                                   lowbounded := lowbounded union {op(inteq,1)}
                                                                              end_if
                                                                         end_if:
                                                                         if op(inteq,2) < 0 
                                                                         then if not testtype(interval[op(inteq,1),greater],"_index")
                                                                              then if interval[op(inteq,1),greater] < 0
                                                                                   then interval[op(inteq,1),greater] := 0:
                                                                                        lowbounded := lowbounded union {op(inteq,1)}
                                                                                   end_if
                                                                              else interval[op(inteq,1),greater] := 0:
                                                                                   lowbounded := lowbounded union {op(inteq,1)}
                                                                              end_if
                                                                         elif not testtype(interval[op(inteq,1),lower],"_index")
                                                                           then if interval[op(inteq,1),lower] > 0
                                                                                then interval[op(inteq,1),lower] := 0:
                                                                                     upbounded := upbounded union {op(inteq,1)}
                                                                                end_if
                                                                           else interval[op(inteq,1),lower] := 0:
                                                                                upbounded := upbounded union {op(inteq,1)}
                                                                         end_if
                                                                    else print(op(constraints,i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                                elif testtype(inteq,DOM_IDENT)
                                                                  then if nops(list) >= 3
                                                                       then if (op(list,3) = NONNEGATIVE or contains(op(list,3),inteq)) and 
                                                                                testtype(interval[inteq,greater],"_index")
                                                                            then interval[inteq,greater] := 0:
                                                                                 lowbounded := lowbounded union {inteq}
                                                                            end_if
                                                                       end_if:
                                                                       if not testtype(interval[inteq,lower],"_index")
                                                                       then if interval[inteq,lower] > 0 then
                                                                              interval[inteq,lower] := 0:
                                                                              upbounded := upbounded union {inteq}
                                                                            end_if
                                                                       else interval[inteq,lower] := 0:
                                                                            upbounded := upbounded union {inteq} 
                                                                       end_if
                                                                  else i := i+1: break
                                                             end_if:

                                                             constraints := constraints minus {op(constraints,i)}:
                                                            
                                                             break
                                                        of "_equal" do
                                                             i := i+1: 
                                                             break
                                                        otherwise 
                                                             print(op(constraints,i)):
                                                             error("Set of (un)-equations expected"):
                                                             break
                                                        end_case:
                                                    end_while:                                                          # a <= x <= b #

                                                    j := 1:                                                             # insert scrolling vars 
                                                                                                                          for [b >=] x >= a :-> 
                                                                                                                          [b-a >=] y = x-a >= 0 #
                                                    h := {}:
                                                    i := 1:

                                                    while i <= nops(lowbounded) do

                                                        if interval[op(lowbounded,i),greater] <> 0
                                                        then interval[scr[j],greater] := 0:
                                                             if not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                               if  interval[op(lowbounded,i),greater] > interval[op(lowbounded,i),lower] 
                                                               then return(this::leer()) 
                                                               end_if:
                                                               if interval[op(lowbounded,i),greater] = interval[op(lowbounded,i),lower]
                                                               then equations := subs(equations,{op(lowbounded,i)=interval[op(lowbounded,i),greater]}) 
                                                                                 union {op(lowbounded,i)=interval[op(lowbounded,i),greater]}: 
                                                                    upbounded := upbounded minus {op(lowbounded,i)}:
                                                                    lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                    next
                                                               end_if:
                                                               interval[scr[j],lower] := interval[op(lowbounded,i),lower]-interval[op(lowbounded,i),greater]:
                                                               h := h union {scr[j]}:
                                                               upbounded := upbounded union {scr[j]}:
                                                               subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                               equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                            union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                               upbounded := upbounded minus {op(lowbounded,i)}:
                                                               lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                               j := j+1:
                                                               next
                                                             end_if:
                                                             h := h union {scr[j]}:
                                                             subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                             equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                          union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                             upbounded := upbounded minus {op(lowbounded,i)}:
                                                             lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                             upbounded := upbounded union {scr[j]}:                                                     
                                                             j := j+1:
                                                             next
                                                        elif not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                            if 0 > interval[op(lowbounded,i),lower] then return(this::leer()) end_if:
                                                            if 0 = interval[op(lowbounded,i),lower]
                                                            then equations := subs(equations,{op(lowbounded,i)=0}) union {op(lowbounded,i)=0}:
                                                                 upbounded := upbounded minus {op(lowbounded,i)}:
                                                                 lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                 next
                                                            end_if:
                                                        end_if:
                                                        i := i+1
                                                    end_while:

                                                    lowbounded := h union lowbounded:
                                                    h := {}:
                                                    for i in (upbounded minus lowbounded) do                             # insert scrolling vars
                                                                                                                           for b >= x :-> y = b-x >= 0 #
                                                        #if interval[i,lower] <> 0
                                                        then# interval[scr[j],greater] := 0:
                                                             lowbounded := lowbounded union {scr[j]}:
                                                             subs(constraints,{i=-scr[j]+interval[i,lower]}):
                                                             equations := subs(equations,{i=-scr[j]+interval[i,lower]}) union {i=-scr[j]+interval[i,lower]}:
                                                             h := h union {i}:
                                                             j := j+1
                                                        #end_if#
                                                    end_for:

                                                    upbounded := upbounded minus h:

                                                    scrollanz := j-1:
                                


#*************************************************************************************************************************************************************#


                                                    i := 1:
                                                    while i <= nops(constraints) do                                     # build internal set of
                                                                                                                          equations # 
                                                        if testtype(op(constraints,i),"_leequal") 
                                                        then i := i+1: next end_if:

                                                        
                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs(inteq,equations):
                                                             h := FALSE:

                                                             if testtype(inteq,"_plus")                                 # test all operands of 
                                                                                                                          the equation #
                                                             then for j from 1 to nops(inteq) do                        
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then if not contains(lowbounded,op(inteq,[j,1])) and
                                                                            (nops(list) < 3 or (op(list,3) <> NONNEGATIVE and 
                                                                                                     not contains(op(list,3),op(inteq,[j,1]))
                                                                                               )
                                                                            )
                                                                          then h := [op(inteq,[j,1]),-op(inteq,[j,2])]:
                                                                               break:
                                                                          elif (h = FALSE) then
                                                                              h := [op(inteq,[j,1]),-op(inteq,[j,2])]
                                                                          end_if
                                                                    elif testtype(op(inteq,j),DOM_IDENT) or testtype(op(inteq,j),"_index")
                                                                      then if not contains(lowbounded,op(inteq,j)) and
                                                                               (nops(list) < 3 or (op(list,3) <> NONNEGATIVE and 
                                                                                                     not contains(op(list,3),op(inteq,j))
                                                                                                  ) 
                                                                               )
                                                                           then h := [op(inteq,j),-1]:
                                                                                break:
                                                                           elif (h = FALSE) then
                                                                               h := [op(inteq,j),-1]
                                                                           end_if
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then h := [op(inteq,1),-op(inteq,2)]
                                                               elif testtype(inteq,DOM_IDENT) or testtype(inteq,"_index") 
                                                                 then h := [inteq,-1]
                                                             end_if:


                                                             if h = FALSE 
                                                             then if bool(inteq <> 0) then return(this::leer()) end_if
                                                                  
                                                             else inteq := inteq + h[2]*h[1]:
                                                                  equations := {op(equations,[i,1]) = subs(op(equations,[i,2]),h[1]=inteq/h[2])
                                                                                $hold(i)=1..nops(equations)}: 

                                                                  equations := equations union {h[1]=inteq/h[2]}:
                                                                  identset := identset minus {h[1]}:
                                                                  gezero := {op(gezero,[i,1]) = subs(op(gezero,[i,2]),h[1]=inteq/h[2])
                                                                               $hold(i)=1..nops(gezero)}:
                                                                  if contains(lowbounded,h[1]) or
                                                                     (nops(list) >= 3 and (op(list,3)=NONNEGATIVE or contains(op(list,3),h[1]))) 

                                                                  then gezero := gezero union {h[1]=inteq/h[2]}:
                                                                       identset := identset union indets(inteq,PolyExpr):
                                                                       unlimited[h[1]] := FALSE:
                                                                  end_if
                                                             end_if:

                                                             constraints := constraints minus {op(constraints,i)}:
                                                                                                                        # equations #
                                                    end_while:


#*************************************************************************************************************************************************************#

                                                

                                                    i := 1:
                                                    while i <= nops(constraints) do                                      # search for x with
                                                                                                                           a <= x or x <= b #
                                                        if testtype(op(constraints,i),"_equal") 
                                                        then i := i+1: next end_if:

                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs (inteq,equations):

                                                             if testtype(inteq,"_plus") and (nops(inteq) = 2)  
                                                             then if ( testtype(op(inteq,2),DOM_INT  ) or
                                                                       testtype(op(inteq,2),DOM_FLOAT) or 
                                                                       testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                     ( testtype(op(inteq,1),DOM_IDENT) or
                                                                       testtype(op(inteq,1),"_index")  or
                                                                       testtype(op(inteq,1),"_mult") )
                                                                  then if testtype(op(inteq,1),"_mult")
                                                                       then if nops(list) >= 3
                                                                            then if (op(list,3) = NONNEGATIVE or 
                                                                                     contains(op(list,3),op(inteq,[1,1]))) and 
                                                                                     testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                 then interval[op(inteq,[1,1]),greater] := 0:
                                                                                      lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                 end_if
                                                                             end_if: 
                                                                             if op(inteq,[1,2]) < 0 
                                                                             then if not testtype(interval[op(inteq,[1,1]),greater],"_index")
                                                                                  then if interval[op(inteq,[1,1]),greater] < -op(inteq,2)/op(inteq,[1,2])
                                                                                       then interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                            lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                       end_if
                                                                                  else interval[op(inteq,[1,1]),greater] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                       lowbounded := lowbounded union {op(inteq,[1,1])}
                                                                                  end_if
                                                                              elif not testtype(interval[op(inteq,[1,1]),lower],"_index")
                                                                                then if interval[op(inteq,[1,1]),lower] > -op(inteq,2)/op(inteq,[1,2])
                                                                                     then interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                          upbounded := upbounded union {op(inteq,[1,1])}
                                                                                      end_if
                                                                                else interval[op(inteq,[1,1]),lower] := -op(inteq,2)/op(inteq,[1,2]):
                                                                                     upbounded := upbounded union {op(inteq,[1,1])}
                                                                              end_if     
                                                                       else if nops(list) >= 3
                                                                            then if (op(list,3) = NONNEGATIVE or 
                                                                                         contains(op(list,3),op(inteq,1))) and
                                                                                      testtype(interval[op(inteq,1),greater],"_index")
                                                                                 then interval[op(inteq,1),greater] := 0:
                                                                                      lowbounded := lowbounded union {op(inteq,1)}
                                                                                 end_if
                                                                            end_if:
                                                                            if not testtype(interval[op(inteq,1),lower],"_index")
                                                                            then if interval[op(inteq,1),lower] > -op(inteq,2)
                                                                                 then interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                      upbounded := upbounded union {op(inteq,1)}
                                                                                 end_if 
                                                                            else interval[op(inteq,1),lower] := -op(inteq,2):
                                                                                 upbounded := upbounded union {op(inteq,1)} 
                                                                            end_if
                                                                       end_if
                                                                  else i := i+1: next
                                                                  end_if
                                                             elif testtype(inteq,"_mult")
                                                               then if nops(list) >= 3
                                                                    then if (op(list,3) = NONNEGATIVE or 
                                                                             contains(op(list,3),op(inteq,1))) and
                                                                             testtype(interval[op(inteq,1),greater],"_index")
                                                                         then interval[op(inteq,1),greater] := 0:
                                                                              lowbounded := lowbounded union {op(inteq,1)}
                                                                         end_if
                                                                    end_if:
                                                                    if op(inteq,2) < 0 
                                                                    then if not testtype(interval[op(inteq,1),greater],"_index")
                                                                         then if interval[op(inteq,1),greater] < 0
                                                                              then interval[op(inteq,1),greater] := 0:
                                                                                   lowbounded := lowbounded union {op(inteq,1)}
                                                                              end_if
                                                                         else interval[op(inteq,1),greater] := 0:
                                                                              lowbounded := lowbounded union {op(inteq,1)}
                                                                         end_if
                                                                    elif not testtype(interval[op(inteq,1),lower],"_index")
                                                                      then if interval[op(inteq,1),lower] > 0
                                                                           then interval[op(inteq,1),lower] := 0:
                                                                                upbounded := upbounded union {op(inteq,1)}
                                                                           end_if
                                                                      else interval[op(inteq,1),lower] := 0:
                                                                           upbounded := upbounded union {op(inteq,1)}
                                                                    end_if

                                                                elif testtype(inteq,DOM_IDENT) or testtype(inteq,"_index")
                                                                  then if nops(list) >= 3
                                                                       then if (op(list,3) = NONNEGATIVE or contains(op(list,3),inteq)) and 
                                                                                testtype(interval[inteq,greater],"_index")
                                                                            then interval[inteq,greater] := 0:
                                                                                 lowbounded := lowbounded union {inteq}
                                                                            end_if
                                                                       end_if:
                                                                       if not testtype(interval[inteq,lower],"_index")
                                                                       then if interval[inteq,lower] > 0 then
                                                                              interval[inteq,lower] := 0:
                                                                              upbounded := upbounded union {inteq}
                                                                            end_if
                                                                       else interval[inteq,lower] := 0:
                                                                            upbounded := upbounded union {inteq} 
                                                                       end_if
                                                                  else i := i+1: next
                                                             end_if:

                                                             constraints := constraints minus {op(constraints,i)}:

                                                    end_while:                                                          # a <= x <= b #


                                                    j := scrollanz+1:                                                   # insert scrolling vars 
                                                                                                                          for [b >=] x >= a :-> 
                                                                                                                          [b-a >=] y = x-a >= 0#


                                                    h := {}:
                                                    i := 1:
                                                    while i <= nops(lowbounded) do
                                                        if interval[op(lowbounded,i),greater] <> 0
                                                        then interval[scr[j],greater] := 0:
                                                             if not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                               if  interval[op(lowbounded,i),greater] > interval[op(lowbounded,i),lower] 
                                                               then return(this::leer()) 
                                                               end_if:
                                                               if interval[op(lowbounded,i),greater] = interval[op(lowbounded,i),lower]
                                                               then equations := subs(equations,{op(lowbounded,i)=interval[op(lowbounded,i),greater]}) 
                                                                                 union {op(lowbounded,i)=interval[op(lowbounded,i),greater]}: 
                                                                    upbounded := upbounded minus {op(lowbounded,i)}:
                                                                    lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                    next
                                                               end_if:
                                                               interval[scr[j],lower] := interval[op(lowbounded,i),lower]-interval[op(lowbounded,i),greater]:
                                                               h := h union {scr[j]}:
                                                               upbounded := upbounded union {scr[j]}:
                                                               subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                               equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                            union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                               upbounded := upbounded minus {op(lowbounded,i)}:
                                                               lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                               j := j+1:
                                                               next
                                                             end_if:
                                                             h := h union {scr[j]}:
                                                             subs(constraints,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}):
                                                             equations := subs(equations,{op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}) 
                                                                          union {op(lowbounded,i)=scr[j]+interval[op(lowbounded,i),greater]}:
                                                             upbounded := upbounded minus {op(lowbounded,i)}:
                                                             lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                             upbounded := upbounded union {scr[j]}:                                                     
                                                             j := j+1:
                                                             next
                                                        elif not testtype(interval[op(lowbounded,i),lower],"_index") then
                                                            if 0 > interval[op(lowbounded,i),lower] then return(this::leer()) end_if:
                                                            if 0 = interval[op(lowbounded,i),lower]
                                                            then equations := subs(equations,{op(lowbounded,i)=0}) union {op(lowbounded,i)=0}:
                                                                 upbounded := upbounded minus {op(lowbounded,i)}:
                                                                 lowbounded := lowbounded minus {op(lowbounded,i)}:
                                                                 next
                                                            end_if:
                                                        end_if:
                                                        i := i+1
                                                    end_while:

                                                    lowbounded := h union lowbounded:
                                                    h := {}:
                                                    for i in (upbounded minus lowbounded) do                             # insert scrolling vars
                                                                                                                           for b >= x :-> y = b-x >= 0 #
                                                        #if interval[i,lower] <> 0
                                                        then# interval[scr[j],greater] := 0:
                                                             lowbounded := lowbounded union {scr[j]}:
                                                             subs(constraints,{i=-scr[j]+interval[i,lower]}):
                                                             equations := subs(equations,{i=-scr[j]+interval[i,lower]}) union {i=-scr[j]+interval[i,lower]}:
                                                             h := h union {i}:
                                                             j := j+1
                                                        #end_if#
                                                    end_for:

                                                    upbounded := upbounded minus h:

                                                    scrollanz := j-1:


#*************************************************************************************************************************************************************#

                                                    i := 1:
                                                    while i <= nops(constraints) do                                     # build internal set of
                                                                                                                          unequations # 

                                                             inteq := op(constraints,[i,1])-op(constraints,[i,2]):
                                                             inteq := subs (inteq,equations):
                                                             h := 0:    
                                                             if testtype(inteq,"_plus")
                                                             then for j from 1 to nops(inteq) do                        # test all operands of 
                                                                                                                          the unequation #
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then identset := identset union {op(inteq,[j,1])}
                                                                    elif ( testtype(op(inteq,j),DOM_INT  ) or
                                                                           testtype(op(inteq,j),DOM_FLOAT) or 
                                                                           testtype(op(inteq,j),DOM_RAT  ) )
                                                                      then h := op(inteq,j)
                                                                      else identset := identset union {op(inteq,j)}
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then identset := identset union {op(inteq,1)}
                                                               elif ( testtype(inteq,DOM_INT  ) or
                                                                      testtype(inteq,DOM_FLOAT) or 
                                                                      testtype(inteq,DOM_RAT  ) )
                                                                 then h := inteq
                                                                 else identset := identset union {inteq} 
                                                             end_if:
                                                
                                                             if not ( testtype(inteq,DOM_IDENT) or testtype(inteq,"_index") or testtype(inteq,DOM_EXPR))
                                                             then if bool(inteq > -h) 
                                                                  then return(this::leer())
                                                                  end_if:
                                                             else inteq := inteq - h:
                                                                  unequations := unequations union {[inteq,-h]}
                                                             end_if:
                                                        i := i+1
                                                    end_while:                                                          # unequations #


#*************************************************************************************************************************************************************#


                                                    gfct := subs(gfct,equations):

                                                    if testtype(gfct,"_plus")
                                                    then for j from 1 to nops(op(gfct)) do                              # test all operands of 
                                                                                                                          the goalfunction #

                                                           if testtype(op(gfct,j),"_mult")                              # _mult(x,i) in this order ! #
                                                           then identset := identset union {op(gfct,[j,1])}
                                                           elif testtype(op(gfct,j),DOM_IDENT) or testtype(op(gfct,j),"_index")
                                                             then identset := identset union {op(gfct,j)}
                                                           end_if
                                                       end_for
                                                    elif testtype(gfct,"_mult")                                         # _mult(x,i) in this order ! #
                                                      then identset := identset union {op(gfct,1)}
                                                      elif ( testtype(gfct,DOM_IDENT) or testtype(gfct,"_index") )
                                                        then identset := identset union {gfct}
                                                    end_if:                                                             # test of goalfunction #
                                                        

#*************************************************************************************************************************************************************#


                                                    if nops(list) >= 3 and op(list,3) = NONNEGATIVE then                # rest of vars >= 0 #
                                                      for i in identset do
                                                        lowbounded := lowbounded union {i}:
                                                        if testtype(interval[i,greater],"_index") then
                                                          interval[i,greater] := 0
                                                        end_if
                                                      end_for
                                                    end_if:

                                                  end_if:                                                               # testargs() #




#*************************************************************************************************************************************************************#
#*************************************************************************************************************************************************************# 



                                                  n := nops(identset):
                                                
                                                  identlist := [op(identset,i)$hold(i)=1..n]:
                                                  for i from 1 to n do
                                                    internalorder[identlist[i]] := i
                                                  end_for:
                                                  i := 1:
                                                  while i <= nops(gezero) do                                            
                                                        if not (testtype(op(gezero,[i,2]),"_plus") or
                                                                testtype(op(gezero,[i,2]),"_mult") or
                                                                testtype(op(gezero,[i,2]),DOM_IDENT) or 
                                                                testtype(op(gezero,[i,2]),"_index") )
                                                        then if nops(list) >= 3
                                                             then if testtype(op(list,3),DOM_SET)
                                                                  then if contains(op(list,3),op(gezero,[i,1])) 
                                                                       then if op(gezero,[i,2]) < 0 
                                                                            then return(this::leer())
                                                                            end_if
                                                                       end_if
                                                                  elif op(gezero,[i,2]) < 0 
                                                                    then return(this::leer())
                                                                  end_if
                                                             end_if:
                                                             gezero := gezero minus {op(gezero,i)}:
                                                             next
                                                        end_if:
                                                        i := i+1
                                                  end_while:

                                                  muneqs := nops(constraints): 
                                                  mgez := nops(gezero):  
                                                  m := muneqs+mgez: 

                                                  tbl := array(1..m+2,1..n+2):
                                                                                                                                          
                                                  for j from 1 to n do
                                                        tbl[1,j+2] := identlist[j]:                                     # first row : die Variablen #
                                                        tbl[2,j+2] := 0                                                 # second row : init with zero #
                                                  end_for:
                                                  
                                                  for j from 1 to 2 do
                                                    for i from 1 to 2 do
                                                        tbl[i,j]:=0;
                                                    end_for
                                                  end_for:      
                                                  
                                                  if testtype(gfct,"_plus")                                             # 2.row : the goalfunction #
                                                  then for j from 1 to nops(gfct) do                            
                                                         if testtype(op(gfct,j),"_mult") 
                                                         then tbl[2,internalorder[op(gfct,[j,1])]+2] := op(gfct,[j,2]):
                                                         elif testtype(op(gfct,j),DOM_IDENT)  or testtype(op(gfct,j),"_index")
                                                           then tbl[2,internalorder[op(gfct,j)]+2] := 1
                                                         end_if
                                                       end_for
                                                  elif testtype(gfct,"_mult") 
                                                    then tbl[2,internalorder[op(gfct,1)]+2] := op(gfct,2):
                                                    elif testtype(gfct,DOM_IDENT)  or testtype(gfct,"_index")
                                                      then tbl[2,internalorder[gfct]+2] := 1
                                                  end_if:

                                                  for i from 1 to muneqs do                                             # 1.column : the slackvariables #
                                                        tbl[i+2,1] := slk[i]:   
                                                  end_for:

                                                  for i from 1 to mgez do
                                                        tbl[muneqs+i+2,1] := op(gezero,[i,1])
                                                  end_for:

                                                  for i from 1 to muneqs do                                             # init A,b #

                                                        tbl[i+2,2] := op(unequations,[i,2]):                            # 2.column : b #

                                                        for j from 1 to n do                                            # init A #
                                                                tbl[i+2,j+2] := 0:
                                                        end_for:

                                                        if testtype(op(unequations,[i,1]),"_plus")
                                                        then for j from 1 to nops(op(unequations,[i,1])) do             # all operands of the 
                                                                                                                          left side of the eq #
                                                               if testtype(op(unequations,[i,1,j]),"_mult") 
                                                               then tbl[i+2,internalorder[op(unequations,[i,1,j,1])]+2] := op(unequations,[i,1,j,2])
                                                          
                                                               else tbl[i+2,internalorder[op(unequations,[i,1,j])]+2] := 1
                                                               end_if
                                                             end_for
                                                        elif testtype(op(unequations,[i,1]),"_mult") 
                                                          then tbl[i+2,internalorder[op(unequations,[i,1,1])]+2] := op(unequations,[i,1,2])
                                                          else tbl[i+2,internalorder[op(unequations,[i,1])]+2] := 1
                                                        end_if
                                                  end_for:

                                                  i := 1:
                                                  while i <= mgez do                                                    # init A,b #

                                                        
                                                        tbl[i+muneqs+2,2] := 0:                                         # 2.column : b #

                                                        for j from 1 to n do                                            # init A #
                                                                tbl[i+muneqs+2,j+2] := 0:
                                                        end_for:

                                                        if testtype(op(gezero,[i,2]),"_plus")
                                                        then for j from 1 to nops(op(gezero,[i,2])) do                  # all operands of the 
                                                                                                                          left side of the eq #
                                                               if testtype(op(gezero,[i,2,j]),"_mult") 
                                                               then tbl[i+muneqs+2,internalorder[op(gezero,[i,2,j,1])]+2] := -op(gezero,[i,2,j,2])
                                                          
                                                               elif testtype(op(gezero,[i,2,j]),DOM_IDENT) or testtype(op(gezero,[i,2,j]),"_index") 
                                                                 then tbl[i+muneqs+2,internalorder[op(gezero,[i,2,j])]+2] := -1
                                                                 else tbl[i+muneqs+2,2] := op(gezero,[i,2,j])
                                                               end_if
                                                             end_for
                                                        elif testtype(op(gezero,[i,2]),"_mult") 
                                                          then tbl[i+muneqs+2,internalorder[op(gezero,[i,2,1])]+2] := -op(gezero,[i,2,2])
                                                          else tbl[i+muneqs+2,internalorder[op(gezero,[i,2])]+2] := -1
                                                        end_if:
                                                        i := i+1
                                                  end_while:

                                                  for i in (upbounded intersect lowbounded) union identset do
                                                         unlimited[i] := bool(not contains(lowbounded,i)):
                                                         if not testtype(interval[i,lower],"_index") then
                                                           interval[i,greater] := FALSE
                                                         end_if
                                                  end_for:

                                                  for j from 1 to muneqs do
                                                    unlimited[slk[j]] := FALSE
                                                  end_for:

                                                  new(this,tbl,m,n,identset,equations,gfct,unlimited,scrollanz,interval)
                                                  
                                                end_proc,

                        "pivot1"        =       proc(tbl,m,n,unlimited,interval,i)
                                                local j,k,l,mini,intervalpiv,h,ht,hel;

                                                begin
        
                                                  l:=0:
                                                  k:=0:
                                                  j := 3:

                                                  while (i>=3) do                                               # letzte schlechte Zeile #
                                                    if (not unlimited[tbl[i,1]]) and 
                                                       (tbl[i,2] < 0 or (not testtype(interval[tbl[i,1],lower],"_index") and 
                                                                         tbl[i,2] > interval[tbl[i,1],lower]) 
                                                       )
                                                    then k:=i: break end_if:
                                                    i := i-1 
                                                  end_while:
                                                
                                                  if k=0 then return([k,l]) end_if:                             # b>=0 #

                                                  hel := k:

                                                  if tbl[k,2] < 0 
                                                  then while (j <= n+2) do                                      # suche tbl[k,j] < 0 oder unbeschraenkte var #
                                                         if tbl[k,j] < 0 or ( unlimited[tbl[1,j]] and (tbl[k,j]<>0) )
                                                         then l:=j: break end_if:
                                                         j := j+1
                                                       end_while
                                                  else while (j <= n+2) do                                      # suche tbl[k,j] < 0 oder unbeschraenkte var #
                                                         if tbl[k,j] > 0 or ( unlimited[tbl[1,j]] and (tbl[k,j]<>0) )
                                                         then l:=j: break end_if:
                                                         j := j+1
                                                       end_while
                                                  end_if:

                                                  if l = 0 then return([k,l]) end_if:                           # Loesungsmenge ist leer #

                                                  h := {}:                                      
                                                  i := 3:

                                                  if tbl[k,2] < 0
                                                  then if tbl[k,l] < 0
                                                       then mini := tbl[k,2]/tbl[k,l]:
                                                            intervalpiv := FALSE:
                                                      
                                                            if not testtype(interval[tbl[1,l],lower],"_index") then 
                                                              h := h union {tbl[1,l]}:
                                                              ht[tbl[1,l]] := 1
                                                            end_if:

                                                            while i < k do
                                                              if not unlimited[tbl[i,1]] 
                                                              then if tbl[i,l] > 0 
                                                                   then if tbl[i,2]/tbl[i,l] < mini and tbl[i,2] >= 0
                                                                        then k:=i:
                                                                             mini := tbl[k,2]/tbl[k,l]:
                                                                             intervalpiv := FALSE
                                                                        end_if
                                                                   elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                     if tbl[i,l] < 0 and tbl[i,2] <= interval[tbl[i,1],lower] then
                                                                       h := h union {tbl[i,1]}:
                                                                       ht[tbl[i,1]] := i
                                                                     end_if
                                                                   end_if
                                                              end_if:
                                                              i:=i+1
                                                            end_while:

                                                            i := k+1:
                                                            while i<= m+2 do
                                                              if not unlimited[tbl[i,1]] 
                                                              then if tbl[i,l] > 0 
                                                                   then if tbl[i,2]/tbl[i,l] < mini
                                                                        then k:=i:
                                                                             mini := tbl[k,2]/tbl[k,l]:
                                                                             intervalpiv := FALSE
                                                                        end_if
                                                                   elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                     if tbl[i,l] < 0 then
                                                                       h := h union {tbl[i,1]}:
                                                                       ht[tbl[i,1]] := i
                                                                     end_if
                                                                   end_if
                                                              end_if:
                                                              i:=i+1
                                                            end_while:

                                                            for i in h do
                                                              if ht[i] = 1 
                                                              then if mini > interval[i,lower] then
                                                                     k := 1:
                                                                     mini := interval[i,lower]:
                                                                     intervalpiv := TRUE
                                                                   end_if
                                                              elif (tbl[ht[i],2]-interval[i,lower])/tbl[ht[i],l] < mini
                                                                then k:=ht[i]:
                                                                     mini := (tbl[k,2]-interval[i,lower])/tbl[k,l]:
                                                                     intervalpiv := TRUE
                                                              end_if
                                                            end_for

                                                       else mini := tbl[k,2]/tbl[k,l]:
                                                            intervalpiv := FALSE:

                                                            while i < k do
                                                              if not unlimited[tbl[i,1]] 
                                                              then if tbl[i,l] < 0
                                                                   then if tbl[i,2]/tbl[i,l] > mini and tbl[i,2] >= 0
                                                                        then k:=i:
                                                                          mini := tbl[k,2]/tbl[k,l]:
                                                                          intervalpiv := FALSE
                                                                        end_if
                                                                   elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                     if tbl[i,l] > 0 and tbl[i,2] <= interval[tbl[i,1],lower] then
                                                                       h := h union {tbl[i,1]}:
                                                                       ht[tbl[i,1]] := i
                                                                     end_if
                                                                   end_if
                                                              end_if:
                                                              i:=i+1
                                                            end_while:

                                                            i := k+1:
                                                            while i<= m+2 do
                                                              if not unlimited[tbl[i,1]] 
                                                              then if tbl[i,l] < 0
                                                                   then if tbl[i,2]/tbl[i,l] > mini
                                                                        then k:=i:
                                                                          mini := tbl[k,2]/tbl[k,l]:
                                                                          intervalpiv := FALSE
                                                                        end_if
                                                                   elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                     if tbl[i,l] > 0 then
                                                                       h := h union {tbl[i,1]}:
                                                                       ht[tbl[i,1]] := i
                                                                     end_if
                                                                   end_if
                                                              end_if:
                                                              i:=i+1
                                                            end_while:

                                                            for i in h do
                                                              if (tbl[ht[i],2]-interval[i,lower])/tbl[ht[i],l] > mini then
                                                                k:=ht[i]:
                                                                mini := (tbl[k,2]-interval[tbl[k,1],lower])/tbl[k,l]:
                                                                intervalpiv := TRUE
                                                              end_if
                                                            end_for
                                                       end_if
                                                  elif tbl[k,l] > 0
                                                    then mini := (tbl[k,2]-interval[tbl[k,1],lower])/tbl[k,l]:
                                                         intervalpiv := TRUE:
                                                      
                                                         if not testtype(interval[tbl[1,l],lower],"_index") then 
                                                           h := h union {tbl[1,l]}:
                                                           ht[tbl[1,l]] := 1
                                                         end_if:

                                                         while i < k do
                                                           if not unlimited[tbl[i,1]] 
                                                           then if tbl[i,l] > 0 
                                                                then if tbl[i,2]/tbl[i,l] < mini and tbl[i,2] >= 0
                                                                     then k:=i:
                                                                       mini := tbl[k,2]/tbl[k,l]:
                                                                       intervalpiv := FALSE
                                                                     end_if
                                                                elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                  if tbl[i,l] < 0 and tbl[i,2] <= interval[tbl[i,1],lower] then
                                                                    h := h union {tbl[i,1]}:
                                                                    ht[tbl[i,1]] := i
                                                                  end_if
                                                                end_if
                                                           end_if:
                                                           i:=i+1
                                                         end_while:

                                                         i := k+1:
                                                         while i<= m+2 do
                                                           if not unlimited[tbl[i,1]] 
                                                           then if tbl[i,l] > 0 
                                                                then if tbl[i,2]/tbl[i,l] < mini
                                                                     then k:=i:
                                                                       mini := tbl[k,2]/tbl[k,l]:
                                                                       intervalpiv := FALSE
                                                                     end_if
                                                                elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                  if tbl[i,l] < 0 then
                                                                    h := h union {tbl[i,1]}:
                                                                    ht[tbl[i,1]] := i
                                                                  end_if
                                                                end_if
                                                           end_if:
                                                           i:=i+1
                                                         end_while:

                                                         for i in h do
                                                           if ht[i] = 1 
                                                           then if mini > interval[i,lower] then
                                                                  k := 1:
                                                                  mini := interval[i,lower]:
                                                                  intervalpiv := TRUE
                                                                end_if
                                                           elif (tbl[ht[i],2]-interval[i,lower])/tbl[ht[i],l] < mini
                                                             then k:=ht[i]:
                                                                  mini := (tbl[k,2]-interval[i,lower])/tbl[k,l]:
                                                                  intervalpiv := TRUE
                                                           end_if
                                                         end_for
                                                    else mini := (tbl[k,2]-interval[tbl[k,1],lower])/tbl[k,l]:
                                                         intervalpiv := TRUE:

                                                         while i < k do
                                                           if not unlimited[tbl[i,1]] 
                                                           then if tbl[i,l] < 0 
                                                                then if tbl[i,2]/tbl[i,l] > mini and tbl[i,2] >= 0
                                                                     then k:=i:
                                                                       mini := tbl[k,2]/tbl[k,l]:
                                                                       intervalpiv := FALSE
                                                                     end_if
                                                                elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                  if tbl[i,l] > 0 and tbl[i,2] <= interval[tbl[i,1],lower] then
                                                                    h := h union {tbl[i,1]}:
                                                                    ht[tbl[i,1]] := i
                                                                  end_if
                                                                end_if
                                                           end_if:
                                                           i:=i+1
                                                         end_while:

                                                         i := k+1:
                                                         while i<= m+2 do
                                                           if not unlimited[tbl[i,1]] 
                                                           then if tbl[i,l] < 0 
                                                                then if tbl[i,2]/tbl[i,l] > mini
                                                                     then k:=i:
                                                                       mini := tbl[k,2]/tbl[k,l]:
                                                                       intervalpiv := FALSE
                                                                     end_if
                                                                elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                  if tbl[i,l] > 0 then
                                                                    h := h union {tbl[i,1]}:
                                                                    ht[tbl[i,1]] := i
                                                                  end_if
                                                                end_if
                                                           end_if:
                                                           i:=i+1
                                                         end_while:

                                                         for i in h do
                                                           if (tbl[ht[i],2]-interval[i,lower])/tbl[ht[i],l] > mini then
                                                             k:=ht[i]:
                                                             mini := (tbl[k,2]-interval[tbl[k,1],lower])/tbl[k,l]:
                                                             intervalpiv := TRUE
                                                           end_if
                                                         end_for
                                                  end_if:
                                                                


                                                  return([k,l,tbl[k,l],intervalpiv,hel])                        # k > 1 ? #                       

                                                end_proc,

                        "step"          =       proc(T,piv)
                                                local i,j,h,tbl,m,n,interval;

                                                begin 
                                                  tbl := T[1]:
                                                  m := T[2]:
                                                  n := T[3]:
                                                  interval := T[9]:
                                                  
                                                  if piv[1] = 1 then

                                                    tbl := assign_elems(tbl,([[i,piv[2]],-tbl[i,piv[2]]],
                                                                      [[i,2],    tbl[i,2]-interval[tbl[piv[1],piv[2]],lower]*tbl[i,piv[2]]
                                                                     ])
                                                                    $hold(i)=2..m+2):
                                                    
                                                    interval[tbl[piv[1],piv[2]],greater] := not interval[tbl[piv[1],piv[2]],greater]: 
                                                    return(new(this,tbl,m,n,T[4],T[5],T[6],T[7],T[8],interval))
                                                  end_if:
                                  

                                                  if piv[4]
                                                  then tbl := assign_elems(tbl,[[piv[1],j],-tbl[piv[1],j]]$hold(j)=3..n+2):
                                                       piv[3] := -piv[3]:
                                                       tbl[piv[1],2] := interval[tbl[piv[1],1],lower]-tbl[piv[1],2]:
                                                       tbl[piv[1],piv[2]] := 1/piv[3]:

                                                       tbl := assign_elems(tbl,[[piv[1],j],tbl[piv[1],j]/piv[3]]$hold(j)=2..piv[2]-1,
                                                                        [[piv[1],j],tbl[piv[1],j]/piv[3]]$hold(j)=piv[2]+1..n+2):

                                                       interval[tbl[piv[1],1],greater] := not interval[tbl[piv[1],1],greater]   # TRUE means "higher value" # 
                                                  else tbl[piv[1],piv[2]] := 1/piv[3]:

                                                       tbl := assign_elems(tbl,[[piv[1],j],tbl[piv[1],j]/piv[3]]$hold(j)=2..piv[2]-1,
                                                                        [[piv[1],j],tbl[piv[1],j]/piv[3]]$hold(j)=piv[2]+1..n+2):
                                                  end_if:


                                                  h := tbl[1,piv[2]]:
                                                  tbl[1,piv[2]] := tbl[piv[1],1]:
                                                  tbl[piv[1],1] := h:

                                                  tbl := assign_elems(tbl,([[i,j],tbl[i,j]-tbl[i,piv[2]]*tbl[piv[1],j]]$hold(j)=2..piv[2]-1,
                                                                    [[i,j],tbl[i,j]-tbl[i,piv[2]]*tbl[piv[1],j]]$hold(j)=piv[2]+1..n+2)
                                                                        $hold(i)=2..piv[1]-1,
                                                                   ([[i,j],tbl[i,j]-tbl[i,piv[2]]*tbl[piv[1],j]]$hold(j)=2..piv[2]-1,
                                                                    [[i,j],tbl[i,j]-tbl[i,piv[2]]*tbl[piv[1],j]]$hold(j)=piv[2]+1..n+2)
                                                                        $hold(i)=piv[1]+1..m+2,

                                                                    [[i,piv[2]],-tbl[i,piv[2]]/piv[3]]$hold(i)=2..piv[1]-1,
                                                                    [[i,piv[2]],-tbl[i,piv[2]]/piv[3]]$hold(i)=piv[1]+1..m+2):

                                                  return(new(this,tbl,m,n,T[4],T[5],T[6],T[7],T[8],interval))
                                                end_proc,

                        "pivot2"        =       proc(tbl,m,n,unlimited,interval)
                                                local i,j,k,l,mini,intervalpiv,h,ht;

                                                begin
                                                  
                                                  l:=0:
                                                  k:=0:
                                                  j := 3:
                                                  i := 3:

                                                  while (j <= n+2) do                                           # Zielfunktion verbesserbar ? #
                                                    if tbl[2,j] < 0 or (unlimited[tbl[1,j]] and tbl[2,j] > 0)
                                                    then #if l = 0 or abs(tbl[2,l]) < abs(tbl[2,j])
                                                         then l:=j 
                                                         end_if#

                                                         l := j: break
                                                    end_if:
                                                    j:=j+1
                                                  end_while:

                                                  if l=0 then return([k,l]) end_if:                             # nein #
                                                  
                                                  h := {}:
                                                  i := 3:                                       
                                                  if tbl[2,l] < 0
                                                  then if not testtype(interval[tbl[1,l],lower],"_index")
                                                       then h := h union {tbl[1,l]}:
                                                            ht[tbl[1,l]] := 1:
                                                       end_if:
                                                       while i<= m+2 do
                                                         if not unlimited[tbl[i,1]] 
                                                         then if tbl[i,l] > 0 
                                                              then if k = 0 or tbl[i,2]/tbl[i,l] < mini
                                                                   then k:=i:
                                                                        mini := tbl[k,2]/tbl[k,l]:
                                                                        intervalpiv := FALSE
                                                                   end_if
                                                              elif not testtype(interval[tbl[i,1],lower],"_index") then

                                                                if tbl[i,l] < 0 then
                                                                  h := h union {tbl[i,1]}:
                                                                  ht[tbl[i,1]] := i:
                                                                end_if
                                                              end_if
                                                         end_if:
                                                         i:=i+1
                                                       end_while:
                                                       for i in h do
                                                         if ht[i] = 1 
                                                         then if k=0 or interval[i,lower] < mini then
                                                                k := 1:
                                                                mini := interval[i,lower]:
                                                                intervalpiv := TRUE
                                                              end_if 
                                                         elif k = 0 or (tbl[ht[i],2]-interval[i,lower])/tbl[ht[i],l] < mini
                                                           then k:=ht[i]:
                                                           mini := (tbl[k,2]-interval[i,lower])/tbl[k,l]:
                                                           intervalpiv := TRUE
                                                         end_if
                                                       end_for
                                                  else while i<= m+2 do
                                                         if not unlimited[tbl[i,1]] 
                                                         then if tbl[i,l] < 0 
                                                              then if k = 0 or tbl[i,2]/tbl[i,l] > mini
                                                                   then k:=i:
                                                                        mini := tbl[k,2]/tbl[k,l]:
                                                                        intervalpiv := FALSE
                                                                   end_if
                                                              elif not testtype(interval[tbl[i,1],lower],"_index") then
                                                                if tbl[i,l] > 0 then
                                                                  h := h union {tbl[i,1]}:
                                                                  ht[tbl[i,1]] := i:
                                                                end_if
                                                              end_if
                                                         end_if:
                                                         i:=i+1
                                                       end_while:
                                                       for i in h do
                                                         if k = 0 or (tbl[ht[i],2]-interval[i,lower])/tbl[ht[i],l] > mini
                                                           then k:=ht[i]:
                                                           mini := (tbl[k,2]-interval[i,lower])/tbl[k,l]:
                                                           intervalpiv := TRUE
                                                         end_if
                                                       end_for
                                                  end_if:
                                                        
                                                  if k = 0 then return([k,l]) else return([k,l,tbl[k,l],intervalpiv]) end_if:                                             
                                                end_proc,


                        "simplex"       =       proc(T)
                                                local i,f,erg,l,insertedvars,ergclean,scr,tbl,m,n,identset,equations,gfct,scrollanz,interval,piv;

                                                begin

                                                  if ((n = 0) and (m > 0)) then 
                                                    return(this::leer()) 
                                                  end_if:

                                                  erg := {}:
                                                  piv := [0,0,0,0,T[2]+2]:

                                                  repeat 
                                                    piv := this::pivot1(T[1],T[2],T[3],T[7],T[9],piv[5]):
#print(piv):#
                                                    if piv[1] = 0 then f := 1: break end_if:
                                                    if piv[2] = 0 then f := 2: break end_if:                                        
#this::print(T):#
                                                    T := Tableau::step(T,piv):
                                                  until 1 = 0 end_repeat:

                                                  if f = 2 then 
                                                        return(this::leer())
                                                  end_if:
                                                                                          
                                                  repeat 
                                                    piv := this::pivot2(T[1],T[2],T[3],T[7],T[9]):
#print(piv):#
                                                    if piv[2] = 0 then f := 1: break end_if:
                                                    if piv[1] = 0 then f := 2: break end_if:
#this::print(T):#
                                                    T := Tableau::step(T,piv):
                                                  until 1 = 0 end_repeat:

                                                
                                                  if f = 2 then
                                                        print("Abschlusstableau"):
                                                        print(T): 
                                                        print("Loesungsmenge ist unbeschraenkt"):
                                                        return(FAIL)
                                                  end_if:

                                                  tbl := T[1]:
                                                  m := T[2]:
                                                  n := T[3]:
                                                  identset := T[4]:
                                                  equations := T[5]:
                                                  gfct := T[6]:
                                                  scrollanz := T[8]:
                                                  interval := T[9]:


                                                 
                                                  for i from 3 to m+2 do
                                                        if not contains({slk[i]$hold(i)=1..m},tbl[i,1])# contains(identset,tbl[i,1])# then 
                                                          erg := erg union {tbl[i,1] = tbl[i,2]}:
                                                        end_if
                                                  end_for: 

                                                  for j from 3 to n+2 do
                                                        if not testtype(interval[tbl[1,j],lower],"_index") and
                                                           interval[tbl[1,j],greater]# and contains(identset,tbl[1,j])#
                                                        then ergclean := {}:
                                                             for i from 1 to nops(erg) do
                                                                if op(erg,[i,1]) = tbl[1,j] then 
                                                                   ergclean := ergclean union {op(erg,i)}
                                                                end_if
                                                             end_for: 
                                                             erg := (erg minus ergclean ) union {tbl[1,j] = interval[tbl[1,j],lower]}
                                                        elif not contains({slk[i]$hold(i)=1..m},tbl[1,j])# contains(identset,tbl[1,j])# then 
                                                            erg := erg union {tbl[1,j] = 0}
                                                        end_if
                                                  end_for:

                                                  erg := erg union {op(equations,[i,1]) = subs(op(equations,[i,2]),erg)$hold(i)=1..nops(equations)}:
                                        
#print(e[2]):# 
                                                  print("Loesung"):
                                                  insertedvars := {scr[i]$hold(i)=1..scrollanz}:
                                                  ergclean := {}:
                                                  
                                                  for i from 1 to nops(erg) do
                                                        if not contains(insertedvars,op(erg,[i,1]))
                                                        then ergclean := ergclean union {op(erg,i)}
                                                        end_if:
                                                  end_for:
#print(e[2]):#
                                                  return([ergclean,subs(gfct,erg)])
                                                        
                                                end_proc,

                        "maximize"      =       proc(list)
                                                local T,inteq,gfct;

                                                begin
                                                  if testargs() 
                                                  then 

                                                    if args(0) <> 1 then 
                                                        error("One list with set of (un)-equations and goalfunction expected")
                                                    end_if:

                                                    if (nops(list) < 2) or (nops(list) > 3)                             # input list ok? #
                                                    then error("List with set of (un)-equations and goalfunction expected")
                                                    end_if: 

                                                    if not testtype(op(list,1),DOM_SET) 
                                                    then error("Set of (un)-equations expected")
                                                    end_if:

                                                    gfct := op(list,2):
                                                    if (domtype(gfct) <> DOM_EXPR) and (domtype(gfct) <> DOM_IDENT) and not 
                                                        (testtype(gfct,DOM_INT) or testtype(gfct,DOM_FLOAT) or testtype(gfct,DOM_RAT))
                                                    then error("No correct goalfunction specified")
                                                    end_if:
                                                    
                                                    if nops(list) >= 3 then 
                                                        if testtype(op(list,3),DOM_SET)
                                                        then for i from 1 to nops(op(list,3)) do
                                                               if not testtype(op(list,[3,i]),DOM_IDENT) then
                                                                 print(op(list,[3,i])):
                                                                 error("Set of restricted variables expected")
                                                               end_if:
                                                             end_for
                                                        elif (op(list,3) <> NONNEGATIVE)
                                                          then print(op(list,3)): 
                                                               error("Set of restricted variables expected") 
                                                          end_if: 
                                                    end_if:

                                                    for i from 1 to nops(op(list,1)) do                                 
                                                        case type(op(op(list,1),i)) 
                                                        of "_leequal" do
                                                             inteq := op(op(list,1),[i,1])-op(op(list,1),[i,2]):
                                                             if testtype(inteq,"_plus")
                                                             then for j from 1 to nops(inteq) do                        # test all operands of 
                                                                                                                          the unequation #
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then if not ( ( testtype(op(inteq,[j,2]),DOM_INT  ) or
                                                                                    testtype(op(inteq,[j,2]),DOM_FLOAT) or 
                                                                                    testtype(op(inteq,[j,2]),DOM_RAT  ) ) and 
                                                                                    testtype(op(inteq,[j,1]),DOM_IDENT) )
                                                                         then print(op(op(list,1),i)):
                                                                              error("Linear optimization only!")
                                                                         end_if
                                                                    elif not ( testtype(op(inteq,j),DOM_INT  ) or
                                                                               testtype(op(inteq,j),DOM_FLOAT) or 
                                                                               testtype(op(inteq,j),DOM_RAT  ) or
                                                                               testtype(op(inteq,j),DOM_IDENT) )
                                                                      then print(op(op(list,1),i)):
                                                                           error("Linear optimization only!")
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then if not ( ( testtype(op(inteq,2),DOM_INT  ) or
                                                                               testtype(op(inteq,2),DOM_FLOAT) or 
                                                                               testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                               testtype(op(inteq,1),DOM_IDENT) )
                                                                    then print(op(op(list,1),i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                               elif not ( testtype(inteq,DOM_INT  ) or
                                                                          testtype(inteq,DOM_FLOAT) or 
                                                                          testtype(inteq,DOM_RAT  ) or
                                                                          testtype(inteq,DOM_IDENT) )
                                                                 then print(op(op(list,1),i)):
                                                                      error("Linear optimization only!")
                                                             end_if:
                                                             break
                                                        of "_equal" do
                                                             inteq := op(op(list,1),[i,1])-op(op(list,1),[i,2]):
                                                             if testtype(inteq,"_plus")                                 
                                                             then for j from 1 to nops(inteq) do                        
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then if not ( ( testtype(op(inteq,[j,2]),DOM_INT  ) or
                                                                                    testtype(op(inteq,[j,2]),DOM_FLOAT) or 
                                                                                    testtype(op(inteq,[j,2]),DOM_RAT  ) ) and 
                                                                                    testtype(op(inteq,[j,1]),DOM_IDENT) )
                                                                          then print(op(op(list,1),i)):
                                                                               error("Linear optimization only!")
                                                                          end_if
                                                                    elif not( testtype(op(inteq,j),DOM_IDENT) or
                                                                              testtype(op(inteq,j),DOM_INT  ) or
                                                                              testtype(op(inteq,j),DOM_FLOAT) or 
                                                                              testtype(op(inteq,j),DOM_RAT  )  )
                                                                        then print(op(op(list,1),i)):
                                                                             error("Linear optimization only!")
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then if not ( testtype(op(inteq,2),DOM_INT  ) or
                                                                             testtype(op(inteq,2),DOM_FLOAT) or 
                                                                             testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                             testtype(op(inteq,1),DOM_IDENT)
                                                                    then print(op(op(list,1),i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                               elif not ( testtype(inteq,DOM_IDENT) or 
                                                                          testtype(inteq,DOM_INT  ) or
                                                                          testtype(inteq,DOM_FLOAT) or 
                                                                          testtype(inteq,DOM_RAT  ) )
                                                                 then print(op(op(list,1),i)):
                                                                      error("Linear optimization only!")
                                                             end_if:
                                                             break:
                                                        otherwise 
                                                             print(op(op(list,1),i)):
                                                             error("Set of (un)-equations expected"):
                                                             break
                                                        end_case:
                                                    end_for:

                                                    if testtype(gfct,"_plus")
                                                    then for j from 1 to nops(op(gfct)) do                              # test all operands of 
                                                                                                                          the goalfunction #

                                                           if testtype(op(gfct,j),"_mult")                              # _mult(x,i) in this order ! #
                                                           then if not ( ( testtype(op(gfct,[j,2]),DOM_INT  ) or 
                                                                           testtype(op(gfct,[j,2]),DOM_FLOAT) or 
                                                                           testtype(op(gfct,[j,2]),DOM_RAT  ) ) and 
                                                                           testtype(op(gfct,[j,1]),DOM_IDENT) )
                                                                then print("Error in goalfunction :"):
                                                                     print(op(op(list,2),j)):
                                                                     error("Linear optimization only!")
                                                                end_if
                                                           elif not (testtype(op(gfct,j),DOM_INT  ) or 
                                                                     testtype(op(gfct,j),DOM_FLOAT) or 
                                                                     testtype(op(gfct,j),DOM_RAT  ) or
                                                                     testtype(op(gfct,j),DOM_IDENT) )
                                                             then  print("Error in goalfunction :"):
                                                                   print(op(op(list,2),j)):
                                                                   error("Linear optimization only!")
                                                           end_if:
                                                       end_for
                                                    elif testtype(gfct,"_mult")                                         # _mult(x,i) in this order ! #
                                                      then if not ( ( testtype(op(gfct,2),DOM_INT  ) or 
                                                                      testtype(op(gfct,2),DOM_FLOAT) or 
                                                                      testtype(op(gfct,2),DOM_RAT  ) ) and 
                                                                      testtype(op(gfct,1),DOM_IDENT) )
                                                           then print("Error in goalfunction :"):
                                                                print(op(list,2)):
                                                                error("Linear optimization only!")
                                                           end_if
                                                      elif not ( testtype(gfct,DOM_INT  ) or 
                                                                 testtype(gfct,DOM_FLOAT) or 
                                                                 testtype(gfct,DOM_RAT  ) or 
                                                                 testtype(gfct,DOM_IDENT) )
                                                        then print("Error in goalfunction :"):
                                                             print(op(list,2)):
                                                             error("Linear optimization only!")
                                                    end_if:

                                                  end_if:                                                               # testargs #

                                                  if nops(list) > 2 
                                                  then T := this([op(list,1),-op(list,2),op(list,i)$hold(i)=3..nops(list)])
                                                  else T := this([op(list,1),-op(list,2)])
                                                  end_if:
                                                  if bool(T <> {}) 
                                                  then lsg := this::simplex(T): 
#print(lsg):#
                                                       if testtype(lsg,DOM_LIST) then return([lsg[1],-lsg[2]]) end_if:
                                                       return(lsg)
                                                  end_if:     
                                                  return(T)
        
                                                end_proc,       

                        "minimize"      =       proc(list)
                                                local T,inteq;
                                                
                                                begin

                                                  if testargs() 
                                                  then 
                                                    if args(0) <> 1 then 
                                                        error("One list with set of (un)-equations and goalfunction expected")
                                                    end_if:

                                                    if (nops(list) < 2) or (nops(list) > 3)                             # input list ok? #
                                                    then error("List with set of (un)-equations and goalfunction expected")
                                                    end_if: 

                                                    if not testtype(op(list,1),DOM_SET) 
                                                    then error("Set of (un)-equations expected")
                                                    end_if:

                                                    gfct := op(list,2):
                                                    if (domtype(gfct) <> DOM_EXPR) and (domtype(gfct) <> DOM_IDENT) and not 
                                                        (testtype(gfct,DOM_INT) or testtype(gfct,DOM_FLOAT) or testtype(gfct,DOM_RAT))
                                                    then error("No correct goalfunction specified")
                                                    end_if:
                                                    
                                                    if nops(list) >= 3 then 
                                                        if testtype(op(list,3),DOM_SET)
                                                        then for i from 1 to nops(op(list,3)) do
                                                               if not testtype(op(list,[3,i]),DOM_IDENT) then
                                                                 print(op(list,[3,i])):
                                                                 error("Set of restricted variables expected")
                                                               end_if:
                                                             end_for
                                                        elif (op(list,3) <> NONNEGATIVE)
                                                          then print(op(list,3)): 
                                                               error("Set of restricted variables expected") 
                                                          end_if: 
                                                    end_if:

                                                    for i from 1 to nops(op(list,1)) do                                 
                                                        case type(op(op(list,1),i)) 
                                                        of "_leequal" do
                                                             inteq := op(op(list,1),[i,1])-op(op(list,1),[i,2]):
                                                             if testtype(inteq,"_plus")
                                                             then for j from 1 to nops(inteq) do                        # test all operands of 
                                                                                                                          the unequation #
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then if not ( ( testtype(op(inteq,[j,2]),DOM_INT  ) or
                                                                                    testtype(op(inteq,[j,2]),DOM_FLOAT) or 
                                                                                    testtype(op(inteq,[j,2]),DOM_RAT  ) ) and 
                                                                                    testtype(op(inteq,[j,1]),DOM_IDENT) )
                                                                         then print(op(op(list,1),i)):
                                                                              error("Linear optimization only!")
                                                                         end_if
                                                                    elif not ( testtype(op(inteq,j),DOM_INT  ) or
                                                                               testtype(op(inteq,j),DOM_FLOAT) or 
                                                                               testtype(op(inteq,j),DOM_RAT  ) or
                                                                               testtype(op(inteq,j),DOM_IDENT) )
                                                                      then print(op(op(list,1),i)):
                                                                           error("Linear optimization only!")
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then if not ( ( testtype(op(inteq,2),DOM_INT  ) or
                                                                               testtype(op(inteq,2),DOM_FLOAT) or 
                                                                               testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                               testtype(op(inteq,1),DOM_IDENT) )
                                                                    then print(op(op(list,1),i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                               elif not ( testtype(inteq,DOM_INT  ) or
                                                                          testtype(inteq,DOM_FLOAT) or 
                                                                          testtype(inteq,DOM_RAT  ) or
                                                                          testtype(inteq,DOM_IDENT) )
                                                                 then print(op(op(list,1),i)):
                                                                      error("Linear optimization only!")
                                                             end_if:
                                                             break
                                                        of "_equal" do
                                                             inteq := op(op(list,1),[i,1])-op(op(list,1),[i,2]):
                                                             if testtype(inteq,"_plus")                                 
                                                             then for j from 1 to nops(inteq) do                        
                                                                    if testtype(op(inteq,j),"_mult") 
                                                                    then if not ( ( testtype(op(inteq,[j,2]),DOM_INT  ) or
                                                                                    testtype(op(inteq,[j,2]),DOM_FLOAT) or 
                                                                                    testtype(op(inteq,[j,2]),DOM_RAT  ) ) and 
                                                                                    testtype(op(inteq,[j,1]),DOM_IDENT) )
                                                                          then print(op(op(list,1),i)):
                                                                               error("Linear optimization only!")
                                                                          end_if
                                                                    elif not( testtype(op(inteq,j),DOM_IDENT) or
                                                                              testtype(op(inteq,j),DOM_INT  ) or
                                                                              testtype(op(inteq,j),DOM_FLOAT) or 
                                                                              testtype(op(inteq,j),DOM_RAT  )  )
                                                                        then print(op(op(list,1),i)):
                                                                             error("Linear optimization only!")
                                                                    end_if:
                                                                  end_for
                                                             elif testtype(inteq,"_mult") 
                                                               then if not ( testtype(op(inteq,2),DOM_INT  ) or
                                                                             testtype(op(inteq,2),DOM_FLOAT) or 
                                                                             testtype(op(inteq,2),DOM_RAT  ) ) and 
                                                                             testtype(op(inteq,1),DOM_IDENT)
                                                                    then print(op(op(list,1),i)):
                                                                         error("Linear optimization only!")
                                                                    end_if
                                                               elif not ( testtype(inteq,DOM_IDENT) or 
                                                                          testtype(inteq,DOM_INT  ) or
                                                                          testtype(inteq,DOM_FLOAT) or 
                                                                          testtype(inteq,DOM_RAT  ) )
                                                                 then print(op(op(list,1),i)):
                                                                      error("Linear optimization only!")
                                                             end_if:
                                                             break:
                                                        otherwise 
                                                             print(op(op(list,1),i)):
                                                             error("Set of (un)-equations expected"):
                                                             break
                                                        end_case:
                                                    end_for:

                                                    if testtype(gfct,"_plus")
                                                    then for j from 1 to nops(op(gfct)) do                              # test all operands of 
                                                                                                                          the goalfunction #

                                                           if testtype(op(gfct,j),"_mult")                              # _mult(x,i) in this order ! #
                                                           then if not ( ( testtype(op(gfct,[j,2]),DOM_INT  ) or 
                                                                           testtype(op(gfct,[j,2]),DOM_FLOAT) or 
                                                                           testtype(op(gfct,[j,2]),DOM_RAT  ) ) and 
                                                                           testtype(op(gfct,[j,1]),DOM_IDENT) )
                                                                then print("Error in goalfunction :"):
                                                                     print(op(op(list,2),j)):
                                                                     error("Linear optimization only!")
                                                                end_if
                                                           elif not (testtype(op(gfct,j),DOM_INT  ) or 
                                                                     testtype(op(gfct,j),DOM_FLOAT) or 
                                                                     testtype(op(gfct,j),DOM_RAT  ) or
                                                                     testtype(op(gfct,j),DOM_IDENT) )
                                                             then  print("Error in goalfunction :"):
                                                                   print(op(op(list,2),j)):
                                                                   error("Linear optimization only!")
                                                           end_if:
                                                       end_for
                                                    elif testtype(gfct,"_mult")                                         # _mult(x,i) in this order ! #
                                                      then if not ( ( testtype(op(gfct,2),DOM_INT  ) or 
                                                                      testtype(op(gfct,2),DOM_FLOAT) or 
                                                                      testtype(op(gfct,2),DOM_RAT  ) ) and 
                                                                      testtype(op(gfct,1),DOM_IDENT) )
                                                           then print("Error in goalfunction :"):
                                                                print(op(list,2)):
                                                                error("Linear optimization only!")
                                                           end_if
                                                      elif not ( testtype(gfct,DOM_INT  ) or 
                                                                 testtype(gfct,DOM_FLOAT) or 
                                                                 testtype(gfct,DOM_RAT  ) or 
                                                                 testtype(gfct,DOM_IDENT) )
                                                        then print("Error in goalfunction :"):
                                                             print(op(list,2)):
                                                             error("Linear optimization only!")
                                                    end_if:

                                                  end_if:                                                               # testargs #

                                                  T := this(list):
                                                  if bool(T <> {}) 
                                                  then return(this::simplex(T))
                                                  else return(T)
                                                  end_if

                                                end_proc,

                        "print"         =       proc(T)
                                                begin
                                                  print(T[1]):
                                                  #print(T[2]):
                                                  print(T[3]):
                                                  print(T[4]):
                                                  print(T[5]):
                                                  print(T[6]):
                                                  print(T[7]):
                                                  print(T[8]):#
                                                  print(T[9]):
                                                end_proc,

                        "leer"          =       proc()
                                                begin
                                                  if args(0) > 0 then
                                                    print("Abschlusstableau"): 
                                                    print(args(1)) 
                                                  end_if:
                                                  print("Loesungsmenge ist leer"):
                                                  return({})
                                                end_proc                        

)():
