# #
# $Date: 1997/10/07 08:29:35 $  $Author: wseiler $   $Revision: 1.3 $ #
# #
#
Removal of duplicate elements of a list.
Note that if several identical elements are contained in a list,
the *last* one of these is kept.

Authors: Eduard Niess, Werner M. Seiler, Uni Karlsruhe
Date created: May 23rd, 1996
Last update: September 29th, 1997
#

listtools::removeDuplicates:= 
    proc(l:DOM_LIST):DOM_LIST
    local i,k,res;
    begin
        res := [ 0 $ nops(l)];
	k := 0;
        while l<>[] do
            if contains(l,l[1],2)=0 then
		k := k+1;
                res[k] := l[1];
	    end_if;
            l[1] := NIL;
        end_while;
	[op(res,1..k)];
    end_proc:

# end of file #
