numeric::fint:= proc(ex,range,opt)
    local a, b;
begin
    if testargs() then
	if type(range) <> "_equal" then
	    error("For 2nd arg, range x=a..b expected")
	end_if;	
        if domtype( op(range,1) ) <> DOM_IDENT then
	    error("invalid integration variable")
	else
	    a:= op(range,[2,1]); b:= op(range,[2,2]);
	    if domtype( float(a) ) <> DOM_FLOAT or domtype( float(b) ) <> DOM_FLOAT then
	        error("left and right endpoint must have numerical expressions")
	    end_if
	end_if;
	if args(0) > 3 then
	    error("wrong no of args (expecting 2 or 3)")
	elif args(0) = 3 then
	    if opt <> Adaptive then
		if type(opt) <> "_equal" then
		    error("invalid third argument")
		elif op(opt,1) <> SymbolicAnalysis or op(opt,2) <> FALSE then
		    error("invalid third argument")
		end_if
	    end_if
	end_if
    end_if;
    if args(0) = 3 then
	# call intlib::float, hence no symbolic analysis will be performed #
	if opt = Adaptive then
	    return( intlib::float( misc::freeze(int)(ex,range),opt ) )
	else
	    return( intlib::float( misc::freeze(int)(ex,range) ) )
	end_if
    else
	return( float(misc::freeze(int)( ex,range )) )
    end_if
end_proc:

# end of file #
