numlib::decimal := proc(a) # a is a rational #
local p,q,s,l,i;
begin
   case type(a)
   of DOM_INT do return(a,[0])
   of DOM_RAT do break # ok#
   otherwise error("rational number expected")
   end_case;
   if a<0 then error("only nonnegative argument allowed") end_if;
   p:=op(a,1); q:=op(a,2);
   s:=p;
   l:=p div q; p:=p mod q;
   repeat
      s:=p,s;
      p:=10*p;
      l:=l,p div q;
      p:=p mod q;
   until (i:=contains([s],p))<>0 or (p=0) end_repeat;
   if p=0 then l else op(l,1..nops(l)-i),[op(l,nops(l)-i+1..nops(l))] end_if;
end_proc:
