# $Date: 1997/04/17 09:26:58 $ $Author: stefanw $ $Revision: 1.2 $ #
# Stefan Wehmeier 16.4.1997 #

#-- 
Omega - Omega function
Omega(m)
m - natural number
--#

numlib::Omega := proc(m)
  local p,i;
begin
  if testargs() then
    if args(0) <> 1 then
      error("expected one argument in function call")
    elif not testtype(m,NUMERIC) then
	    return(procname(args()))
	  elif domtype(m) <> DOM_INT or m < 1 then
	    error("argument must be a natural number")
	  end_if
  end_if;
  
  if m = 1 then
    1
  else
    p := ifactor(m);
    _plus(p[2*i+1] $hold(i)=1..nops(p) div 2) 
  end_if
end_proc:

#--
omega - Omega function
omega(m)
m - integer 
--#

numlib::omega := subsop(numlib::numprimedivisors,6=hold(numlib::omega)): 
     
