#-

This isn't really a density plot. It is only a special
view at this 3D scene. See camera and focal point.

densityplot([Mode=Surface, [u,v,1/2*sin(u*u + v*v)], u=[0,PI], v=[0, PI]]):

--> plot3d(CameraPoint=[0,-100,100000000], FocalPoint= [0,0,0],
           [Mode=Surface, [u,v,1/2*sin(u*u + v*v)], u=[0,PI], v=[0, PI],
           Color=[Height], Style=[ColorPatches,Only]])

-#

plotlib::densityplot := proc()
    local color, i, j, l, new_args, r, style;
begin

    if args(0) = 0 then 
        plot(Dimension = 3)
    else 
        new_args := null();

        for i from 1 to args(0) do 
          if type(args(i)) = "_equal" then
             l := args(i);
             if op(l, 1) = CameraPoint or op(l, 1) = FocalPoint then
                next
             end_if
          elif domtype(args(i)) = DOM_LIST then
             l := []; color := TRUE; style := TRUE;
             for j from 1 to nops(args(i)) do
                 r := args(i)[j];
                 if type(r) = "_equal" then
                    if op(r,1) = Color then
                       color := FALSE
                    elif op(r,1) = Style then
                       style := FALSE
                    end_if
                 end_if;
                 l := append(l, r);
             end_for; 
             if color then
                l := append(l, Color=[Height])
             end_if;
             if style then 
                l := append(l, Style=[ColorPatches,Only]) 
             end_if;
          end_if;
          new_args := new_args, l
         end_for;

         new_args := CameraPoint=[0,-100,100000000], 
                     FocalPoint= [0,0,0], new_args;

        plot3d(new_args)
    end_if
end_proc:
