

#( Pid - Domain of 'Id of Properties' )#

alias(POp = property::POp):
alias(Pid = POp::Pid):

Pid:= domain("POp::Pid"):
Pid::info:= "Identity of Properties":
Pid::type:= "Pid":
  
Pid::new:=
	proc()
	begin
	  new(Pid, args())
	end_proc:

Pid::expr:=
	proc()
	begin
	  map(op(args()), POp::expr)
	end_proc:
	
Pid::_subtract:=
	fun(hold(_subtract)(args())):

Pid::_mult:=
	fun(hold(_mult)(args())):

Pid::_divide:=
	fun(hold(_divide)(args())):

Pid::_and:=
	fun(hold(_and)(args())):

Pid::_or:=
	fun(hold(_or)(args())):

Pid::_not:=
	fun(hold(_not)(args())):

Pid::print:=
	proc()
	begin
	  expr2text(op(args()))
	end_proc:

unalias(Pid):
unalias(POp):
