

#( Pnegate - Domain of 'Negation of Properties' )#

alias(POp = property::POp):
alias(Pnegate = POp::Pnegate):

Pnegate:= domain("POp::Pnegate"):
Pnegate::info:= "Negation of Properties":
Pnegate::type:= "Pnegate":
Pnegate::Ptype:= "Ptype":
  
Pnegate::new:=
	proc()
	begin
	  if args(0) > 1 then
	    return(map(args(), Pnegate))
	  end_if;
	  if type(args()) = "Pnegate" then
	    op(args())
	  else
	    new(Pnegate, args())
	  end_if
	end_proc:

Pnegate::expr:=
	proc()
	begin
	  POp::_expr(_negate, args())
	end_proc:
	
Pnegate::print:=
	proc()
	begin
	  "-" . expr2text(op(args()))
	end_proc:

unalias(Pnegate):
unalias(POp):