

#( Por - Domain of 'Or of Properties' )#

alias(Por = (property::POp)::Por):

Por:= domain("POp::Por"):
Por::info:= "Inversion of Properties":
Por::type:= "Por":
Por::Ptype:= "Pbool":
  
Por::new:=
	proc()
	begin
	  if args(0) = 1 then
	    args()
	  elif args(0) = 2 then
	    new(Por, args())
	  else
	    new(Por, args())
	  end_if
	end_proc:

Por::expr:=
	proc()
	  local i;
	begin
	  for i from 1 to args(0) do
	    if POp::expr(args(i)) = TRUE then
	      return(TRUE)
	    end_if
	  end_for;
	  return(FALSE)
	end_proc:
	
Por::print:=
	proc()
	  local i, l;
	begin
	  if nops(args()) > 0 then
	    l:= "(" . expr2text(op(args(), 1));
	    i:= 2;
	    while i <= nops(args()) do
	      l:= l . " or " . expr2text(op(args(), i));
	      i:= i + 1
	    end_while;
	    l . ")"
	  end_if;
	end_proc:

unalias(Por):