
#(
   Prop - generic property domain
          primitive implementation - only table rules
)#

alias(Prop = property::Prop):

Prop:= domain("property::Prop"):
Prop::info:= "Domain of generic property 'Prop'":
Prop::domtype:= fun(Type):
Prop::type:= "Prop":
Prop::prop:= TRUE:
Prop::propdom:= domattr(property, "Prop"):
Prop::autoload:= TRUE:
Prop::testtype:= Type::testtype:

Prop::ax:= []:

Prop::new:= 
	proc()
	begin
	  if args(0) > 0 then
	    new(Prop, args())
	  else
	    new(Prop, NIL)
	  end_if
	end_proc:

#( gibt bool zur"uck, ob aus arg1, ..., argn-1 -> argn folgt )#
Prop::is:=
	proc()
	begin
	  if args(args(0)) = args(1) then return(TRUE) end_if;
	  return(UNKNOWN)
	end_proc:

Prop::_and:=
	proc()
	begin
	  property::_Op(Prop, _and, fun(hold(_and)(args())), args())
	end_proc:

Prop::_or:=
	proc()
	begin
	  property::_Op(Prop, _or, fun(hold(_or)(args())), args())
	end_proc:

Prop::_not:=
	proc()
	begin
	  property::_Op(Prop, _not, fun(hold(_not)(args())), args())
	end_proc:

Prop::_plus:=
	proc()
	begin
	  property::_Op(Prop, _plus, fun(hold(_plus)(args())), args())
	end_proc:

Prop::_subtract:=
	proc()
	begin
	  property::_Op(Prop, _subtract, fun(hold(_subtract)(args())), args())
	end_proc:

Prop::_negate:=
	proc()
	begin
	  property::_Op(Prop, _negate, fun(hold(_negate)(args())), args())
	end_proc:

Prop::_mult:=
	proc()
	begin
	  property::_Op(Prop, _mult, fun(hold(_mult)(args())), args())
	end_proc:

Prop::_divide:=
	proc()
	begin
	  property::_Op(Prop, _divide, fun(hold(_divide)(args())), args())
	end_proc:

Prop::_invert:=
	proc()
	begin
	  property::_Op(Prop, _invert, fun(hold(_invert)(args())), args())
	end_proc:

Prop::_power:=
	proc()
	begin
	  property::_Op(Prop, _power, fun(hold(_power)(args())), args())
	end_proc:

Prop::print:=
	proc()
	begin
	  "Prop(" . expr2text(op(args())) . ")"
	end_proc:

unalias(Prop):