alias(Is = property::__Is):

#( l"oscht Eigenschaften - unassume(ident, < prop >) )#
property::unassume:=
	proc(ident, prop)
	  local _pr, idprops, _v, __x;
	begin
          if property::PROPLEVEL <= 1 then
            if type(ident)<>DOM_IDENT then __x:=indets(ident) else __x:={ident} end_if;
            if (_v:=op(Is,5))<>NIL then
               sysassign(Is,subsop(Is,5=table(op(select([op(_v)],not has,__x)))))
            end_if;
            #for _v in __x do sysassign(sign(_v), NIL) end_for;#
            for _v in __x do
                sysassign( sign, subsop( sign,
	         [1,5] = select( op(sign,[1,5]),not has,_v)
                ) );
            end_for;
          end_if;

	  if property::PROPLEVEL <> 1 then
	    property::reset():
	    if contains({"_less", "_leequal", "_equal", "_unequal"},
		        type(ident)) then
	      return(property::delrel(args()))
	    end_if;
	    if args(0) = 0 then
	      if property::gdef <> null()  then
	        sysassign(property::gdef, null());
	        return(TRUE)
	      else
	        return(FALSE)
	      end_if
	    end_if;
	    if args(0) = 1 then
	      if contains({DOM_SET, DOM_LIST}, domtype(args(1))) then
	        for _pr from 1 to nops(args(1)) do
	          property::unassume(op(args(1), _pr))
	        end_for;
	        return()
	      elif domtype(ident) = DOM_IDENT then
	        properties(ident, FAIL);
	        userinfo(9, "Removing all properties.");
	        return(TRUE)
	      elif property::gdef <> null() and (ident)::propdom <> FAIL then
	        sysassign(property::gdef, subs(property::gdef, ident = null()));
	        return(TRUE)
	      else
	        return(FAIL)
	      end_if
	    end_if;
	    idprops:= properties(ident);
	    _pr:= eval(subs(idprops, prop = null()));
	    if nops(_pr) < nops (idprops) then
	      if nops(_pr) > 0 then
	        properties(ident, _pr)
	      else
	        properties(ident, FAIL)
	      end_if;
	      userinfo(9, "Removing: " . expr2text(prop));
	      return(TRUE)
	    end_if;
	    userinfo(9, "No property: " . expr2text(prop));
	    return(FALSE)
	  end_if;
	  null()
	end_proc:

#( (rel, _Op) l"oscht eine Relation )#
property::delrel:=
	proc(_rel, _Op)
	  local __op, op1, op2, __ret;
	begin
	  property::reset():
	  op1:= _if(domtype(op(_rel, 1)) = DOM_IDENT, op(_rel, 1), null());
	  op2:= _if(domtype(op(_rel, 2)) = DOM_IDENT, op(_rel, 2), null());
	  _Op:= _if(hold(_Op) = _Op, null(), _Op);
	  __ret:= null();
	  __op:= op(_rel, 0);
	  if domtype(op1) <> DOM_NULL then
	    __ret:= property::unassume(op1, property::Rel(op1, __op,
					                 op(_rel, 2)), _Op)
	  end_if;
	  if domtype(op2) <> DOM_NULL then
	    __ret:= property::unassume(op2, property::Rel(op2, -__op,
					                 op(_rel, 1)), _Op)
	  end_if;
	  __ret
	end_proc:

unassume:= property::unassume:

unalias(Is):
