alias(POp = property::POp):

#( Standard-Operator: Domain, Operator, Funktion f"ur zwei Argumente )#
property::_Op:=
	proc(_dom, _op, _proc)
	  local Args, _ret, _rule, _dom2;
	begin
	  if args(0) = 4 then return(args(4)) end_if;
	  if args(0) = 5 then

	  if contains({property::Undefined, property::Unknown}, args(4)) then
	    return(args(4))
	  end_if;
	  if contains({property::Undefined, property::Unknown}, args(5)) then
	    return(args(5))
	  end_if;

	    _rule:= POp::Prule(_op, args(4..5));
	    userinfo(9, "Rule?");
	    _ret:= property::_getrule(_dom, _rule);
	    if _ret <> FAIL then return(_ret) end_if;
	    if nops(map({(args(4))::propdom, (args(5))::propdom},
		        domattr, "prop")) = 1 then
	      _dom2:= domattr(args(_if(_dom = (args(4))::propdom, 5, 4)), "propdom")
	    else
	      _dom2:= _dom
	    end_if;

	    #userinfo(10, "_Op: domains - ".expr2text((args(5))::prop));#
	    if (_dom2 <> _dom) then
	      #userinfo(10, "_Op: second domain rule");#
	      _ret:= property::_getrule(_dom2, _rule);
	      if _ret <> FAIL then return(_ret) end_if;
	    end_if;
	    userinfo(9, "Function?");
	    _ret:= property::_getfunc(_dom, _rule);
	    if _ret <> FAIL then return(_ret) end_if;
	    if (_dom2 <> _dom) then
	      #userinfo(10, "_Op: second domain function");#
	      _ret:= property::_getfunc(_dom2, _rule);
	      if _ret <> FAIL then return(_ret) end_if;
	    end_if;

	    userinfo(9, "Convert?");
	    #( informativeres Domain )#
	    if contains(property::incl, _dom2::type) then
	      if contains(property::incl[_dom2::type], _dom::type) then
	        _dom:= _dom2;
	        _proc:= _op
	      end_if
	    end_if;

	    Args:= property::convertArgs(_dom, args(4..5));

	    if op(Args, 0) = hold(_no) then
	      userinfo(9, "Return hold");
	      #( Verkn"upfung in gemeinsamer Obermenge )#
	      if (_rule:= contains(map([map(op(property::incl), op, 2)],
	                    fun(bool(map({args(2..3)}, type) minus
	                      args(1) = {})), args(4..5)), TRUE)) > 0 then
	        Args:= property::convertArgs(domattr(property,
	                 op(property::incl, [_rule, 1])), args(4..5));
	        if op(Args, 0) = hold(_yes) then
	          _ret:= property::_Op(domattr(property,
	                   op(property::incl, [_rule, 1])), _op, _op, op(Args));
	          if type(_ret) <> expr2text(_op) then
	            return(_ret)
	          end_if
	        end_if
	      end_if;
	      return(subsop(Args, 0 = _op, Unsimplified))
	    end_if;
	    if op(Args, 0) = hold(_yes) then
	      userinfo(9, "Own proc");
	      _ret:= _proc(op(Args));
	      if type(_ret) = expr2text(_op) then
	        #( Verkn"upfung in gemeinsamer Obermenge )#
	        if (_rule:= contains(map([map(op(property::incl), op, 2)],
	                      fun(bool(map({args(2..3)}, type) minus
	                        args(1) = {})), args(4..5)), TRUE)) > 0 then
	          Args:= property::convertArgs(domattr(property,
	                   op(property::incl, [_rule, 1])), args(4..5));
	          if op(Args, 0) = hold(_yes) then
	            _ret:= property::_Op(domattr(property,
	                     op(property::incl, [_rule, 1])), _op, _op, op(Args));
	            if type(_ret) <> expr2text(_op) then
	              return(_ret)
	            end_if
	          end_if
	        end_if;
	        return(subsop(Args, 0 = _op, Unsimplified))
	      else
	        return(_ret)
	      end_if
	    else
	      userinfo(9, "Return more");
	      return(_op(op(Args)))
	    end_if
	  else
	    userinfo(9, "More than two Operands - ".expr2text(args(), args(0)));
	    return(property::Op(_op, args(4..args(0))))
	  end_if

	end_proc:

#( Standard-Auswertung f"ur mehr als zwei Parameter )#
#( Operator, Argumente (min. 3 - _exprseq) )#
property::Op:=
	proc()
	  local pr, ret, Ret, _T, _op, i;
	begin
	  if args(0) < 4 then
	    userinfo(9, "Less than tree operands");
	    return(eval(args(1))(args(2..args(0))))
	  end_if;

	  _T:= expr2text(args(1));
	  _op:= args(1);
	  #pr:= args(2..args(0));#

	  pr:= op(sort([args(2..args(0))],
	               fun(bool(expr2text((args(1))::type())
	                        <expr2text((args(2))::type())))));

	  #( zuerst: nur Operanden gleichen Domains )#
	  ret:= op(pr, 1);
	  for i from 2 to nops(pr) do
	    if domtype(ret) = DOM_EXPR then
	      if type(op(ret, nops(ret))) = type(op(pr, i)) then
	        Ret:= _op(op(ret, nops(ret)), op(pr, i));
	        if domtype(Ret) = DOM_EXPR then
	          ret:= op(ret, 1..nops(ret)-1), op(Ret)
	        else
	          ret:= op(ret, 1..nops(ret)-1), Ret
	        end_if
	      else
	        ret:= op(ret), op(pr, i)
	      end_if
	    else
	      if type(ret) = type(op(pr, i)) then
	        Ret:= _op(ret, op(pr, i));
	        if domtype(Ret) = DOM_EXPR then
	          ret:= op(Ret)
	        else
	          ret:= Ret
	        end_if
	      else
	        ret:= ret, op(pr, i)
	      end_if
	    end_if
	  end_for;

	  if type(ret) <> "_exprseq" then return(ret) end_if;

	  #( dann: nacheinander )#
	  pr:= ret;
	  ret:= op(pr, 1);
	  for i from 2 to nops(pr) do
	    if domtype(ret) = DOM_EXPR then
	      Ret:= _op(op(ret, nops(ret)), op(pr, i));
	      if domtype(Ret) = DOM_EXPR then
	        ret:= op(ret, 1..nops(ret)-1), op(Ret)
	      else
	        ret:= op(ret, 1..nops(ret)-1), Ret
	      end_if
	    else
	      Ret:= _op(ret, op(pr, i));
	      if domtype(Ret) = DOM_EXPR then
	        ret:= op(Ret)
	      else
	        ret:= Ret
	      end_if
	    end_if
	  end_for;

	  if domtype(ret) <> DOM_EXPR then return(ret) end_if;
	  userinfo(9, "More than one-operand result");
	  return(subsop(hold(id)(ret), 0 = _op, Unsimplified))
	end_proc:

#( Lazy-map(_expA, _proc, args...) )#
#( _expA - Pbool )#
property::lzeval:=
	proc(_expA, _proc)
	  local i, n, ret, _ok, _oko, _okp;
	begin
	  if type(_expA) = "Pand" then
	    _ok:= FALSE;
	    _oko:= _or
	  elif type(_expA) = "Por" then
	    _ok:= TRUE;
	    _oko:= _and
	  else
	    #return(_proc(_expA))#
	  end_if;
	  n:= nops(_expA);
	  i:= 0;
	  ret:= UNKNOWN;
	  _okp:= UNKNOWN;
	  if not(POp::Ptype(_expA, "Pbool")) then
	    ret:= _proc(expr(_expA), args(3..args(0)));
	    return(ret)
	  end_if;
	  repeat
	    i:= i + 1;
	    if POp::Ptype(op(_expA, i), "Pbool") then
	      ret:= property::lzeval(op(_expA, i), _proc, args(3..args(0)))
	    else
	      ret:= _proc(#expr#(op(_expA, i)), args(3..args(0)))
	    end_if;
	    _okp:= _okp &_oko ret;
	  until (ret = _ok) or (i = n) end_repeat;
	  return(_if(ret = _ok, ret, _okp))
	end_proc:

#( rekursives map - auch f"ur Teil-Ausdr"ucke )#
property::mapr:=
	proc(ex, fu)
	  local i, lo, li;
	begin
	  lo:= [op(ex)];
	  li:= [0 $i=1..nops(ex)];
	  i:= 0;
	  i:= contains([map(op(lo), domtype)], DOM_EXPR);
	  while i > 0 do
	    lo:= subsop(lo, i = property::mapr(op(lo, i),
			                       fu, args(3..args(0))));
	    li:= subsop(li, i = 1);
	    i:= contains([map(op(lo), domtype)], DOM_EXPR, i + 1)
	  end_while;
	  for i from 1 to nops(lo) do
	    if op(li, i) = 0 then
	      lo:= subsop(lo, i = fu(op(lo, i), args(3..args(0))))
	    end_if
	  end_for;
	  return(op(ex, 0)(op(lo)));
	end_proc:

#( rekursives map von P-Ausdr"ucken )#
property::mapp:=
	proc(_type, _ex, _fu)
	  local i, lo, li;
	begin
	  #if args(0) < 3 then _type:= null() end_if;#
	  if POp::Ptype(_ex, _type) then
	    lo:= [op(_ex)];
	    li:= [0 $i=1..nops(_ex)]
	  else
	    lo:= [_ex];
	    li:= [0]
	  end_if;
	  i:= 0;
	  i:= contains([map(op(lo), POp::Ptype, _type)], TRUE);
	  while i > 0 do
	    lo:= subsop(lo, i = property::mapp(_type, op(lo, i),
			                       _fu, args(3..args(0))));
	    li:= subsop(li, i = 1);
	    i:= contains([map(op(lo), POp::Ptype, _type)], TRUE, i + 1)
	  end_while;
	  for i from 1 to nops(lo) do
	    if op(li, i) = 0 then
	      lo:= subsop(lo, i = _fu(op(lo, i),
			             _if(args(0) > 3, args(4..args(0)), null())))
	    end_if
	  end_for;
	  return(_if(POp::Ptype(_ex, _type), op(_ex, 0), id)(op(lo)));
	end_proc:

#( Standard-Test-/Konvertierungsroutine f"ur Domain-Operationen )#
#( Args: Ziel-Domain, args(1), args(2) )#
property::convertArgs:=
	proc(_dom)
	  local _rg1, _rg2, _op;
	begin
	  _op:= hold(_yes);
	  
	  _rg1:= args(2);
	  if (args(2))::propdom <> _dom then
	    _rg1:= property::convert_to(_rg1, _dom);
	    if (_rg1)::propdom <> _dom then
	      if (args(2) <> _rg1) and
	         not(contains({property::Null, FAIL}, _rg1)) then
	        _op:= hold(_xx);
	        _rg1:= args(2)
	      else
	        _op:= hold(_no);
	        _rg1:= args(2)
	      end_if
            end_if
          end_if;
          
          _rg2:= args(3);
          if (args(3))::propdom <> _dom then
	    _rg2:= property::convert_to(_rg2, _dom);
	    if (_rg2)::propdom <> _dom then
	      if (args(3) <> _rg2) and
	         not(contains({property::Null, FAIL}, _rg2)) then
	        _op:= hold(_xx);
	        _rg2:= args(3)
	      else
	        if _op <> hold(_xx) then
	          _op:= hold(_no);
	          _rg2:= args(3)
	        end_if
	      end_if
	    end_if
	  end_if;

	  if (_rg1 = args(2)) and (_rg2 = args(3)) and _op <> hold(_yes) then
	    _op:= hold(_no)
	  end_if;

	  return(_op(_rg1, _rg2))
	end_proc:

#( Konvertierung - Schnittstelle )#
property::convert_to:=
	proc(prop, _to)
	  local ret;
	begin
	  if contains({property::Unknown, property::Null, property::Undefined},
	              prop) then
	    return(prop)
	  end_if;
	  #( kein Ziel )#
	  if _to = hold(_to) then
	    #( numerisch )#
	    if not(contains({DOM_INT, DOM_RAT, DOM_FLOAT}, domtype(prop))) and
	       domtype((ret:= float(prop))) = DOM_FLOAT then
	      userinfo(9, "convert_to: float ".expr2text(ret));
	      return(ret)
	    end_if;
	    return(prop)
	  end_if;
	  #( Domain-Element statt Domain )#
	  if domtype(_to) <> DOM_DOMAIN then
	    _to:= domattr(_to, "propdom")
	  end_if;
	  #( nichts zu konvertieren )#
	  if domattr(prop, "propdom") = _to then
	    return(prop)
	  end_if;
	  if domtype(prop) = DOM_EXPR then
	    return(FAIL)
	  end_if;

	  #( System-Konstanten und auswertbare Funktionen )#
	  if domtype(prop) = DOM_IDENT then
	    if domtype((ret:= float(prop))) = DOM_FLOAT then
	      userinfo(9, "convert_to: float ".expr2text(ret));
	      return(property::convert_to(ret, _to))
	    end_if
	  end_if;

          #( Generierung von Eigenschaften, Konvertierung )#
	  _to:= _if(_to::type <> FAIL, _to::type, expr2text(_to));
	  userinfo(2, "convert_to: ".expr2text(prop)." --> ".expr2text(_to));
	  ret:= domattr(domattr(prop, "propdom"), _to)(prop);
	  userinfo(9, "convert_to: gen - ".expr2text(ret));
	  if ret <> FAIL then
	    return(ret)
	  end_if;
	  #( Standard-Typen )#
	  ret:= domattr(domtype(prop), _to)(prop);
	  userinfo(9, "convert_to: gen - ".expr2text(ret));
	  if ret <> FAIL then
	    return(ret)
	  end_if;
	  return(property::Unknown)
	  #return(prop)#
	end_proc:

#( wendet expr auf einem P-Ausdruck an mit Ziel! )#
property::expr:=
	proc(_expr)
	  local _to, __i, __ret, __con;
	begin
	  if args(0) = 1 then
	    return(expr(_expr))
	  elif args(0) = 2 then
	    _to:= args(2);
	    repeat
	      __i:= contains(map([op(_expr)], POp::Ptype), TRUE);
	      if __i > 0 then
	        _expr:= subsop(_expr, __i = property::expr(op(_expr, __i), _to))
	      end_if;
	    until __i = 0 end_repeat;
	    __i:= contains(map([op(_expr)], domattr, "propdom"), _to);
	    if __i > 0 then #( ein Argument schon richtiges Ziel )#
	      __ret:= #property::#expr(subsop(_expr, 1 = op(_expr, __i),
	                                           __i = op(_expr, 1))#, _to#);
	      if domattr(__ret, "propdom") = _to then return(__ret) end_if
	    end_if;
	    __i:= contains(map([op(_expr)], domattr, "prop"), FAIL);
	    if __i > 0 then #( ein Argument Basistyp --> konvertieren )#
	      __con:= domattr(domattr(op(_expr, __i), "propdom"),
	                      _to::type)(op(_expr, __i));
	      if __con <> FAIL then
	        __ret:= #property::#expr(subsop(_expr, __i = op(_expr, 1),
	                                             1 = __con)#, _to#);
	        if domattr(__ret, "propdom") = _to then return(__ret) end_if
	      end_if
	    end_if;
	    return(expr(_expr))
	  end_if;
	  null()
	end_proc:

unalias(POp):