#( Funktionsattribute "getprop" )#
ln:= funcattr(ln, "getprop",
       loadproc(funcattr(ln, "getprop"), pathname("PROP", "GETPROP"), "ln")):
exp:= funcattr(exp, "getprop",
        loadproc(funcattr(ln, "getprop"), pathname("PROP", "GETPROP"), "exp")):

alias(POp = property::POp):
#( gibt alle Eigenschaften aus )#
property::getprop:=
	proc()
	  local __rEt__;
	begin
	  userinfo(1, "*** getprop --> ".expr2text(args()));
	  property::reset():
	  __rEt__:= property::_getprop(args());
	  property::reset():
	  userinfo(1, "*** getprop <-- ".expr2text(__rEt__));
	  return(__rEt__)
	end_proc:

#( intern )#
property::_getprop:=
	proc(_expr, _to)
	  option remember;
	  local __f_, __ret__;
	begin
	  if _to = hold(_to) then _to:= null() end_if;
	  sysassign(property::_getprop(args()), args());
	  if domtype(_expr) = DOM_IDENT then
	    #return(property::convert_to(properties(_expr), DOM_IDENT))#
	    if properties(_expr) <> FAIL then
	      __ret__:= (properties(_expr))
	    else
	      __ret__:= (property::convert_to(_expr, _to))
	    end_if
	  else
	    if domtype(_expr) = DOM_EXPR then
	      #( Ziel der Konvertierung )#
	      if _to = hold(_to) then
	        _to:= contains([map(op(_expr), domattr, "prop")], TRUE);
	        if _to > 0 then
	          _to:= domattr((op(_expr, _to)), "propdom")
	        else
	          _to:= null()
	        end_if
	      end_if;
	      if (__ret__:= Factor(_expr)) <> FAIL then _expr:= __ret__ end_if;
	      __f_:= op(_expr, 0);
	      if domtype(level(__f_, 2)) = DOM_FUNC_ENV and
	         (__f_:= funcattr(level(__f_, 2), "getprop")) <> FAIL then
	        __ret__:= (__f_(op(_expr), _to))
	      else
	        __ret__:= (eval(property::expr(POp::mkAll(_expr), _to)))
	      end_if
	    else
	      __ret__:= (eval(property::convert_to(_expr, _to)))
	    end_if
	  end_if;
	  if nops(property::gdef) > 0 then
	    if __ret__ = _expr then __ret__:= null() end_if;
	    __ret__:= _and(__ret__, property::gdef)
	  end_if;
  	  return(sysassign(property::_getprop(args()), __ret__))
	end_proc:

#( gibt nur Eigenschaften des Domains X zur"uck )#
property::get:=
	proc(ident, X)
	  local idprops, i, list;
	begin
	  idprops:= property::getprop(ident, X);
	  list:= [];
	  i:= 0;
	  while i < nops(idprops) do
	    i:= contains([map(op(idprops), domtype)], X);
	    if i <> 0 then
	      list:= append(list, op(idprops, i));
	      idprops:= subsop(idprops, i = null())
	    else
	      i:= nops(idprops)
	    end_if
	  end_while;
	  if nops(list) = 0 then return(FAIL) end_if;
	  return(op(list))
	end_proc:

#(  )#

getprop:= property::getprop:

unalias(POp):
