#( Funktionsattribute "is" )#
ln:= funcattr(ln, "is",
	      loadproc(funcattr(ln, "is"), pathname("PROP", "IS"), "ln")):
exp:= funcattr(exp, "is",
	       loadproc(funcattr(exp, "is"), pathname("PROP", "IS"), "exp")):

alias(POp = property::POp):
alias(Is = property::__Is):

#( gibt BOOL zur"uck, ob prop eine Eigenschaft von ex ist )#
property::is:=
	proc()
	  local __rEt__;
	begin
          __rEt__:= UNKNOWN;
          if property::PROPLEVEL <= 1 then
            __rEt__:= Is(args());
            userinfo(2,args()," ==> ",__rEt__);
          end_if;
	  if __rEt__ <> UNKNOWN then return(__rEt__) end_if;

          #( Neue Funktion )#
          if property::PROPLEVEL <> 1 then
	    userinfo(1, ">** is --> ".expr2text(args()));
	    property::reset():
	    __rEt__:= property::_is(args());
	    property::reset():
	    userinfo(1, "<** is <-- ".expr2text(__rEt__));
	    if contains({TRUE, FALSE}, __rEt__) then
	      return(__rEt__)
	    else
	      return(UNKNOWN)
	    end_if
	  end_if;
	  __rEt__
	end_proc:

#( gibt BOOL zur"uck, ob prop eine Eigenschaft von ex ist )#
property::_is:=
	proc(ex, prop)
	  local __ret__, __f_;
	  option remember;
	begin
	  #( testtype )#
	  if domtype(prop) = Type and domattr(prop, "propdom") = FAIL then
	    if nops(prop) > 4 then #( provisorische Type's )#
	      return(domattr(property, op(prop, 5))(ex))
	    else
	      userinfo(10, "testtype(".expr2text(args()).")");
	      return(testtype(ex, prop))
	    end_if
	  end_if;
	  if property::RECLEVEL < property::MAXREC then
	    sysassign(property::RECLEVEL, property::RECLEVEL + 1)
	  else
	    userinfo(1, "*<* is: max recursion reached");
	    return(UNKNOWN)
	  end_if;
	  #( Operand undefined )#
	  if contains({op(ex), op(prop)}, undefined) then
	    return(UNKNOWN)
	  end_if;
	  #( Bezeichner ohne Eigenschaften )#
	  __f_:= indets(ex);
	  userinfo(10, "indets: ", expr2text(__f_));
	  if __f_ = map(__f_, float) then
	    if map(__f_, properties) = {FAIL} then
	      if __f_ intersect 
	           _if(args(0) > 1, indets(prop), null()) = {} then
	        userinfo(2, "no properties of identifier");
		return(UNKNOWN)
	      end_if
	    end_if
	  end_if;
	  if args(0) < 2 then prop:= null() end_if;
	  userinfo(8, "**> _is: ".expr2text(ex)." ?-> ".expr2text(prop));
	  __ret__:= UNKNOWN;
	  #( remember )#
	  sysassign(property::_is(subs(args(), ">" = null(), "<" = null())),
	            UNKNOWN);
	  __f_:= op(ex, 0);
	  if domtype(ex) = DOM_EXPR then
	    #__f_:= op(ex, 0);#
	    if contains({"_and", "_or", "_not"}, type(ex)) then
	      __ret__:= (map(ex, property::_is, prop));
	    elif contains({"_less", "_leequal", "_equal", "_unequal"},
			  type(ex)) then
	      #( numerisch )#
	      if ({map(op(ex), domtype)} minus
	          {DOM_INT, DOM_FLOAT, DOM_RAT}) = {} then
	        return(sysassign(property::_is(args()), bool(ex)))
	      end_if;
	      if ({map((__f_:= map(op(ex), property::convert_to)), domtype)}
	         minus {DOM_INT, DOM_FLOAT, DOM_RAT}) = {} then
	        return(sysassign(property::_is(args()), bool(op(ex, 0)(__f_))))
	      end_if;
	      #( Relationen nur in einer Richtung )#
	      if prop = null() then prop:= NIL end_if;
	      if contains({">", "<"}, prop) then
	        if prop = "<" then
	          __ret__:= property::_is(op(ex, 1),
	                                  property::Rel(property::Null, op(ex, 0),
	                                                op(ex, 2)))
	        else #( ">" )#
	          __ret__:= property::_is(op(ex, 2),
	                                  property::Rel(property::Null, -op(ex, 0),
	                                                op(ex, 1)))
	        end_if
	      elif op(ex, 1) = op(ex, 2) then
	        if contains({hold(_equal), hold(_leequal)}, op(ex, 0)) then
	          __ret__:= TRUE
	        else __ret__:= FALSE
	        end_if
	      else
	        __ret__:= property::_is(op(ex, 1),
	                                property::Rel(property::Null, op(ex, 0),
	                                              op(ex, 2)));
	        if __ret__ = UNKNOWN then
	          #property::reset();#
	          __ret__:= property::_is(op(ex, 2),
	                                  property::Rel(property::Null, -op(ex, 0),
	                                                op(ex, 1)))
	        end_if;
	        #( Faktorisierung )#
	        if TRUE #( high-level )# then
	          __ret__:= property::_is(Factor(op(ex, 1)),
	                                  property::Rel(property::Null, op(ex, 0),
	                                                op(ex, 2)));
	          if __ret__ = UNKNOWN then
	            #property::reset();#
	            __ret__:= property::_is(Factor(op(ex, 2)),
	                                    property::Rel(property::Null,
	                                                  -op(ex, 0), op(ex, 1)))
	          end_if
	        end_if;
	        if __ret__ = UNKNOWN then
	          if op(ex, 0) = hold(_equal) then
	            __ret__:= property::_is(op(ex, 1),
	                        property::Rel(property::Null, hold(_leequal),
	                                      op(ex, 2)));
	            if __ret__ = TRUE then
	              #property::reset();# #( ?? )#
	              __ret__:= property::_is(op(ex, 1),
	                          property::Rel(property::Null, -hold(_leequal),
	                                        op(ex, 2)))
	            elif __ret__ = UNKNOWN then
	              __ret__:= property::_is(op(ex, 2),
	                          property::Rel(property::Null, hold(_leequal),
	                                        op(ex, 1)));
	              if __ret__ = TRUE then
	                #property::reset();# #( ?? )#
	                __ret__:= property::_is(op(ex, 2),
	                            property::Rel(property::Null, -hold(_leequal),
	                                          op(ex, 1)))
	              end_if
	            end_if
	          elif op(ex, 0) = hold(_unequal) then
	            __ret__:= property::_is(op(ex, 1),
	                        property::Rel(property::Null, hold(_leequal),
	                                      op(ex, 2)));
	            if __ret__ = TRUE then
	              #property::reset();# #( ?? )#
	              __ret__:= property::_is(op(ex, 1),
	                          property::Rel(property::Null, -hold(_leequal),
	                                        op(ex, 2)))
	            elif __ret__ = UNKNOWN then
	              __ret__:= property::_is(op(ex, 2),
	                          property::Rel(property::Null, hold(_leequal),
	                                        op(ex, 1)));
	              if __ret__ = TRUE then
	                #property::reset();# #( ?? )#
	                __ret__:= property::_is(op(ex, 2),
	                            property::Rel(property::Null, -hold(_leequal),
	                                          op(ex, 1)))
	              end_if
	            end_if;
	            __ret__:= not(__ret__)
	          end_if
	        end_if
	      end_if;
	    #( DOM_FUNC_ENV )#
	    elif domtype(level(__f_, 2)) = DOM_FUNC_ENV and
	         (__f_:= funcattr(level(__f_, 2), "is")) <> FAIL then
	      userinfo(8, "funcattr(".expr2text(op(ex, 0)).", is)");
	      __ret__:= __f_(op(ex), prop)
	    #( DOM_EXPR )#
	    elif POp::Otype(ex) then
	      #if property::divis(ex) = TRUE then#
	        ###( nur eine Unbestimmte div Integer )###
	        #__ret__:= property::lzeval(op(__f_, 1), property::isprop, prop)#
	      #else#
	        __ret__:= property::lzeval(POp::mkAll(ex), property::isprop, prop)
	      #end_if#
	    else
	      #__ret__:= op(ex, 0)(property::lzeval(POp::mkAll(op(ex)),#
	                                           #property::isprop, prop))#
	      __ret__:= UNKNOWN
	    end_if
	  else
	    #return(property::isprop(property::_getprop(ex, prop), prop))#
	    __ret__:= property::lzeval(POp::mkAll(ex, NIL, TRUE),
	                                property::isprop, prop);
	    if __ret__ = UNKNOWN then
	      __ret__:= property::isprop(eval(property::_getprop(ex, prop)), prop)
	      #__ret__:= property::lzeval(POp::mkAll(ex, prop, TRUE),#
	                                  #property::isprop, prop)#
	    end_if
	  end_if;
	  #( remember )#
	  sysassign(property::_is(subs(args(), ">" = null(), "<" = null())),
	            __ret__);
	  sysassign(property::RECLEVEL, property::RECLEVEL - 1);
	  return(__ret__)
	end_proc:

#( is f"ur Relationen )#
property::isrel:=
	proc(_rel)
	  local __ret, __op, op1, op2, i;
	  option remember;
	begin
	  if contains({op(_rel)}, FAIL) then return(UNKNOWN) end_if;
	  if not(contains(map({op(_rel)}, domtype), DOM_EXPR)) then
	    op1:= _if(contains({DOM_IDENT}, domtype(op(_rel, 1))),
		      op(_rel, 1), null());
	    op2:= _if(contains({DOM_IDENT}, domtype(op(_rel, 2))),
		      op(_rel, 2), null());
	    __op:= op(_rel, 0);
	    #( 0/1/2/3 = t-t/i-t/t-i/i-i )#
	    i:= _if(domtype(op1) <> DOM_NULL, 1, 0);
	    i:= i + _if(domtype(op2) <> DOM_NULL, 2, 0);
	    #( remember this )#
	    if i > 0 then sysassign(property::isrel(_rel), UNKNOWN) end_if;
	    case i
	    of 0 do 
	      if (i:= contains(map([op(_rel)], domattr, "prop"), TRUE)) > 0 then
	        return(property::isprop
	                (_if(i = 1, (op(_rel, 1),
	                             property::Rel(property::Null, __op,
	                                           op(_rel, 2))),
	                            (op(_rel, 2),
	                             property::Rel(property::Null, -__op,
	                                           op(_rel, 1)))
	                     )))
	      else
	        return(bool(_rel))
	      end_if
	    of 1 do 
	      return(property::_is(op1, property::Rel(op1, __op, op(_rel, 2))))
	    of 2 do 
	      return(property::_is(op2, property::Rel(op2, -__op, op(_rel, 1))))
	    of 3 do 
	      __ret:= property::_is(_rel, ">");
	      if __ret <> TRUE then
	        __ret:= __ret or property::_is(_rel, "<")
	      end_if;
	      #__ret:= (property::_is(op1, property::Rel(op1, __op, op(_rel, 2)));#
	      __ret:= property::_is(op1, property::Rel(op1, __op, op(_rel, 2)));
	      #property::reset();#
	      __ret:= __ret or property::_is(op2, property::Rel(op2, -__op,
	                                                  op(_rel, 1)));
	      return(__ret);
	      #( ??? geht nicht so recht )#
	      if __ret = UNKNOWN then
	        if __op = hold(_equal) then
	          __ret:= property::_is(op1, property::Rel(op1, hold(_leequal),
	                                                  op(_rel, 2))) and
	                  property::_is(op1, property::Rel(op1, -hold(_leequal),
	                                                  op(_rel, 2)));
	          if __ret <> TRUE then
	            __ret:= __ret or (property::_is(op2, property::Rel(op2,
	                                hold(_leequal), op(_rel, 1))) and
	                    property::_is(op2, property::Rel(op2, -hold(_leequal),
	                                                    op(_rel, 1))));
	          end_if
	        end_if
	      end_if;
	      return(__ret)
	    end_case
	  else
	    #( Ausdr"ucke )#
	    op1:= _if(contains({DOM_EXPR}, domtype(op(_rel, 1))),
		      op(_rel, 1), null());
	    op2:= _if(contains({DOM_EXPR}, domtype(op(_rel, 2))),
		      op(_rel, 2), null());
	    __op:= op(_rel, 0);
	    #( 0/1/2/3 = t-t/e-t/t-e/e-e )#
	    i:= _if(domtype(op1) <> DOM_NULL, 1, 0);
	    i:= i + _if(domtype(op2) <> DOM_NULL, 2, 0);
	    #( remember this )#
	    if i > 0 then sysassign(property::isrel(_rel), UNKNOWN) end_if;
	    case i
	    of 1 do 
	      return(property::_is(op1, property::Rel(op1, __op, op(_rel, 2))))
	    of 2 do 
	      return(property::_is(op2, property::Rel(op2, -__op, op(_rel, 1))))
	    of 3 do 
	      if __op = hold(_equal) then
	        return(property::_is(op1, property::Rel(op1, hold(_leequal),
	                                               op(_rel, 2)))
	               and property::_is(op2, property::Rel(op2, -hold(_leequal),
	                                                   op(_rel, 1))))
	      else
	        return(property::_is(op1, property::Rel(op1, __op, op(_rel, 2)))
	               or property::_is(op2,
	                               property::Rel(op2, -__op, op(_rel, 1))))
	      end_if
	    end_case
	  end_if
	end_proc:

#( gibt BOOL zur"uck, ob aus _exp prop folgt )#
#( _exp - P-Ausdruck von Eigenschaften, prop - Eigenschaft )#
property::isprop:=
	proc(_exp, prop)
	  local __ret, __rule;
	  option remember;
	begin
	  if ({args(), op(_exp), op(prop)} intersect
	      {FAIL, NIL, property::Null, property::Undefined,
	       property::Unknown}) <> {} then
	    return(UNKNOWN)
	  end_if;

	  if _exp = prop then return(TRUE) end_if;

	  #( keine Endlosschleifen bei unaufl"osbaren Eigenschaften )#
	  sysassign(property::isprop(_exp, prop), UNKNOWN);

	  __ret:= UNKNOWN;
	  if POp::Ptype(_exp) then
	    __rule:= POp::Prule(POp::OPp(_exp));
	    __ret:= property::_getrule(domattr(op(__rule, 2), "propdom"), __rule);
	    if __ret <> FAIL then
	      return(property::isprop(__ret, prop))
	    end_if;
	    __ret:= property::_getfunc(domattr(op(__rule, 2), "propdom"), __rule);
	    if __ret <> FAIL then
	      #return(property::isprop(__ret, prop))#
	      __ret:= property::isprop(__ret, prop)
	    else
	      #return(property::isprop(property::expr(_exp, prop), prop))#
	      __ret:= property::isprop(property::expr(_exp, prop), prop)
	    end_if
	  else
	    #( ungleiches Domain )#
	    if type(_exp) <> type(prop) then
	      if contains({TRUE, FALSE},
	           (__ret:= domattr(domattr(prop, "propdom"), "is")
	                           (_exp, prop))) then
	        #return(__ret)#
	      elif contains({TRUE, FALSE},
	             (__ret:= domattr(domattr(_exp, "propdom"), "is")
	                             (_exp, prop))) then
	        #return(__ret)#
	      elif (__rule:= property::convert_to(_exp, prop)) <> FAIL then
	        if contains({TRUE, FALSE},
	             (__ret:= domattr(domattr(prop, "propdom"), "is")
	                             (__rule, prop))) then
	          #return(__ret)#
	        end_if;
	      elif (__rule:= property::convert_to(prop, _exp)) <> FAIL then
	        if contains({TRUE, FALSE},
	             (__ret:= domattr(domattr(prop, "propdom"), "is")
	                             (_exp, __rule))) then
	          #return(__ret)#
	        end_if
	      end_if
	    else #( gleiches Domain )#
	      __ret:= domattr(domattr(_exp, "propdom"), "is")(_exp, prop)
	    end_if
	  end_if;
	  sysassign(property::isprop(_exp, prop), __ret);
	  return(__ret)
	end_proc:

Is := proc(e,t) local s;
begin
   if args(0)=2 then
      if t=Type::RealNum then 
         if contains({"Re","Im"},type(e)) then return(TRUE) end_if;
         # try to use sign for constants #
         if testtype(e,Type::Constant) then
	    if contains({-1,0,1},(s:=sign(e))) then return(TRUE)
	    elif has(s,hold(sign)) then return(UNKNOWN)
	    else return(FALSE)
	    end_if
         elif contains({"_plus","_mult"},type(e)) then
            for s from 1 to nops(e) do
               if Is(op(e,s),Type::RealNum)<>TRUE then break end_if
            end_for;
            if s>nops(e) then return(TRUE) end_if
         elif type(e)="_power" then
            if type(op(e,2))=DOM_INT then
               if Is(op(e,1),Type::RealNum)=TRUE then
	         return(TRUE) end_if
            end_if
         elif type(e)=DOM_IDENT and Is(e,DOM_INT)=TRUE then return(TRUE)
         end_if
      elif t=DOM_INT then
         case type(e)
         of DOM_INT do return(TRUE)
         of DOM_RAT do return(FALSE)
         of DOM_IDENT do
	    if (Is(e,Type::PosInt) or Is(e,Type::NonNegInt) or
		Is(e,Type::NegInt))=TRUE then return(TRUE) end_if
         end_case
      elif t=Type::NonNegInt then
         return((if type(e)=DOM_INT then bool(e>=0)
	         elif Is(e,Type::PosInt)=TRUE then TRUE else UNKNOWN end_if))
      elif t=Type::PosInt then
         return((if type(e)=DOM_INT then bool(e>0) else UNKNOWN end_if))
      end_if;
      # if testtype returns FALSE, the property may be true #
      return((if testtype(e,t)=TRUE then TRUE else UNKNOWN end_if))
   end_if;
   if type(e)="_less" then
      case sign((s:=op(e,2)-op(e,1)))
      of 1 do return(TRUE)
      of 0 do of -1 do return(FALSE)
      otherwise
         case type(s) of "_plus" do
            for t from 1 to nops(s) do
               if Is(op(s,t)>=0)=TRUE and Is(subsop(s,t=0)>0)=TRUE then
		  return(TRUE) end_if
            end_for; break
         of "_mult" do
            e:=TRUE;
            for t in s do if Is(t>0)<>TRUE then e:=UNKNOWN; break end_if end_for;
            if e=UNKNOWN and nops(s)=2 and op(s,2)=-1 then
               if Is(op(s,1)>0)=TRUE then e:=FALSE end_if
            end_if;
            if e<>UNKNOWN then return(e) end_if
         of DOM_IDENT do
	    if Is(s,Type::PosInt)=TRUE then return(TRUE) end_if; break
         of "_power" do
	    if (Is(op(s,1)>0) and Is(op(s,2),Type::RealNum))=TRUE then return(TRUE)
	    end_if
         end_case
      end_case;
      if testtype(s,Type::AlgebraicConstant)
      and length((t:=radsimp(s)))<length(s) then return(is(t>0)) end_if
   elif type(e)="_leequal" then
      case (s:=sign((t:=op(e,2)-op(e,1))))
      of 1 do of 0 do return(TRUE)
      of -1 do return(FALSE)
      otherwise
         if type(s)="sign" and type(op(s))="Re" then
            if type(op(s,[1,1]))="_power" then
               # 0<=Re(x^(1/n)) is always true #
               if testtype(1/op(s,[1,1,2]),Type::PosInt) then return(TRUE) end_if
            end_if
         elif type(s)="_power" and type(op(s,1))="sign" then
            if Is(op(s,[1,1]),Type::RealNum)=TRUE and type(op(s,2)/2)=DOM_INT then
               return(TRUE) # sign(x)^(2*k)=1 when x is real #
            end_if
         elif type(t)=DOM_IDENT and Is(t,Type::NonNegInt)=TRUE then return(TRUE)
         elif type(op(e,2))="_plus" then
	    if contains({"sin","cos"},type(op(e,[2,1]))) then
               return(Is(op(e,1)<=subsop(op(e,2),1=-1)))
            else
               s:=TRUE; for t in op(e,2) do
                  s:=s and Is(t>=0);
                  if s<>TRUE then break end_if
               end_for;
               if s=TRUE then return(s) end_if
            end_if
         end_if;
         if op(is,5)<>NIL and op(is,5)[-op(e,1)>=-op(e,2)]=TRUE 
         then return(TRUE) end_if;
         return(Is(subsop(e,0=_less))) # a<b ==> a<=b #
      end_case
   elif type(e)="_equal" then
      case sign(op(e,1)-op(e,2))
      of 0 do return(TRUE)
      of -1 do of 1 do return(FALSE)
      end_case
   end_if;
   UNKNOWN
end_proc:

is:= property::is:

unalias(Is):
unalias(POp):
