alias(POp = property::POp):

#( intern - setrule, getrule, delrule )#
#( "meth", expr || "meth", dom, expr || "meth", dom, func, "name", "rem")#
property::xxxrule:=
	proc()
	  local _dom, _ret, _args;
	begin
	  _dom:= FAIL;
	  if args(0) = 2 then #( methode, expr )#
	    if domtype(args(2)) = DOM_EXPR then
	      if type(args(2)) <> "fun" then
	        if type(args(2)) = "_equal" then #( Gleichung )#
	          #( vorerst a + b = c )#
	          _args:= op(args(2), [1, 0]), op(args(2), [1, 1]),
	                  op(args(2), [1, 2]), op(args(2), 2)

	        elif type(args(2)) = "domattr" then
	          _dom:= args(2);
	          _dom:= domattr(level(_dom, 2), "propdom");
	          if _dom = FAIL then
	            return(FAIL, FAIL)
	          end_if
	        elif type(args(2)) <> "_exprseq" then #( Verkn"upfung )#
	          _args:= op(args(2), 0), op(args(2), 1), op(args(2), 2)
		end_if
	      else
		return(FAIL, FAIL)
	      end_if;
	      #( domain? )#
	      if _dom = FAIL then
	        _dom:= domattr(level(op(_args, 2)), "propdom");
	        if _dom = FAIL then
	          _dom:= domattr(level(op(_args, 3)), "propdom");
	          if _dom = FAIL then
	            return(FAIL, FAIL, _args)
	          end_if
	        end_if
	      end_if
	    else
	      _dom:= args(2);
	      _dom:= domattr(level(_dom, 2), "propdom");
	      if _dom = FAIL then
	        return(FAIL, FAIL)
	      else
	        _args:= null()
	      end_if
	    end_if
	  elif args(0) = 3 then
	    _dom:= args(2);
	    _dom:= domattr(level(_dom, 2), "propdom");
	    if _dom = FAIL then
	      return(FAIL, FAIL)
	    else
	      if domtype(args(3)) = DOM_EXPR then
	        if type(args(3)) = "_equal" then #( Gleichung )#
	          #( vorerst a + b = c )#
	          _args:= op(args(3), [1, 0]), op(args(3), [1, 1]),
	                  op(args(3), [1, 2]), op(args(3), 2)

	        elif type(_args) <> "_exprseq" then #( Verkn"upfung )#
	          _args:= op(args(3), 0), op(args(3), 1), op(args(3), 2)
	        else
		  return(FAIL, FAIL)
	        end_if;
	        #( domain? )#
	        #_dom:= domattr(level(op(_args, 2)), "propdom");#
	        #if _dom = FAIL then#
	          #_dom:= domattr(level(op(_args, 3)), "propdom");#
	          #if _dom = FAIL then#
	            #return(FAIL, FAIL, _args)#
	          #end_if#
	        #end_if#
	      elif domtype(args(3)) = DOM_STRING then
	        _args:= args(3)
	      elif args(3) = hold(All) then
	        _args:= args(3)
	      else
	        return(FAIL, FAIL)
	      end_if
	    end_if
	  elif args(0) > 3 then
	    _dom:= args(2);
	    _dom:= domattr(level(_dom, 2), "propdom");
	    if _dom = FAIL then
	      return(FAIL, FAIL)
	    else
	      if contains({DOM_PROC, "fun", "function"}, type(args(3))) then
	        if domtype(args(4)) = DOM_STRING then
	          _args:= args(3..args(0));
	          _args:= level(_args, 2)
	        else
	          return(FAIL, FAIL)
	        end_if
	      else
	        return(FAIL, FAIL)
	      end_if
	    end_if
	  else
	    return(FAIL, FAIL)
	  end_if;

	  if contains(_dom, args(1)) then
	    _ret:= domattr(_dom, args(1))(_args);
	    if contains([op(_ret)], FAIL) = 0 then
	      return(_ret)
	    else
	      return(_args)
	    end_if
	  else
	    return(FAIL, _dom, _args)
	  end_if

	end_proc:

#( internes setrule )#
property::_setrule:=
	proc(_dom, _rule, _new)
	begin
	  if contains({hold(New), "New"}, _new) then
	    _new:= TRUE
	  else
	    _new:= FALSE
	  end_if;
	  if _new then
	    if _rule::_func(_rule) then
	      if not(property::_delrule(_dom, _rule)) then
	        if contains(map(_dom::ax, _rule::equif,
			    _rule, "Name"), TRUE) > 0 then
	          print(Unquoted, "Another P-func named "
		                . _rule::fir() . " do exist,");
	          print(Unquoted, "set this P-func with name "
		                . _rule::_fir() . "?");
	          _rule:= _rule::name(_rule, _rule::fir() . "?")
	        end_if
	      else
	        userinfo(2, "Overwrite existing P-func " . expr2text(_rule));
	        property::_delrule(_dom, _rule)
	      end_if
	    else
	      if property::_getrule(_dom, _rule, "One") <> FAIL then
	        userinfo(2, "Overwrite existing Rule " . expr2text(_rule));
	        property::_delrule(_dom, _rule)
	      end_if
	    end_if;
	    userinfo(2, "Built-in func " . expr2text(_rule).
		     " in domain ".expr2text(_dom));
	    _dom::ax:= _dom::ax . [_rule];
	    return(TRUE)
	  else	      
	    if _rule::_func(_rule) then
	      if contains(map(_dom::ax, _rule::equif, _rule, "Name"),
			  TRUE) > 0 then
	        print(Unquoted, "Another P-func named " . _rule::fir()
		                . " do exist,");
	        print(Unquoted,
		      "rename this P-func or use Option New to overwrite");
	        return(FALSE)
	      else
	        userinfo(2, "Built-in func " . expr2text(_rule).
			 " in domain ".expr2text(_dom));
	        _dom::ax:= _dom::ax . [_rule];
	        return(TRUE)
	      end_if
	    else
	      if property::_getrule(_dom, _rule, "One") <> FAIL then
	        if property::_getrule(_dom, _rule, "One") = _rule::result() then
		  userinfo(2, "Rule always do exist");
	          return(FALSE)
	        else
	          userinfo(2, "Another Rule for " . expr2text(_rule) . " do exist");
	          return(FAIL)
	        end_if
	      else
	        userinfo(2, "Built-in rule ".expr2text(_rule).
			 " in domain ".expr2text(_dom));
	        _dom::ax:= _dom::ax . [_rule];
	        return(TRUE)
	      end_if
	    end_if
	  end_if
	end_proc:
 
#( setzen einer Regel )#
#( setrule(<dom, > Prule()) oder setrule(<dom, > Equation))#
#( setrule(<dom, > Prule()) oder setrule(<dom, > Func <, name <, info>>))#
property::setrule:=
	proc()
	  option hold;
	  local ret, _dom;
	begin
	  property::reset():
	  #ret:= args();#
	  ret:= property::xxxrule("setrule", args());
	  if contains([op(ret)], FAIL) = 0 then return(ret) end_if;
	  _dom:= op(ret, 2);

	  if _dom = FAIL then
	    userinfo(2, "No domain found in arguments!");
	    return(FAIL)
	  end_if;

	  if nops(ret) < 3 then
	    error("Wrong number of arguments")
	  end_if;

	  #ret:= args(i..args(0));#
	  ret:= POp::Prule(op(level(ret, 2), 3..nops(ret)));

	  if _dom::ax = FAIL then _dom::ax:= [] end_if;

	  if ret::_name(ret) = ret::_name(POp::Prule(fun(null()))) then
	    error("Missing function name (and info)")
	  end_if;

	  return(property::_setrule(_dom, ret, args(args(0))))
	end_proc:

#( internes getrule )#
#( _getrule(_dom, _rule <, _one >) )#
property::_getrule:=
	proc(_dom, _rule, _one)
	  local i, _ax;
	begin
	  if args(0) = 1 then return(_dom::ax) end_if;
	  if contains({hold(One), hold(Exact), "One", "Exact"}, _one) then
	    _one:= "Exact"
	  else
	    _one:= null()
	  end_if;
	  _ax:= select(_dom::ax, (POp::Prule)::_equiv, _rule, _one);
	  if nops(_ax) = 0 then
	    userinfo(2, "No rules for " . expr2text(_rule));
	    return(FAIL)
	  end_if;
	  for i from 1 to nops(_ax) do
	    #if property::isprop(_rule::sec(_rule),#
				#(POp::Prule)::sec(op(_ax, i))) = TRUE then#
	      #return((POp::Prule)::result(op(_ax, i)))#
	    #( direkter Zugriff - schneller )#
	    if property::isprop(op(_rule, 3), op(_ax, [i, 3])) = TRUE then
	      #return((POp::Prule)::result(op(_ax, i)))#
	      return(op(_ax, [i, 4]))
	    end_if
	  end_for;
	  userinfo(2, "No rules for " . expr2text(_rule));
	  return(FAIL)
	end_proc:

#( internes getrule f"ur Entscheidungsfunktionen )#
#( _getrule(_dom, _rule <, _name >) )#
property::_getfunc:=
	proc(_dom, _rule, _name)
	  local i, _ax, ret;
	begin
	  if contains({hold(Name), "Name", "name"}, _name) then
	    _name:= "Name"
	  else
	    _name:= null()
	  end_if;
	  _ax:= select(_dom::ax, (POp::Prule)::_func);
	  #_ax:= select(_ax, (POp::Prule)::equif, _rule, _name);#
	  if nops(_ax) = 0 then
	    userinfo(2, "No P-func for " . expr2text(_rule));
	    return(FAIL)
	  end_if;
	  for i from 1 to nops(_ax) do
	    ret:= (POp::Prule)::exec(op(_ax, i), _rule);
	    if ret <> FAIL then return(ret) end_if
	  end_for;
	  userinfo(2, "No P-func for " . expr2text(_rule));
	  return(FAIL)
	end_proc:

#( abfragen einer Regel )#
#( getrule(<_dom>, linke_seite_einer_regel) - Resultat )#
#( getrule(<_dom>, linke_seite_einer_regel = rechte_seite_einer_regel) - bool )#
property::getrule:=
	proc()
	  option hold;
          local __ret, res, _dom;
	begin
	  __ret:= args();
	  __ret:= property::xxxrule("getrule", __ret);
	  if contains([op(__ret)], FAIL) = 0 then return(__ret) end_if;
	  _dom:= op(__ret, 2);

	  if _dom = FAIL then
	    userinfo(2, "No domain found in arguments!");
	    return(FAIL)
	  end_if;

	  if nops(__ret) < 3 then
	    userinfo(2, "All rules of domain ".expr2text(_dom));
	    return(_dom::ax)
	  end_if;

	  __ret:= op(level(__ret, 2), 3..nops(__ret));

	  if _dom::ax = FAIL then
	    userinfo(2, "Nothing defined in ".expr2text(_dom));
	    return(FAIL)
	  end_if;

	  __ret:= POp::Prule(__ret);

	  #res:= __ret::resultat;#
	  userinfo(2, "Rule?");
	  res:= property::_getrule(_dom, __ret, args(args(0)));
	  if res <> FAIL then
	    if op(__ret, 4) <> "??" then
	      return(bool(res = op(__ret, 4)))
	    else
	      return(res)
	    end_if
	  end_if;

	  userinfo(2, "Function?");
	  res:= property::_getfunc(_dom, __ret, args(args(0)));
	  if res <> FAIL then
	    if op(__ret, 4) <> "??" then
	      return(bool(res = op(__ret, 4)))
	    else
	      return(res)
	    end_if
	  end_if;

	  userinfo(2, "No Rule or Function for ".expr2text(__ret));	  
	  return(FAIL)
	end_proc:

#( internes delrule )#
property::_delrule:=
	proc(_dom, _rule, _name)
	  local i;
	begin
	  i:= contains(map(_dom::ax, (POp::Prule)::_equiv,
		           _rule, "Exact"), TRUE);
	  if i > 0 then
	   userinfo(1, "Removing P-rule " . expr2text(_rule));
	    _dom::ax:= subsop(_dom::ax, i = null());
	    return(TRUE)
	  end_if;
	  #if contains({hold(Name), "name", "Name"}, _name) then#
	  i:= contains(map(_dom::ax,
		       (POp::Prule)::_equif,
	               _rule), TRUE);
	  if i > 0 then
	   userinfo(2, "Removing P-func " . expr2text(_rule));
	    _dom::ax:= subsop(_dom::ax, i = null());
	    return(TRUE)
	  end_if;
	  #end_if;#
	  if contains({hold(All), "All", "all"}, _rule) then
	    userinfo(2, "Removing all rules of " . expr2text(_dom));
	    _dom::ax:= [];
	    return(TRUE)
	  end_if;
	  userinfo(2, "Nothing to delete.");
	  return(FALSE)
	end_proc:

#( l"oschen einer Regel )#
#( delrule(<_dom, >  _rule) oder delrule(<_dom, > "func-name") )#
property::delrule:=
	proc()
	  option hold;
          local ret, _dom;
	begin
	  property::reset():
	  ret:= property::xxxrule("delrule", args());
	  if contains([op(ret)], FAIL) = 0 then return(ret) end_if;
	  _dom:= op(ret, 2);

	  if _dom = FAIL then
	    userinfo(2, "No domain found in arguments!");
	    return(FAIL)
	  end_if;

	  if contains({hold(All)}, args(args(0))) then
	    sysassign(_dom::ax, []);
	    return(TRUE)
	  end_if;

	  if nops(ret) < 3 then
	    if contains({hold(y), hold(Y), hold(j), hold(J)},
	                input("Remove all rules (y/n)? ")) then
	      _dom::ax:= [];
	      return(TRUE)
	    else
	      userinfo(2, "User break");
	      return(FALSE)
	    end_if
	  end_if;

	  if _dom::ax = FAIL then
	    userinfo(2, "Nothing defined in ".expr2text(_dom));
	    return(FAIL)
	  end_if;

	  ret:= op(level(ret, 2), 3..nops(ret));

	  if type(ret) = DOM_STRING then
	    ret:= POp::Prule(fun(null()), ret), "Name"
	  else
	    ret:= POp::Prule(ret)
	  end_if;

	  if property::_delrule(_dom, ret) = TRUE then
	    return(TRUE)
	  end_if;

	  userinfo(2, "No Rule or Function for ".expr2text(ret));	  
	  return(FAIL)
	end_proc:

property::saverule:=
	proc()
	  local k, x, _dom, _doms, _DATEI, _NAME, _new;
	begin
	  x:= 0;
	  _NAME:= "";
	  if args(0) > 0 then
	    if contains({"New", hold(New)}, args(args(0))) then
	      _new:= bool(contains({hold(y), hold(Y), hold(j), "y", "Y"},
                                   input("Overwrite existing rule-file (y/n)?")));
	      if _new then x:= 1 end_if
	    end_if;
	    if domtype(args(args(0) - x)) = DOM_STRING then
	      _NAME:= args(args(0) - x);
	      x:= x + 1
	    end_if
	  end_if;
	  if args(0) > x then
	    _doms:= [args(1..args(0) - x)]
	  else
	    _doms:= select([map(op(stdlib::LoadlibState), op, 1)],
	                   fun(bool(domattr(eval(text2expr(args())), 
	                                    "prop") = TRUE)))
	  end_if;

	  if nops(_doms) = 0 then return() end_if;
	  while nops(_doms) > 0 do
	    _dom:= eval(op(_doms, 1));
	    _doms:= subsop(_doms, 1 = null());
	    if domtype(domattr(_dom, "type")) = DOM_STRING
	       or _NAME <> "" then
	      if not(_new) then
	        property::loadrule(_dom, _if(_NAME <> "", _NAME, null()))
	      end_if;
	      userinfo(1, "Save rules of ".expr2text(_dom));
	      if _DATEI <> FAIL then
	        _DATEI:= fopen(hold(Text),
		               _if(_NAME="", _dom::type."_ax.mu", _NAME),
	                       hold(Write));
  
	        for k from 1 to nops(_dom::ax) do
		  (POp::Prule)::fprint(_DATEI, op(_dom::ax, k))
	        end_for;
	        userinfo(1, "...done");
	        _DATEI:= fclose(_DATEI);
	        TRUE
	      else
	        userinfo(1, "Warning: Can't load File \"".
	                    _dom::type . "_ax.mu\"");
	        FALSE
	      end_if
	    end_if
	  end_while
	end_proc:

property::loadrule:=
	proc()
	  local _dom, _doms, _DATEI, _NAME, _new, x, _y_;
	begin
	  x:= 0;
	  _NAME:= "";
	  if args(0) > 0 then
	    _new:= contains({"New", hold(New)}, args(args(0)));
	    if _new then x:= 1 end_if;
	    if domtype(args(args(0) - x)) = DOM_STRING then
	      _NAME:= args(args(0) - x);
	      x:= x + 1
	    end_if
	  end_if;
	  if args(0) > x then
	    _doms:= [args(1..args(0) - x)]
	  else
	    _doms:= select([map(op(stdlib::LoadlibState), op, 1)],
	                   fun(bool(domattr(eval(text2expr(args())), 
	                                    "prop") = TRUE)))
	  end_if;
	  if nops(_doms) = 0 then return() end_if;
	  while nops(_doms) > 0 do
	    _dom:= eval(op(_doms, 1));
	    _doms:= subsop(_doms, 1 = null());
	    #if domattr(_dom, "prop") <> FAIL then#
	    if domtype(domattr(_dom, "type")) = DOM_STRING
	       or _NAME <> "" then
	      userinfo(1, "Loading known rules of ".expr2text(_dom));
	      if _new = TRUE then property::_delrule(_dom) end_if;
	      _DATEI:= fopen(_if(_NAME="", _dom::type."_ax.mu", _NAME));
	      if _DATEI <> FAIL then

	        x:= finput(_DATEI);
	        if op(x, 0) = hold(alias) then
	          _y_:= expr2text(op(x, [1, 1]));
	          level(x);
	          x:= null()
	        else
	          x:= POp::Prule(x)
	        end_if;

		repeat
		  if x <> null() then
	            property::_setrule(_dom, x)
		  end_if;
		  x:= POp::Prule(finput(_DATEI))
		until domtype(x) = DOM_NULL end_repeat;
	        userinfo(1, "...done");

	        eval(text2expr("unalias("._y_.")"));

	        _DATEI:= fclose(_DATEI);
	        TRUE
	      else
	        userinfo(1,
                      "Warning: Can't load File \""._dom::type."_ax.mu\"");
	        FALSE
	      end_if
	    end_if
	  end_while
	end_proc:

property::autoload:=
	proc()
	  local __i;
	begin
	  if args(0) = 0 then
	    property::loadrule()
	  elif contains({DOM_LIST, DOM_SET}, domtype(args())) then
	    for __i from 1 to nops(args()) do
	      property::loadrule(op(args(), __i))
	    end_for
	  else
	    for __i from 1 to args(0) do
	      property::loadrule(args(__i))
	    end_for
	  end_if
	end_proc:

unalias(POp):
