
#(
   Test - generic property domain
          primitive implementation - only table rules
)#

alias(Test = property::Test):

Test:= domain("property::Test"):
Test::info:= "Test-Domain: numeric evaluation - Properties 'Test'":
Test::domtype:= "Type":
Test::type:= "Test":
Test::prop:= TRUE:
Test::propdom:= hold(property::Test):
Test::autoload:= TRUE:
Test::ax:= []:

Test::new:= 
	proc()
	begin
	  if args(0) > 0 then
	    new(Test, args())
	  else
	    new(Test, null())
	  end_if
	end_proc:

#( gibt bool zur"uck, ob aus arg1 -> arg2 folgt )#
Test::is:=
	proc()
	begin
	  bool(expr(op(args(1))) = op(args(2)))
	end_proc:

#( gibt eine Regel f"ur arg1, ..., argn oder arg1, ..., argn zur"uck )#
Test::Is:=
	proc()
	begin
	  Test()
	end_proc:

Test::_and:=
	proc()
	begin
	  if args(0) = 2 then
	    if args(1) = args(2) then return(args(1)) end_if;
	    return(hold(_and)(args()))
	  else
	    return(property::Op(_and, args()))
	  end_if
	end_proc:

Test::_or:=
	proc()
	begin
	end_proc:

Test::_not:=
	proc()
	begin
	end_proc:

Test::_plus:=
	proc()
	begin
	  property::_Op(Test, _plus,
	                fun(subsop(args(1),
			    1 = op(args(1)) + op(args(2)))),
			args())
	end_proc:

Test::_subtract:=
	proc()
	begin
	  property::_Op(Test, _subtract,
	                fun(subsop(args(1),
			    1 = op(args(1)) - op(args(2)))),
			args())
	end_proc:

Test::_negate:=
	proc()
	begin
	  subsop(args(), 1 = _negate(op(args(), 1)))
	end_proc:

Test::_mult:=
	proc()
	begin
	  property::_Op(Test, _mult,
	                fun(subsop(args(1),
			    1 = op(args(1)) * op(args(2)))),
			args())
	end_proc:

Test::_divide:=
	proc()
	begin
	  property::_Op(Test, _divide,
	                fun(subsop(args(1),
			    1 = op(args(1)) / op(args(2)))),
			args())
	end_proc:

Test::_invert:=
	proc()
	begin
	  subsop(args(), 1 = _invert(op(args(), 1)))
	end_proc:

Test::_power:=
	proc()
	begin
	  property::_Op(Test, _power,
	                fun(subsop(args(1),
			    1 = op(args(1)) ^ op(args(2)))),
			args())
	end_proc:

Test::print:=
	proc()
	begin
	  "Test(" . expr2text(op(args())) . ")"
	end_proc:

userinfo(1, "Loading 'Test' done ..."):

unalias(Test):


