# $Date: 1995/08/12 16:08:47 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	gamma/expand -- the function attribut "expand" for gamma
--#

gamma:= funcattr( gamma, "expand",
proc(e) local i,j;
begin
   if type(e)="_plus" then
      i:=op(e,nops(e)); # integers are always in the last operand ??? #
      if testtype(i,Type::PosInt) then
         return(_mult(gamma(e-i),e-j$j=1..i))
      elif testtype(i,Type::NegInt) then
         _mult(e+j$j=0..-i-1);
         return(gamma(e-i)/%)
      end_if
   end_if;
   gamma(e)
end_proc):

# end of file #
