# $Date: 1995/08/12 16:08:48 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	psi/expand -- the function attribut "expand" for psi

	psi(x+i,n) = psi(x,n)+(-1)^n*n!*(1/x^(n+1)+1/(x+1)^(n+1)+...+
           1/(x+i-1)^(n+1))
--#

psi:= funcattr( psi, "expand", proc(x,n) local i,j,t,rng,N;
begin
   if args(0)=1 then n:=0; N:=null() else N:=n end_if;
   i:=coeff(x,0);
   if type(i)=DOM_INT then
      x:=x-i;
      if i<0 then rng:=i..-1 else rng:=0..i-1 end_if;
      t:=_plus(1/(x+j)^(n+1) $ j=rng);
      hold(psi)(x,N)+sign(i)*(-1)^n*fact(n)*t
   else hold(psi)(x,N)
   end_if
end_proc):

# end of file #
