# $Date: 1995/08/12 16:10:04 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	exp/sign -- the function attribut "sign" for exp
--#

exp:= funcattr(exp,"sign",proc(x)
    local a;
begin
    a := op(x,1);
    if testtype(a,Type::RealNum)
    or testtype(sign(a),Type::RealNum) then
        return( 1 )
    end_if;
    if domtype(a) = DOM_COMPLEX then
        if domtype(op(a,1)) = DOM_FLOAT
        or domtype(op(a,2)) = DOM_FLOAT then
            return( exp(I*Im(a)) )
        end_if
    end_if;
    a := Im(a);
    if not has(a,{Im,Re}) then exp(I*a) else hold(sign)(x) end_if
end_proc
):

# end of file #
