acsch := proc(x)
    # acsch(x) = asinh(1/x) #
begin
    if x::acsch <> FAIL then return(x::acsch(args())) end_if;
    if args(0) <> 1 then
       error("1 argument expected")
    end_if;

    if x = 0 or x = 0.0 then
       error("singularity")
    end_if;
    asinh(1/x)
end_proc:

acsch:= funcattr(acsch, "print", "acsch"):
acsch:= funcattr(acsch, "info", "acsch -- the inverse hyperbolic cosecant"):
acsch:= funcattr(acsch, "type", "acsch"):

# end of file #
