asech := proc(x)
    # asech(x) = acosh(1/x) #
begin
    if x::asech <> FAIL then return(x::asech(args())) end_if;
    if args(0) <> 1 then
       error("1 argument expected")
    end_if;
    
    if x = 0 or x = 0.0 then
       error("singularity")
    end_if;
    acosh(1/x)
end_proc:

asech:= funcattr(asech, "print", "asech"):
asech:= funcattr(asech, "info", "asech -- the inverse hyperbolic secant"):
asech:= funcattr(asech, "type", "asech"):

# end of file #

