catalan := proc() begin procname() end_proc:

stdlib::catalan := [0.915965594177219015054603514932384110774149374281672, 50]:

/*
catalan := sum( (-1)^n / (2*n+1)^2 , n = 0..infinity )
*/

catalan := funcattr(catalan, "float",
 proc()
    local i, j, p, t, s, g;
 begin
    if DIGITS <= stdlib::catalan[2] then
        stdlib::catalan[1]
    else
        g := DIGITS + length(DIGITS) + 3;
        p := 10^g div 2;
        t := p;
        s := t;
        j := 1;
        i := 1;
        while t > 0 do
            j := j + 2;
            p := (p*i) div j;
            t := (t*i + p) div j;
            s := s + t;
            i := i + 1
        end_while;
        sysassign(stdlib::catalan[2], DIGITS);
        sysassign(stdlib::catalan[1], s*10.0^(-g))
    end_if
 end_proc):
