# $Date: 1996/10/01 15:19:30 $ $Author: zimmerma $ $Revision: 1.9 $ #

# zimmerma, 01/08/95 #

#++
        dirac -- the Dirac delta function

        dirac(x)

        x - expression

	dirac(x) := diff(heaviside(x),x)
++#

dirac := proc(x)
begin
   if (is(x<0) or is(x>0))=TRUE then 0 else procname(x) end_if
end_proc:

dirac:= funcattr(dirac,"type","dirac"):
dirac:= funcattr(dirac,"info", "dirac -- the Dirac function dirac(x) = diff(heaviside(x),x)"):
dirac:= funcattr(dirac,"print","dirac"):
dirac:= funcattr(dirac,"int",proc(f,x) begin
if op(f)=x then heaviside(x) else FAIL end_if end_proc):

dirac:= funcattr(dirac,"series",
	loadproc(funcattr(dirac,"series"),pathname("SERIES"),"dirac")):

# end of file #
