# $Date: 1996/07/03 13:45:59 $ $Author: frankp $ $Revision: 1.7 $ #

# zimmerma, 01/08/95 #

#++
	heaviside -- the Heaviside function

	heaviside(x)

	x - expression

	heaviside(x) := 1 if x>=0 and 0 otherwise.
++#

heaviside := proc(x)
begin
   if is(x>=0)=TRUE then 1
   elif is(x<0)=TRUE then 0
   else procname(x)
   end_if
end_proc:

heaviside:= funcattr(heaviside,"type","heaviside"):
heaviside:= funcattr(heaviside,"info",
  "heaviside -- the Heaviside step function"
):
heaviside:= funcattr(heaviside, "print", "heaviside"):

heaviside:= funcattr(heaviside, "diff", proc(f,x) begin
   diff(subsop(f,0=dirac)*diff(op(f),x),args(3..args(0)))
end_proc):

# end of file #
