# $Date: 1995/08/12 16:02:33 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	ln/Im -- the function attribut "Im" for ln
--#

ln := funcattr( ln, "Im", fun(
    (sign(args(1));
    if % = 1 then 0
    elif % = -1 then PI
    elif iszero(%) then error("singularity")
    elif domtype(args(1)) = DOM_COMPLEX then
        args(1);
        if op(%,1) = 0 then
            return( 1/2*PI*sign(op(%,2)) )
        else
            return( atan(op(%,1),op(%,2)) )
        end_if
    elif not has(%,hold(sign)) then
        atan(Re(%),Im(%))
    else
        hold(Im)(ln(args(1)))
    end_if)
) ):

# end of file #
