# $Date: 1995/08/12 16:02:34 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	sin/Im -- the function attribut "Im" for sin
--#

sin := funcattr( sin, "Im", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then return( 0 )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( cos(r)*sinh(s) )
            end_if
        end_if;
        hold(Im)(sin(x))
    end_proc
):

# end of file #
