Pref::trailingZeroes:= funcattr(
    proc(n)
    begin
        case args(0) 
        of 0 do
            return( _pref(TrailingZeroes)) 
        of 1 do
            if args(1) = NIL then # set default value #
                n:= _pref(hold(TrailingZeroes)); 
                _pref(hold(TrailingZeroes) = FALSE);
                return( n )
            elif domtype(n) <> DOM_BOOL then
                error("BOOLEAN expected")
            else
                _pref(hold(TrailingZeroes)); 
                _pref(hold(TrailingZeroes) = n); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting TRUE or FALSE)")
        end_case
    end_proc,
"info","If set to TRUE trailing zeroes in floats are printed."):

Pref::trailingZeroes:= funcattr( Pref::trailingZeroes,"default", FALSE ):

# end of file #
