Pref::postInput:= funcattr(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(PostInput)) )
        of 1 do
            if args(1) = NIL then # set default value #
                v:= _pref(hold(PostInput)); _pref(hold(PostInput) = NIL);
                return( v )
            else
                _pref(hold(PostInput)); _pref(hold(PostInput) = v); 
                return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting one argument)")
        end_case
    end_proc,
"info","'Pref::postInput(data)' will be executed on every interactive input."):

Pref::postInput:= funcattr( Pref::postInput, "default", "NIL" ):

# end of file #
