Pref::typeCheck:= funcattr(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(TypeCheck)) )
        of 1 do
            if args(1) = NIL then # set default value #
                v:= _pref(hold(TypeCheck)); _pref(hold(TypeCheck) = hold(Interactive));
                return( v )
            elif not contains( {None,Always,Interactive},v ) then
                error("argument must either be 'None', 'Always' or 'Interactive'")
            else
                _pref(hold(TypeCheck)); _pref(hold(TypeCheck) = v); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting either 'None', 'Always' or 'Interactive')")
        end_case
    end_proc,
"info","Typchecking of arguments, if a type specification for a formal parameter exists."):

Pref::typeCheck:= funcattr( Pref::typeCheck,"default",hold(Interactive) ):

# end of file #
