# $Date: 1995/08/12 16:03:18 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	ln/Re -- the function attribut "Re" for ln
--#

ln := funcattr( ln, "Re", fun(
    (sign(args(1));
    if % = 1 then ln(args(1))
    elif % = -1 then ln(-args(1))
    elif iszero(%) then error("singularity")
    elif domtype(args(1)) = DOM_COMPLEX then
        abs(args(1));
        if domtype(%) = DOM_EXPR then 1/2*ln(%^2) else ln(%) end_if
    else
        ln(abs(args(1)))
    end_if)
) ):

# end of file #
