# $Date: 1995/08/12 16:03:19 $ $Author: frankp $ $Revision: 1.1 $ #

#--
	sin/Re -- the function attribut "Re" for sin
--#

sin := funcattr( sin, "Re", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then return( sin(x) )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sin(r)*cosh(s) )
            end_if
        end_if;
        hold(Re)(sin(x))
    end_proc
):

# end of file #
