# #
# $Date: 1996/09/19 08:42:31 $ $Author: frankp $ $Revision: 1.2 $ #
# #
# frankp, 25.11.1994 #

#--
	rectform::abs  --  the function abs for rectform
--#

domattr(rectform,"abs") := proc(x)
    name rectform::abs;
    local a, b;
begin
    x := rectform::new(x);
    if extop(x,3) = 0 then
        a := extop(x,1);
        b := extop(x,2);
        if domtype(a+I*b) = DOM_COMPLEX
           and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
        then
            rectform::new(abs(a+I*b),extop(x,4))
        elif sign(a+I*b) = 0 or sign(a+I*b) = 1 then
            new(rectform,a+I*b,0,0,extop(x,4))
        elif iszero(a) or iszero(b) then
            new(rectform,abs(a+I*b),0,0,extop(x,4))
        else
            new(rectform,sqrt(normal(a^2+b^2)),0,0,extop(x,4))
        end_if
    else
        rectform::new(0,0,abs(rectform::expr(x)),extop(x,4))
    end_if
end_proc:

# end of file #
