# #
# $Date: 1996/09/19 08:42:33 $ $Author: frankp $ $Revision: 1.2 $ #
# #
# frankp, 25.11.1994 #

#--
	rectform::_plus  --  add elements of domain rectform
--#

domattr(rectform,"_plus") := proc(x,y)
    name rectform::_plus;
    local l1, l2;
begin
    if args(0) > 2 then
        return(
          rectform::_plus(x,rectform::_plus(args(i) $ hold(i) = 2..args(0)))
        )
    end_if;

    if domtype(x) = rectform then l1 := extop(x,4)
    else x := rectform::new(x); l1 := {}
    end_if;
    if domtype(y) = rectform then l2 := extop(y,4)
    else y := rectform::new(y); l2 := {}
    end_if;
    if l1 <> l2 then
        x := rectform::new(x, l1 intersect l2);
        y := rectform::new(y, l1 intersect l2)
    end_if;

    new( rectform,extop(x,1)+extop(y,1),extop(x,2)+extop(y,2),
                  extop(x,3)+extop(y,3),l1 intersect l2
    )
end_proc:

# end of file #
