# $Date: 1997/08/07 13:42:58 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	conjugate/rectform -- the function attribut "rectform" for conjugate
--#

conjugate := funcattr( conjugate, "rectform", proc(x)
        local rl;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2))
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(conjugate)(rectform::expr(x)),rl)
        else
            new(rectform,extop(x,1),-extop(x,2),0,rl)
        end_if
    end_proc
):

# end of file #
