# $Date: 1997/08/07 13:43:00 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	cot/rectform -- the function attribut "rectform" for cot
--#

cot := funcattr( cot, "rectform", proc(x)
        local a, b, t, rl;
    begin
        if args(0) = 2 then
            x:= rectform::new(x,args(2))
        else
            x:= rectform::new(x)
        end_if;
        rl:= extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(cot)(rectform::expr(x)),rl)
        else
            a:= extop(x,1);
            b:= extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
               and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then
                rectform::new(cot(a+I*b))
            elif iszero(b) then
                new(rectform,cot(a),0,0,rl)
            else
                t := sin(a)^2+sinh(b)^2;
                new(rectform,sin(a)*cos(a)/t,-sinh(b)*cosh(b)/t,0,rl)
            end_if
        end_if
    end_proc
):

# end of file #
