# $Date: 1997/08/07 13:43:03 $ $Author: tonner $ $Revision: 1.4 $ #

#--
	sign/rectform -- the function attribut "rectform" for sign
--#

sign := funcattr(sign,"rectform",proc(x)
    local r, i, t, rl;
begin
    if args(0) = 2 then x := rectform::new(x,args(2))
    else x:= rectform::new(x)
    end_if;
    rl:= extop(x,4);
    if extop(x,3) <> 0 then
        new(rectform,0,0,hold(sign)(args(1)),rl)
    elif extop(x,2) = 0 then
        new(rectform,sign(extop(x,1)),0,0,rl)
    else
        r:= extop(x,1); i:= extop(x,2);
        t:= sqrt(r^2+i^2);
        new(rectform,r/t,i/t,0,rl)
    end_if
end_proc):

# end of file #
