# #
# $Date: 1996/06/19 06:21:10 $ $Author: zimmerma $ $Revision: 1.3 $ #
# #
# zimmerma, 14/12/95 #

#--
	stdlib::solve_isalgebraic

	returns FALSE if sys is not an algebraic system with respect 
	to unk, otherwise sys where all equalities a=b have been 
	replaced by a-b and all 0 equations have been deleted.
--#

stdlib::solve_isalgebraic := proc(sys,unk)
local eq,u,newsys;
begin
   newsys:={};
   for eq in sys do
      if type(eq)="_equal" then eq:=op(eq,1)-op(eq,2) end_if;
      eq:=numer(eq);
      for u in unk do
         if not testtype(eq,Type::PolyExpr(u)) then return(FALSE) end_if
      end_for;
      newsys:=newsys union {eq};
   end_for;
   newsys
end_proc:

# end of file #
