#++
primpart -- primitive part of polynomial

primpart(p)
primpart(e [,ind])

p   - polynomial
e   - expression
ind - list of indets
++#

primpart:= fun((
    case args(0)
    of 1 do
	case domtype(args(1))
	of DOM_POLY do
	    if iszero(args(1)) then
		args(1)
    	    elif domtype(op(args(1), 3)) = DOM_DOMAIN then
    	    	mapcoeffs(args(1), domattr(op(args(1), 3), "_divide"), content(args(1)))
    	    else
    	    	multcoeffs(args(1), 1/content(args(1)))
    	    end_if;
	    break;
	of DOM_INT do
	    sign(args(1));
	    break;
	of DOM_RAT do
	    args(1);
	    break;
	of DOM_FAIL do
	    FAIL;
	    break;
	otherwise
	    expr(primpart(poly(args(1))))
	end_case;
    	break;
    of 2 do
    	expr(primpart(poly(args())));
    	break;
    otherwise error("wrong no of args")
    end_case)):

