# mainly used for the reversion of Puiseux series #

revert := proc(x)
begin
   if x::revert<>FAIL then return(x::revert(x)) end_if;
   procname(x)
end_proc:

# to revert strings, code from Ralf Hillebrand, 31 Oct 1996 #
DOM_STRING::revert :=
  proc(str)
    local len, i;
  begin
    len := strlen(str);
    _concat(str[len-i] $ i = 1..len)
  end_proc:

# to revert lists, code from Ralf Hillebrand, 17 Feb 1997 #
DOM_LIST::revert := 
  proc(list)
    local len, i;
  begin
    len := nops(list);
    [ op(list, len-i+1) $ hold(i)=1..len ]
  end_proc:
