# Dirk Mueller, olorien, 28/10/96, v1.0 #

dirac:=funcattr(dirac, "transform::laplace",
  proc(_f, var1, var2) 
    local _a, _g, erg;
  begin
    _g:=op(_f);
    _a:=_g/var1;
    if not has(_a, var1) then
      userinfo(10, "formula from M&P");
      return(1/abs(_a));
    end_if;

    _a:=-(_g-var1);
    if not has(_a, var1) then
      erg:=is(_a>0);
      if erg=TRUE then
        userinfo(10, "formula 1.1 from R&K");
        return(exp(-_a*var2));
      elif erg=FALSE then
        return(0);
      else 
        userinfo(1, "please specify constant "._a);
      end_if;
    end_if;
    FAIL;
  end_proc):


# end of file #
