# paul #
#++
	ifourier(f,y,x) = 1/(2*PI)*int(f*exp(-I*y*x),y=-infinity..infinity)
	                = 1/(2*PI)*fourier(f,y,-x) 
++#
transform::ifourier:= proc(f,y,x)
begin
   # allow overloading #
   if f::ifourier<>FAIL then return(f::ifourier(args())) end_if;
   1/(2*PI)*transform::fourier(f,y,-x)
end_proc:

# end of file #
