
nw_x := proc(u,v)
begin
  2/(1+abs(u+I*v)^2)*u:
end_proc:

nw_y := proc(u,v)
begin
  2/(1+abs(u+I*v)^2)*v:
end_proc:

nw_z := proc(u,v)
begin
  1/(1+abs(u+I*v)^2)*(abs(u+I*v)^2-1)
end_proc:

plot3d(Axes = None,
      [Mode = Surface,
             [hold(nw_x(u,v)),
              hold(nw_y(u,v)),
              hold(nw_z(u,v))],
             u = [-PI, PI], v =[-PI, PI], 
             Grid = [30,30], Style = [HiddenLine, Mesh]]);
