#
  P. Prusinkiewicz and A. Lindenmayer, 
  The Algorithmic Beauty of Plants, Springer Verlag, 1990.

  P. Prusinkiewicz and J. Hanan,
  Lindenmayer Systems, Fractals and Plants, 
  Lecture Notes in Biomathematics 79, S.Levin (Editor),
  Springer Verlag, 1989.
#

p1:=Lsys(25.7, "L", "L"="L[+L]L[-L]L", "L"=line):
Lsys::plot(p1,5): # plot 5th generation #

p2:=Lsys(20, "L", "L"="L[+L]L[-L][L]", "L"=line):
Lsys::plot(p2,5): # plot 5th generation #

p3:=Lsys(22.5, "L", "L"="LL-[-L+L+L]+[+L-L-L]", "L"=line, "R"=line):
Lsys::plot(p3,5): # plot 4th generation #

p4:=Lsys(20, "L", "L"="R[+L]R[-L]+L", "R"="RR", "L"=line, "R"=line):
Lsys::plot(p4,7): # plot 7th generation #

p5:=Lsys(25.7, "L", "L"="R[+L][-L]RL", "R"="RR", "L"=line, "R"=line):
Lsys::plot(p5,7): # plot 7th generation #

p6:=Lsys(22.5, "L", "L"="R-[[L]+L]+R[+RL]-L", "R"="RR", "L"=line, "R"=line):
Lsys::plot(p6,5): # plot 5th generation #
