#ifndef __MCT_secure_string__
#define __MCT_secure_string__

#include <string.h>

class MCLT_SecureString
{
private:
	char	*itsString;
	long	itsAllocated;
	
public:
	MCLT_SecureString();							// Konstruktoren
	MCLT_SecureString(long initialLength);
	MCLT_SecureString(char *srcStrg);
	
	~MCLT_SecureString();							// Destruktor
	
	char	*s_get_string()							{ return( itsString ); }
	void	s_strcpy(char *srcStrg);				// strcpy fuer secure string
	void	s_strcat(char *srcStrg);				// strcat fuer secure string
	void	s_strncat(char *srcStrg, long n );		// strncat fuer secure string

private:
	void	Resize(long newLength );				// Interne Methode zum Vergroessern des
													// internen Stringpuffers
};

#endif
