/*
 * File:        MGR_command.h
 *
 * Inhalt:      Diese Datei enth"alt die Deklarationen der Funktionen, die aus
 *              den Grafikdaten einen Befehlsspointer machen und an das Grafik-
 *              tool schicken. Diese Routinen waren zuvor in MGR_sys_func.c
 *              definiert.
 *
 * Autor:       Gudrun Oevel, Thorsten Schulze
 *
 * Datum:       27.09.1994
 */

#ifndef __MGR_command__
#define __MGR_command__


/*
 * globale Funktionen
 */

void    MGR_calc_sp_command
           (   S_Pointer    *sp_command,
               S_Pointer    sp_graphic
           );

void    MGR_send_sp_command
           ( S_Pointer    sp_command
           );

#endif /* __MGR_command__ */
