/* $Date: 1997/04/15 19:51:54 $  $Author: kg $  $Revision: 1.5 $ */
/*
 * Filename:     MGR_defaults.h
 *
 * Inhalt:       Enth"alt die Definition der Funktionen, zum Behandeln der
 *               Defaults, die sowohl in Kern als auch in VCam
 *               benutzt werden.
 *
 * Autor:        Gudrun Oevel 
 *
 * Datum:        31.08.1993
 */

#ifndef __MGR_defaults__
#define __MGR_defaults__


/*
 * Konstanten
 */

#define  MGRC_VCAM_DEFAULTS_HEADER           "VCam-Default-Values"
#define  MGRC_VCAM_DEFAULTS_HEADER_LENGTH    19L

/*
 * Funktionen
 */



void       MGR_read_default_file
                     (   char             *filename,
                         MGRT_Defaults    *defaults
                     );

void        MGR_get_default_scene(
                       long             dimension,
                       MGRT_Scene       *scene,
                       MGRT_Defaults    *defaults
                      );

void        MGR_get_default_object(
                       long             dimension,
		       long		mode,
                       long             number,
                       MGRT_Object      *actobj,
                       MGRT_Defaults    *actdef
                      );

void MGR_init_defaults(MGRT_Defaults *def);

#endif /* __MGR_defaults__ */
