/* $Date: 1995/07/21 09:34:31 $  $Author: andi $  $Revision: 1.2 $ */

/**************************************************************************/
/* FILE:             MHI_history.h                                        */
/* Autor:            Oliver Kluge                                         */
/* Erstellt:         17/07/91                                             */
/* Letzte Aenderung: 10/09/93                                             */
/**************************************************************************/

#ifndef __MHI_history__
#define __MHI_history__


/* void MHI_write( S_Pointer value ) */

#define MHI_write(value)                          \
	{ if (MMMequal(GLOBAL_READ(MUPV_LAST_HISTORY),value))  \
	     { MMMfree(GLOBAL_READ(MUPV_LAST_HISTORY));        \
	       GLOBAL_WRITE( MUPV_LAST_HISTORY, MMMNULL); }     \
          else                                         \
	       if (MHIV_HISTORY && !MUPV_no_history)   \
                   MHI_write_(value);                  \
	}

/* S_Pointer MHI_read( long num ) */

#define MHI_read(num) \
	(num > 0L && MHIV_HISTORY ? MHI_read_(num) : MMMNULL)

void MHI_init( VOID );
void MHI_exit( VOID );
void MHI_free( VOID );
void MHI_reset( VOID );
void MHI_reset_interactiv( VOID );
void MHI_write_( S_Pointer s );
void MHI_history( long num );
void MHI_change( long new_size_top, long new_size_proc );
void MHI_increase( long neww );
void MHI_reorganize( long new_size, long old_size );

S_Pointer MHI_read_( long num );
void MHI_reset(VOID);

#endif /* __MHI_history__ */
