/*************************************************************************
**                         MNS_namespace.h                              **
** In diesem File werden die Routinen definiert, mit denen Namespaces   **
** benutzt werden k"onnen.                                              **
** Autor            :  Holger Naundorf                                  **
** Erstellungsdatum :  04/09/95                                         **
** Letzte Aenderung :  27/09/95                                         **
**                                                                      **
** 'namespace' scheint fuer den g++ ein reservierter Bezeichner zu sein **
** und darf daher nicht verwendet werden (==> 'namspace').              **
*************************************************************************/

#ifndef __MNS_namespace__
#define __MNS_namespace__

extern S_Pointer MNSV_global_namespace ;
extern S_Pointer MNSV_namespacelist ;

void      MNS_init(VOID);
void      MNS_exit(VOID);

S_Pointer MNS_new_ident      (S_Pointer name, S_Pointer namspace) ;
MUPbool   MNS_ident_exists   (S_Pointer name, S_Pointer namspace) ;
S_Pointer MNS_new_namespace  (VOID) ;
S_Pointer MNS_index          (S_Pointer namspace, S_Pointer name) ;
S_Pointer MNS_ident_name     (S_Pointer ident) ;
S_Pointer MNS_ident_namespace(S_Pointer ident) ;
S_Pointer MNS_ident2string   (S_Pointer ident) ;

#ifdef DEADCODE
S_Pointer MNS_eval_new_ident(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MNS_eval_new_namespace(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
#endif

#endif /* __MNS_namespace__ */
