/* $Date: 1997/07/02 08:18:28 $  $Author: chh $  $Revision: 1.5 $ */

/**************************************************************************/
/*                           MPL_parallel.h                               */
/* Autor:            Holger Naundorf                                      */
/* Erstellt:         12/03/91                                             */
/* Letzte Aenderung: 11/06/93                                             */
/**************************************************************************/

#ifndef __MPL_parallel__
#define __MPL_parallel__


void      MPL_init               (VOID) ;
void      MPL_exit               (VOID) ;
S_Pointer MPL_create_queue       (VOID) ;
S_Pointer MPL_read_queue         (S_Pointer queue) ;
S_Pointer MPL_read_queue_sleep   (S_Pointer queue) ;
void      MPL_write_queue        (S_Pointer queue, S_Pointer value) ;
S_Pointer MPL_read_of_queue      (S_Pointer ass, S_Pointer mem) ;
S_Pointer MPL_read_of_queue_sleep(S_Pointer ass, S_Pointer mem) ;
void      MPL_write_to_queue     (S_Pointer ass, S_Pointer mem, S_Pointer value) ;
S_Pointer MPL_eval_readqueue     (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_writequeue    (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_readpipe      (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_writepipe     (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_global        (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_topology      (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;

/********************** Semaphoren ***********************/

/**************************************************************************/
/* Gr"osse der Semaphore-Liste 'MSYV_sem_list'.                           */
/**************************************************************************/
#define MPLC_sem_list_size 10L   /* Muss > 0 sein. */

void 	MPL_init_semaphores	(VOID);
void 	MPL_free_semaphores	(VOID);
void 	MPL_reset_semaphores	(VOID);

S_Pointer MPL_eval_init_sem	(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_semP    	(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_semV         (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;

S_Pointer MPL_eval_lock         (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;
S_Pointer MPL_eval_unlock       (S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;


#endif /* __MPL_parallel__ */
