/**************************************************************************
**                             MPM_match.h                               **
** In diesem File werden Funktionen defniert, mit denen Pattern-Matching **
** m"oglich ist.                                                         **
** Erstellungsdatum  : 09/07/93                                          **
** Letzte Aenderung  : 09/07/93                                          **
** Autor             : Holger Naundorf                                   **
**************************************************************************/

#ifndef __MPM_match__
#define __MPM_match__


/**************************************************************************
** long MPM_contains_free_variable(S_Pointer v)                          **
** Diese Funktion testet, ob v eine freie Variable f"urs Matchen         **
** beinhaltet. Dies wird sp"ater in der Signatur codiert sein. Im        **
** Moment behauptet die Funktion immer, da\3 noch eine freie Variable    **
** in dem Datum ist.                                                     **
**************************************************************************/
#define MPM_contains_free_variable(v) _true_


/**************************************************************************
** Deklaration der Schnittstellenfunktionen                              **
**************************************************************************/
void MPM_init(VOID) ;
void MPM_exit(VOID) ;
S_Pointer MPM_eval_match(S_Pointer s, long prev_func, long eval_type, S_Pointer exec) ;

#endif /* __MPM_match__ */

