/* $Date: 1997/08/21 07:17:31 $  $Author: kg $  $Revision: 1.3 $ */

/**************************************************************************/
/* FILE:             MTA_table.h                                          */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         07/11/91                                             */
/* Letzte Aenderung: 02/06/93                                             */
/**************************************************************************/

#ifndef __MTA_table__
#define __MTA_table__


S_Pointer MTA_eval_table_call(	S_Pointer	 s,
				long		 prev_func,
				long		 eval_type,
				S_Pointer	 exec );
S_Pointer MTA_new_table ( 	long type );
long      MTA_read_table (	S_Pointer	 table, 
				S_Pointer	 args,
				long		 ignore, 
				S_Pointer	*result );
void      MTA_write_table (	S_Pointer	*table, 
				S_Pointer	 args,
				long		 ignore, 
				S_Pointer	 value );
MUPbool   MTA_get_name (	S_Pointer	 table,
				S_Pointer	*name );
void      MTA_set_name (	S_Pointer	 table,
				S_Pointer	 name );


/*** Zur Steuerung des Lesen/Schreiben von Tabelleneintraegen *************/

#define MTAC_ARG      0L
#define MTAC_FUNC     1L
#define MTAC_INDEX    2L 
#define MTAC_LIST     3L
    

#endif /* __MTA_table__ */
