#ifndef __GENPARI__
#define __GENPARI__

#ifndef MuPAD
#define MuPAD
#endif

#include <setjmp.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <types.h>
#include <stdlib.h>
#include <stdarg.h>

#ifndef LONG_IS_32BIT
#define LONG_IS_32BIT
#endif

#ifndef ULONG_NOT_DEFINED
#define ULONG_NOT_DEFINED
#endif

#ifndef macintosh
#define macintosh
#endif

#ifdef MuPAD
#   define MIOPprint_string(s) MIO_print_string(s)
#   define MIOPprint_char(c)   MIO_print_char(c)
#   define MEVPset_error(n,s)  MEV_set_error(n,s)

#endif

#include "gencom.h"
#include "erreurs.h"

#if __MWERKS__
#   include <SIOUX.h>
#   include <Memory.h>

#   define malloc(x)    NewPtr(x)
#   define calloc(x, y) NewPtrClear((x)*(y))
#   define free(x)      DisposePtr((Ptr)(x))

    void *macrealloc(void *p, size_t olds, size_t news);

#   pragma pointers_in_D0

#endif /*** __MWERKS__ ***/

#if powerc
#   include "genport.h"
#else
#   include "gen68k.h"
#endif

#ifdef __cplusplus
#   include "mpin.h"
#else
#   include "mpansi.h"
#endif

#if __MWERKS__
#   pragma pointers_in_A0
#endif

#endif /*** __GENPARI__ ***/
