#ifndef __GEN_PARIOTHER__
#define __GEN_PARIOTHER__

#include        <stdlib.h>	/* malloc, free, atoi */
#ifndef ULTRIX
#include        <stdarg.h>
#endif

/*** Dirty trick fuer HP: In den C++ inlcude gibt es dort ***/
/*** einen Fehler, wodurch die Variable  __EH_JMPBUF_TEMP ***/
/*** in header definiert  (statt deklariert) wird und der ***/
/*** somit nich gelinkt werden kann.  Darum wird hier das ***/
/*** ANSI-C include eingebunden.                          ***/
#ifdef HP
#include        "/usr/include/setjmp.h"
#else
#include        <setjmp.h>
#endif

#include        <signal.h>
#include        <stdio.h>
/* #include        <string.h> */
#include        <math.h>
#include        <ctype.h>

#ifdef MSDOS
#   include <time.h>
#   include <stdlib.h>
#else
#   include        <sys/time.h>
#   include        <sys/file.h>
#   include        <sys/resource.h>
#endif

#include "gencom.h"
#include "erreurs.h"
#include "genport.h"
#ifdef __cplusplus
#include "mpin.h"
#else
#include "mpansi.h"
#endif


#define MIOPprint_string(s) MIO_print_string(s)
#define MIOPprint_char(c)   MIO_print_char(c)
#define MEVPset_error(n,s)  MEV_set_error(n,s)

#if (defined MMMDOWNMALLOC && !defined MMMDMuPAD)

/*** Eigene Speicherverwaltung fuer den parallelen Fall ***/
/*** Dabei muessen auch MAMMUT Typen eingebunden werden ***/

#ifdef SOLARIS
   typedef struct {
      long a ;
      long b ;
      long c ;
      long d ;
      long e ;
      long f ;
      long g ;
      long h ;
   } MMMTlock ;
#endif
#ifdef sequent
   typedef slock_t MMMTlock ;
#endif

typedef struct MMMSheapMemList
{
   struct MMMSheapMemList *next ;
   long                    size ;
} MMMTheapMemList ;
 
typedef struct
{
   MMMTheapMemList *MemList ;
   MMMTlock        *Lock ;
} MMMTheap ;
 
void *MMMFown_malloc(long size, MMMTheap *heap) ;
void MMMFown_free(void *mem, MMMTheap *heap) ;

extern MMMTheap MMMVheap ;
 
#  define malloc(n) MMMFown_malloc(n, &MMMVheap)
#  define MMMEfree(p) MMMFown_free(p, &MMMVheap)

#endif /*MMMDOWNMALLOC*/

#endif /* __GEN_PARIOTHER__ */
